#
# spec file for package xorg-x11 (Version 6.9.0)
#
# Copyright (c) 2006 SUSE LINUX Products GmbH, Nuernberg, Germany.
# This file and all modifications and additions to the pristine
# package are under the same license as the package itself.
#
# Please submit bugfixes or comments via http://bugs.opensuse.org/
#

# norootforbuild
# usedforbuild    aaa_base acl attr audit-libs autoconf automake bash bind-libs bind-utils binutils bison bzip2 coreutils cpio cpp cracklib cvs cyrus-sasl db desktop-translations diffutils e2fsprogs ed expat file filesystem fillup findutils flex fontconfig fontconfig-devel freetype2 freetype2-devel gawk gcc gcc-c++ gdbm gdbm-devel gettext gettext-devel glibc glibc-devel glibc-locale gpm grep groff gzip info insserv klogd less libacl libattr libcom_err libgcc libjpeg libjpeg-devel libnscd libpng libpng-devel libstdc++ libstdc++-devel libtool libusb libxcrypt libzio m4 make man mktemp module-init-tools ncurses ncurses-devel net-tools netcfg openldap2-client openssl pam pam-devel pam-modules patch perl permissions popt procinfo procps psmisc pwdutils rcs readline resmgr rpm sed strace sysvinit tar tcpd texinfo timezone unzip update-desktop-files utempter util-linux vim zlib zlib-devel

Name:           xorg-x11
BuildRequires:  ed fontconfig-devel freetype2-devel gcc-c++ libjpeg-devel libpng-devel libusb pam-devel resmgr update-desktop-files utempter
URL:            http://xorg.freedesktop.org/
%define SHARED_FREETYPE_MODULE 1
%define BITMAP_ENCODINGS_ON_THE_FLY 0
%define USE_EXTERNAL_XKB_FILES 1
%define USE_EXTERNAL_MESA 1
%define USE_EXTERNAL_DRIVERS 1
%if %suse_version > 1000
%define FC_232 0
%else
%define FC_232 1
%define FC_FILE fonts.cache-1
%endif
License:        Other License(s), see package, X11/MIT
Group:          System/X11/Utilities
Obsoletes:      XFree86 XFree86-Xprt XFree86-driver-options
%if %suse_version > 920
Provides:       XFree86 XFree86-Xprt XFree86-driver-options
%else
Provides:       XFree86 xf86
%endif
PreReq:         /bin/cp /bin/ln /bin/ls /bin/mkdir /bin/mv /bin/rm /usr/bin/grep /usr/bin/sed %insserv_prereq %fillup_prereq permissions
%if %USE_EXTERNAL_XKB_FILES
Requires:       x11-tools resmgr /lib/cpp xkeyboard-config
%else
Requires:       x11-tools resmgr /lib/cpp
%endif
Autoreqprov:    on
Version:        6.9.0
Release:        50.14
Summary:        The basic X Window System package
Source:         xorg-6.9.0.tar.bz2
Source1:        xdm.tar.gz
Source3:        CardModules.addon
Source19:       HALlib-4.2.tar.gz 
Source21:       suse-addons.tar.bz2
Source23:       FILES
Source26:       xf4vnc-20050720.tar.bz2
Source34:       mkallcomposecaches.sh
Source35:       README.updates
Patch:          ps_suse.diff
Patch1:         pu_fixes.diff
Patch4:         ps_libvncauth-fpic.diff
Patch7:         pu_macintosh-kb.diff
Patch10:        ps_vnc.diff
Patch13:        ps_vncviewer.diff
# New gb18030 patches from SUN
Patch24:        p_XFree86-4.2.0-i18n-xlib-20020322.diff
Patch52:        ps_mkfontdir.diff
Patch56:        ps_libXft.diff
Patch62:        p_xft_cjk.diff
Patch111:       p_fixes-cvs.diff
Patch210:       p_compose-cache.diff
Patch228:       p_trident.diff
Patch232:       p_xim_spot.diff
Patch233:       p_pended_events.diff
Patch237:       p_xlc-locale.diff
Patch238:       p_sdk.diff
Patch276:       p_xlib-threadsafe.diff
Patch280:       p_freetype-crashfix.diff
Patch282:       p_new-locales.diff
Patch283:       p_xauth.diff
Patch287:       p_sr_CS-locales.diff
Patch288:       p_sr_CS-compose.diff
Patch292:       ps_nv.diff
Patch295:       p_enable-via-on-AMD64.diff
Patch296:       p_kbd.diff
Patch297:       p_i810-refresh.diff
Patch308:       p_mouse_misc.diff
Patch315:       p_bug4243.diff  
Patch316:       p_bug4247.diff
Patch324:       p_bugzilla-117193-luit-sometimes-hangs.diff
Patch325:       p_64bit-clean.diff
Patch326:       p_fbdev.diff
Patch327:       p_gcc410.diff
Patch328:       ps_disable-drivers.diff
Patch330:       ps_glxproto.diff
Patch332:       ps_acpi.diff
Patch333:       p_vga-crashfix.diff
Patch334:       p_pci-domain.diff
Patch335:       p_xft_register.diff
Patch336:       p_xorg_rom_read.diff
Patch337:       ps_showopts.diff
Patch338:       p_mouse_wheelemu_fix_x-5071.diff
Patch339:       p_evdev_abs.diff
Patch340:       p_ppc64.diff
Patch341:       p_khmer-compose.diff
Patch342:       p_khmer-locale.diff
Patch343:       p_xf86Mode.diff
Patch344:       pc_trident.diff
Patch345:       p_lnx_Kbd.diff
Patch346:       ps_parser.diff
Patch347:       p_xorg-compositefastpath-4320.diff
Patch348:       p_xrdb.diff
Patch349:       p_xorg_acpi.diff
Patch350:       p_pci-ia64.diff
Patch351:       p_twm_sig11.diff
Patch352:       p_xkills_wrong_client.diff
Patch353:       p_xmodmap.diff
Patch354:       p_bug156974.diff
Patch355:       p_zx2_pcie.diff
Patch356:       p_bug159532.diff
Patch357:       p_pci-ce-x.diff
Patch358:       p_setxkbmap.diff
Patch359:       p_mappciBIOS_complete.diff
Patch360:       p_x86_renderinit.diff
Patch361:       p_default-module-path.diff
Patch362:       p_mouse-wheel-multibit.diff
Patch363:       p_xrender-mitri.diff
Patch364:       p_pci-legacy-mmap.diff
Patch365:       p_xorg-fbcompose-radek2.diff
Patch366:       pc_xf86-pci.diff
Patch367:       p_xlib_skip_ext_env.diff
Patch368:       p_xnest-ignore-getimage-errors.diff
Patch400:       p_bug96328.diff
BuildRoot:      %{_tmppath}/%{name}-%{version}-build

%description
This package contains X.Org and some other programs from the
contrib-directory.



Authors:
--------
    Egbert Eich
    Keith Packard
    Roland Mainz
    Alan Coopersmith
    Russ Blaine
    Alexander Gottwald
    Alan Hourihane
    Chisato Yamauchi
    Eric Anholt
    Nolan Leake
    Stefan Dirsch
    Rik Faith
    Daniel Berrange
    Matthieu Herrb
    John Heasley
    Ryan Underwood
    Alex Deucher
    Ty Sarna
    Torrey T Lyons Darwin
    Stuart Kreitman
    Kevin E. Martin
    Greg Parker
    John Harper
    Adam Jackson
    Peter Kunzman
    Aaron Plattner
    Chisato Yamauchi
    Michel Daenzer
    Kristian Hgsberg
    Sren Sandmann
    Owen Taylor
    Mike A. Harris
    Ivan Kokshaysky
    Bryan Stine
    Guy Martin
    Paul Anderson
    Yu Shao
    David Dawes
    Harold L. Hunt II
    Andreas Luik
    Travis Tilley
    Ryan Lortie
    Ryan Breen
    Deron Johnson
    Ronny Vindenes
    Jim Gettys

%debug_package
%package fonts-75dpi
Summary:        75dpi Bitmap Fonts
Group:          System/X11/Utilities
Provides:       XFree86-fonts-75dpi
Obsoletes:      XFree86-fonts-75dpi
Autoreqprov:    on

%description fonts-75dpi
This package contains 75dpi Bitmap Fonts for the X Window System.



Authors:
--------
    Egbert Eich
    Keith Packard
    Roland Mainz
    Alan Coopersmith
    Russ Blaine
    Alexander Gottwald
    Alan Hourihane
    Chisato Yamauchi
    Eric Anholt
    Nolan Leake
    Stefan Dirsch
    Rik Faith
    Daniel Berrange
    Matthieu Herrb
    John Heasley
    Ryan Underwood
    Alex Deucher
    Ty Sarna
    Torrey T Lyons Darwin
    Stuart Kreitman
    Kevin E. Martin
    Greg Parker
    John Harper
    Adam Jackson
    Peter Kunzman
    Aaron Plattner
    Chisato Yamauchi
    Michel Daenzer
    Kristian Hgsberg
    Sren Sandmann
    Owen Taylor
    Mike A. Harris
    Ivan Kokshaysky
    Bryan Stine
    Guy Martin
    Paul Anderson
    Yu Shao
    David Dawes
    Harold L. Hunt II
    Andreas Luik
    Travis Tilley
    Ryan Lortie
    Ryan Breen
    Deron Johnson
    Ronny Vindenes
    Jim Gettys

%package doc 
Summary:        HTML documentation for X11
Group:          System/X11/Utilities
Provides:       XFree86-doc  
Obsoletes:      XFree86-doc
Autoreqprov:    on

%description doc 
X11 documentation in HTML format.



Authors:
--------
    Egbert Eich
    Keith Packard
    Roland Mainz
    Alan Coopersmith
    Russ Blaine
    Alexander Gottwald
    Alan Hourihane
    Chisato Yamauchi
    Eric Anholt
    Nolan Leake
    Stefan Dirsch
    Rik Faith
    Daniel Berrange
    Matthieu Herrb
    John Heasley
    Ryan Underwood
    Alex Deucher
    Ty Sarna
    Torrey T Lyons Darwin
    Stuart Kreitman
    Kevin E. Martin
    Greg Parker
    John Harper
    Adam Jackson
    Peter Kunzman
    Aaron Plattner
    Chisato Yamauchi
    Michel Daenzer
    Kristian Hgsberg
    Sren Sandmann
    Owen Taylor
    Mike A. Harris
    Ivan Kokshaysky
    Bryan Stine
    Guy Martin
    Paul Anderson
    Yu Shao
    David Dawes
    Harold L. Hunt II
    Andreas Luik
    Travis Tilley
    Ryan Lortie
    Ryan Breen
    Deron Johnson
    Ronny Vindenes
    Jim Gettys

%package server
Summary:        X Window System modularized server
Group:          System/X11/Utilities
PreReq:         xorg-x11-server-glx /bin/rm /bin/ln /usr/bin/readlink /bin/mv /bin/cp /bin/cat /usr/bin/tr
Requires:       xorg-x11
Provides:       XFree86-server
Obsoletes:      XFree86-server
Autoreqprov:    on

%description server
This is the modularized Xserver for the X Window System.



Authors:
--------
    Egbert Eich
    Keith Packard
    Roland Mainz
    Alan Coopersmith
    Russ Blaine
    Alexander Gottwald
    Alan Hourihane
    Chisato Yamauchi
    Eric Anholt
    Nolan Leake
    Stefan Dirsch
    Rik Faith
    Daniel Berrange
    Matthieu Herrb
    John Heasley
    Ryan Underwood
    Alex Deucher
    Ty Sarna
    Torrey T Lyons Darwin
    Stuart Kreitman
    Kevin E. Martin
    Greg Parker
    John Harper
    Adam Jackson
    Peter Kunzman
    Aaron Plattner
    Chisato Yamauchi
    Michel Daenzer
    Kristian Hgsberg
    Sren Sandmann
    Owen Taylor
    Mike A. Harris
    Ivan Kokshaysky
    Bryan Stine
    Guy Martin
    Paul Anderson
    Yu Shao
    David Dawes
    Harold L. Hunt II
    Andreas Luik
    Travis Tilley
    Ryan Lortie
    Ryan Breen
    Deron Johnson
    Ronny Vindenes
    Jim Gettys

%package server-glx
Summary:        GLX extension and nvidia dummy driver modules
Group:          System/X11/Utilities
Provides:       XFree86-server:/usr/X11R6/lib/modules/extensions/libglx.a XFree86-server-glx
Obsoletes:      XFree86-server-glx
Autoreqprov:    on

%description server-glx
This is the GLX extension and the nvidia dummy driver modules for the
Xserver.



Authors:
--------
    Egbert Eich
    Keith Packard
    Roland Mainz
    Alan Coopersmith
    Russ Blaine
    Alexander Gottwald
    Alan Hourihane
    Chisato Yamauchi
    Eric Anholt
    Nolan Leake
    Stefan Dirsch
    Rik Faith
    Daniel Berrange
    Matthieu Herrb
    John Heasley
    Ryan Underwood
    Alex Deucher
    Ty Sarna
    Torrey T Lyons Darwin
    Stuart Kreitman
    Kevin E. Martin
    Greg Parker
    John Harper
    Adam Jackson
    Peter Kunzman
    Aaron Plattner
    Chisato Yamauchi
    Michel Daenzer
    Kristian Hgsberg
    Sren Sandmann
    Owen Taylor
    Mike A. Harris
    Ivan Kokshaysky
    Bryan Stine
    Guy Martin
    Paul Anderson
    Yu Shao
    David Dawes
    Harold L. Hunt II
    Andreas Luik
    Travis Tilley
    Ryan Lortie
    Ryan Breen
    Deron Johnson
    Ronny Vindenes
    Jim Gettys

%package libs
Summary:        X Window System shared libraries
Group:          System/X11/Utilities
%if %suse_version > 920
Provides:       XFree86-compat-libs XFree86-libs
%else
Provides:       XFree86-compat-libs XFree86-libs xshared
%endif
Obsoletes:      XFree86-compat-libs XFree86-libs
Autoreqprov:    on

%description libs
Since some programs were linked with the X Window System libraries, but
do work on a text console as well (emacs for example), we have put the
X Window System dynamic libraries into an extra package so that you can
use these programs without installing the entire X Window System.



Authors:
--------
    Egbert Eich
    Keith Packard
    Roland Mainz
    Alan Coopersmith
    Russ Blaine
    Alexander Gottwald
    Alan Hourihane
    Chisato Yamauchi
    Eric Anholt
    Nolan Leake
    Stefan Dirsch
    Rik Faith
    Daniel Berrange
    Matthieu Herrb
    John Heasley
    Ryan Underwood
    Alex Deucher
    Ty Sarna
    Torrey T Lyons Darwin
    Stuart Kreitman
    Kevin E. Martin
    Greg Parker
    John Harper
    Adam Jackson
    Peter Kunzman
    Aaron Plattner
    Chisato Yamauchi
    Michel Daenzer
    Kristian Hgsberg
    Sren Sandmann
    Owen Taylor
    Mike A. Harris
    Ivan Kokshaysky
    Bryan Stine
    Guy Martin
    Paul Anderson
    Yu Shao
    David Dawes
    Harold L. Hunt II
    Andreas Luik
    Travis Tilley
    Ryan Lortie
    Ryan Breen
    Deron Johnson
    Ronny Vindenes
    Jim Gettys

%if !%{USE_EXTERNAL_MESA}
%package Mesa
Summary:        Mesa Libraries
Group:          System/Libraries
Provides:       mesa3dfx mesasoft mesaglu XFree86-GLX mesa XFree86-Mesa libMesaGL.so.3 libMesaGLU.so.3 
Obsoletes:      mesa3dfx mesasoft mesaglu XFree86-GLX mesa XFree86-Mesa
Autoreqprov:    on

%description Mesa
The runtime environment (libGL/libGLU) required for running OpenGL
programs.



Authors:
--------
    Egbert Eich
    Keith Packard
    Roland Mainz
    Alan Coopersmith
    Russ Blaine
    Alexander Gottwald
    Alan Hourihane
    Chisato Yamauchi
    Eric Anholt
    Nolan Leake
    Stefan Dirsch
    Rik Faith
    Daniel Berrange
    Matthieu Herrb
    John Heasley
    Ryan Underwood
    Alex Deucher
    Ty Sarna
    Torrey T Lyons Darwin
    Stuart Kreitman
    Kevin E. Martin
    Greg Parker
    John Harper
    Adam Jackson
    Peter Kunzman
    Aaron Plattner
    Chisato Yamauchi
    Michel Daenzer
    Kristian Hgsberg
    Sren Sandmann
    Owen Taylor
    Mike A. Harris
    Ivan Kokshaysky
    Bryan Stine
    Guy Martin
    Paul Anderson
    Yu Shao
    David Dawes
    Harold L. Hunt II
    Andreas Luik
    Travis Tilley
    Ryan Lortie
    Ryan Breen
    Deron Johnson
    Ronny Vindenes
    Jim Gettys

%endif
%package man
Summary:        On-line manuals for X11
Group:          System/X11/Utilities
Provides:       XFree86-man
Obsoletes:      XFree86-man
Autoreqprov:    on

%description man
The manual pages for programs that come with the X Window System\tm.



Authors:
--------
    Egbert Eich
    Keith Packard
    Roland Mainz
    Alan Coopersmith
    Russ Blaine
    Alexander Gottwald
    Alan Hourihane
    Chisato Yamauchi
    Eric Anholt
    Nolan Leake
    Stefan Dirsch
    Rik Faith
    Daniel Berrange
    Matthieu Herrb
    John Heasley
    Ryan Underwood
    Alex Deucher
    Ty Sarna
    Torrey T Lyons Darwin
    Stuart Kreitman
    Kevin E. Martin
    Greg Parker
    John Harper
    Adam Jackson
    Peter Kunzman
    Aaron Plattner
    Chisato Yamauchi
    Michel Daenzer
    Kristian Hgsberg
    Sren Sandmann
    Owen Taylor
    Mike A. Harris
    Ivan Kokshaysky
    Bryan Stine
    Guy Martin
    Paul Anderson
    Yu Shao
    David Dawes
    Harold L. Hunt II
    Andreas Luik
    Travis Tilley
    Ryan Lortie
    Ryan Breen
    Deron Johnson
    Ronny Vindenes
    Jim Gettys

%package Xnest
Summary:        Hardware independent Xserver Xnest
Group:          System/X11/Utilities
Provides:       XFree86-Xnest
Obsoletes:      XFree86-Xnest
Autoreqprov:    on

%description Xnest
Xnest -- a nested X server.  Xnest is a client of the real server which
manages windows and graphics requests on its behalf.  Xnest is a server
to its own clients.  Xnest manages windows and graphics requests on
their behalf.



Authors:
--------
    Egbert Eich
    Keith Packard
    Roland Mainz
    Alan Coopersmith
    Russ Blaine
    Alexander Gottwald
    Alan Hourihane
    Chisato Yamauchi
    Eric Anholt
    Nolan Leake
    Stefan Dirsch
    Rik Faith
    Daniel Berrange
    Matthieu Herrb
    John Heasley
    Ryan Underwood
    Alex Deucher
    Ty Sarna
    Torrey T Lyons Darwin
    Stuart Kreitman
    Kevin E. Martin
    Greg Parker
    John Harper
    Adam Jackson
    Peter Kunzman
    Aaron Plattner
    Chisato Yamauchi
    Michel Daenzer
    Kristian Hgsberg
    Sren Sandmann
    Owen Taylor
    Mike A. Harris
    Ivan Kokshaysky
    Bryan Stine
    Guy Martin
    Paul Anderson
    Yu Shao
    David Dawes
    Harold L. Hunt II
    Andreas Luik
    Travis Tilley
    Ryan Lortie
    Ryan Breen
    Deron Johnson
    Ronny Vindenes
    Jim Gettys

%package Xvfb
Summary:        Hardware independent Xserver Xvfb
Group:          System/X11/Utilities
Provides:       XFree86-Xvfb
Obsoletes:      XFree86-Xvfb
Autoreqprov:    on

%description Xvfb
Xvfb -- a virtual framebuffer X server. Xvfb is an X server that can
run on machines with no display hardware and no physical input devices.
 It emulates a dumb framebuffer using virtual memory.



Authors:
--------
    Egbert Eich
    Keith Packard
    Roland Mainz
    Alan Coopersmith
    Russ Blaine
    Alexander Gottwald
    Alan Hourihane
    Chisato Yamauchi
    Eric Anholt
    Nolan Leake
    Stefan Dirsch
    Rik Faith
    Daniel Berrange
    Matthieu Herrb
    John Heasley
    Ryan Underwood
    Alex Deucher
    Ty Sarna
    Torrey T Lyons Darwin
    Stuart Kreitman
    Kevin E. Martin
    Greg Parker
    John Harper
    Adam Jackson
    Peter Kunzman
    Aaron Plattner
    Chisato Yamauchi
    Michel Daenzer
    Kristian Hgsberg
    Sren Sandmann
    Owen Taylor
    Mike A. Harris
    Ivan Kokshaysky
    Bryan Stine
    Guy Martin
    Paul Anderson
    Yu Shao
    David Dawes
    Harold L. Hunt II
    Andreas Luik
    Travis Tilley
    Ryan Lortie
    Ryan Breen
    Deron Johnson
    Ronny Vindenes
    Jim Gettys

%package Xvnc
Summary:        VNC Server for the X Window System
Group:          System/X11/Utilities
Provides:       vnc:/usr/X11R6/bin/Xvfb XFree86-Xvnc
Obsoletes:      XFree86-Xvnc
%ifarch ia64
Provides:       vnc-x86
Obsoletes:      vnc-x86
%endif
Autoreqprov:    on

%description Xvnc
An X Window System server for Virtual Network Computing (VNC).



Authors:
--------
    Egbert Eich
    Keith Packard
    Roland Mainz
    Alan Coopersmith
    Russ Blaine
    Alexander Gottwald
    Alan Hourihane
    Chisato Yamauchi
    Eric Anholt
    Nolan Leake
    Stefan Dirsch
    Rik Faith
    Daniel Berrange
    Matthieu Herrb
    John Heasley
    Ryan Underwood
    Alex Deucher
    Ty Sarna
    Torrey T Lyons Darwin
    Stuart Kreitman
    Kevin E. Martin
    Greg Parker
    John Harper
    Adam Jackson
    Peter Kunzman
    Aaron Plattner
    Chisato Yamauchi
    Michel Daenzer
    Kristian Hgsberg
    Sren Sandmann
    Owen Taylor
    Mike A. Harris
    Ivan Kokshaysky
    Bryan Stine
    Guy Martin
    Paul Anderson
    Yu Shao
    David Dawes
    Harold L. Hunt II
    Andreas Luik
    Travis Tilley
    Ryan Lortie
    Ryan Breen
    Deron Johnson
    Ronny Vindenes
    Jim Gettys

%package devel
Summary:        Include Files and Libraries mandatory for Development
Group:          System/X11/Utilities
Requires:       fontconfig-devel xorg-x11-libs
%if %suse_version > 920
Provides:       XFree86-devel
%else
Provides:       XFree86-devel xdevel
%endif
Obsoletes:      XFree86-devel
Autoreqprov:    on

%description devel
This package contains all necessary include files and libraries needed
to develop applications that require these.



Authors:
--------
    Egbert Eich
    Keith Packard
    Roland Mainz
    Alan Coopersmith
    Russ Blaine
    Alexander Gottwald
    Alan Hourihane
    Chisato Yamauchi
    Eric Anholt
    Nolan Leake
    Stefan Dirsch
    Rik Faith
    Daniel Berrange
    Matthieu Herrb
    John Heasley
    Ryan Underwood
    Alex Deucher
    Ty Sarna
    Torrey T Lyons Darwin
    Stuart Kreitman
    Kevin E. Martin
    Greg Parker
    John Harper
    Adam Jackson
    Peter Kunzman
    Aaron Plattner
    Chisato Yamauchi
    Michel Daenzer
    Kristian Hgsberg
    Sren Sandmann
    Owen Taylor
    Mike A. Harris
    Ivan Kokshaysky
    Bryan Stine
    Guy Martin
    Paul Anderson
    Yu Shao
    David Dawes
    Harold L. Hunt II
    Andreas Luik
    Travis Tilley
    Ryan Lortie
    Ryan Breen
    Deron Johnson
    Ronny Vindenes
    Jim Gettys

%if !%{USE_EXTERNAL_MESA}
%package Mesa-devel
Summary:        Include Files and Libraries mandatory for Development
Group:          Development/Libraries/X11
Requires:       xorg-x11-devel xorg-x11-Mesa
Provides:       mesa-devel mesaglu-devel XFree86-GLX-devel XFree86-Mesa-devel
Obsoletes:      mesa-devel mesaglu-devel XFree86-GLX-devel XFree86-Mesa-devel
Autoreqprov:    on

%description Mesa-devel
This package contains all necessary include files and libraries needed
to develop applications that require these.



Authors:
--------
    Egbert Eich
    Keith Packard
    Roland Mainz
    Alan Coopersmith
    Russ Blaine
    Alexander Gottwald
    Alan Hourihane
    Chisato Yamauchi
    Eric Anholt
    Nolan Leake
    Stefan Dirsch
    Rik Faith
    Daniel Berrange
    Matthieu Herrb
    John Heasley
    Ryan Underwood
    Alex Deucher
    Ty Sarna
    Torrey T Lyons Darwin
    Stuart Kreitman
    Kevin E. Martin
    Greg Parker
    John Harper
    Adam Jackson
    Peter Kunzman
    Aaron Plattner
    Chisato Yamauchi
    Michel Daenzer
    Kristian Hgsberg
    Sren Sandmann
    Owen Taylor
    Mike A. Harris
    Ivan Kokshaysky
    Bryan Stine
    Guy Martin
    Paul Anderson
    Yu Shao
    David Dawes
    Harold L. Hunt II
    Andreas Luik
    Travis Tilley
    Ryan Lortie
    Ryan Breen
    Deron Johnson
    Ronny Vindenes
    Jim Gettys

%package Mesa-devel-static
Summary:        Static GL library - Usually not required at all
Group:          Development/Libraries/X11
Requires:       xorg-x11-Mesa-devel
Autoreqprov:    on

%description Mesa-devel-static
Static GL library. It is not recommended at all to link against the
static GL library. Only included for legacy reasons.



Authors:
--------
    Egbert Eich
    Keith Packard
    Roland Mainz
    Alan Coopersmith
    Russ Blaine
    Alexander Gottwald
    Alan Hourihane
    Chisato Yamauchi
    Eric Anholt
    Nolan Leake
    Stefan Dirsch
    Rik Faith
    Daniel Berrange
    Matthieu Herrb
    John Heasley
    Ryan Underwood
    Alex Deucher
    Ty Sarna
    Torrey T Lyons Darwin
    Stuart Kreitman
    Kevin E. Martin
    Greg Parker
    John Harper
    Adam Jackson
    Peter Kunzman
    Aaron Plattner
    Chisato Yamauchi
    Michel Daenzer
    Kristian Hgsberg
    Sren Sandmann
    Owen Taylor
    Mike A. Harris
    Ivan Kokshaysky
    Bryan Stine
    Guy Martin
    Paul Anderson
    Yu Shao
    David Dawes
    Harold L. Hunt II
    Andreas Luik
    Travis Tilley
    Ryan Lortie
    Ryan Breen
    Deron Johnson
    Ronny Vindenes
    Jim Gettys

%endif
%package Xprt
Summary:        X print Server
Group:          System/X11/Utilities
PreReq:         %insserv_prereq %fillup_prereq
Provides:       XFree86-Xprt
Obsoletes:      XFree86-Xprt
Autoreqprov:    on

%description Xprt
Contains the X print server.



Authors:
--------
    Egbert Eich
    Keith Packard
    Roland Mainz
    Alan Coopersmith
    Russ Blaine
    Alexander Gottwald
    Alan Hourihane
    Chisato Yamauchi
    Eric Anholt
    Nolan Leake
    Stefan Dirsch
    Rik Faith
    Daniel Berrange
    Matthieu Herrb
    John Heasley
    Ryan Underwood
    Alex Deucher
    Ty Sarna
    Torrey T Lyons Darwin
    Stuart Kreitman
    Kevin E. Martin
    Greg Parker
    John Harper
    Adam Jackson
    Peter Kunzman
    Aaron Plattner
    Chisato Yamauchi
    Michel Daenzer
    Kristian Hgsberg
    Sren Sandmann
    Owen Taylor
    Mike A. Harris
    Ivan Kokshaysky
    Bryan Stine
    Guy Martin
    Paul Anderson
    Yu Shao
    David Dawes
    Harold L. Hunt II
    Andreas Luik
    Travis Tilley
    Ryan Lortie
    Ryan Breen
    Deron Johnson
    Ronny Vindenes
    Jim Gettys

%package fonts-100dpi
Summary:        100dpi Bitmaps fonts for X11
Group:          System/X11/Utilities
Provides:       XFree86-fonts-100dpi
Obsoletes:      XFree86-fonts-100dpi
Autoreqprov:    on

%description fonts-100dpi
100dpi Bitmaps fonts for X11 required for bigger resolutions.



Authors:
--------
    Egbert Eich
    Keith Packard
    Roland Mainz
    Alan Coopersmith
    Russ Blaine
    Alexander Gottwald
    Alan Hourihane
    Chisato Yamauchi
    Eric Anholt
    Nolan Leake
    Stefan Dirsch
    Rik Faith
    Daniel Berrange
    Matthieu Herrb
    John Heasley
    Ryan Underwood
    Alex Deucher
    Ty Sarna
    Torrey T Lyons Darwin
    Stuart Kreitman
    Kevin E. Martin
    Greg Parker
    John Harper
    Adam Jackson
    Peter Kunzman
    Aaron Plattner
    Chisato Yamauchi
    Michel Daenzer
    Kristian Hgsberg
    Sren Sandmann
    Owen Taylor
    Mike A. Harris
    Ivan Kokshaysky
    Bryan Stine
    Guy Martin
    Paul Anderson
    Yu Shao
    David Dawes
    Harold L. Hunt II
    Andreas Luik
    Travis Tilley
    Ryan Lortie
    Ryan Breen
    Deron Johnson
    Ronny Vindenes
    Jim Gettys

%package fonts-cyrillic
Summary:        Cyrillic bitmaps fonts for X11
Group:          System/X11/Utilities
Provides:       XFree86-fonts-cyrillic
Provides:       locale(xorg-x11:ru)
Obsoletes:      XFree86-fonts-cyrillic
Autoreqprov:    on

%description fonts-cyrillic
Cyrillic bitmap fonts for X11 required for using russian language.



Authors:
--------
    Egbert Eich
    Keith Packard
    Roland Mainz
    Alan Coopersmith
    Russ Blaine
    Alexander Gottwald
    Alan Hourihane
    Chisato Yamauchi
    Eric Anholt
    Nolan Leake
    Stefan Dirsch
    Rik Faith
    Daniel Berrange
    Matthieu Herrb
    John Heasley
    Ryan Underwood
    Alex Deucher
    Ty Sarna
    Torrey T Lyons Darwin
    Stuart Kreitman
    Kevin E. Martin
    Greg Parker
    John Harper
    Adam Jackson
    Peter Kunzman
    Aaron Plattner
    Chisato Yamauchi
    Michel Daenzer
    Kristian Hgsberg
    Sren Sandmann
    Owen Taylor
    Mike A. Harris
    Ivan Kokshaysky
    Bryan Stine
    Guy Martin
    Paul Anderson
    Yu Shao
    David Dawes
    Harold L. Hunt II
    Andreas Luik
    Travis Tilley
    Ryan Lortie
    Ryan Breen
    Deron Johnson
    Ronny Vindenes
    Jim Gettys

%package fonts-scalable
Summary:        Scalable fonts for the X Window System
Group:          System/X11/Utilities
%if %suse_version > 920
Provides:       XFree86-fonts-scalable
%else
Provides:       XFree86-fonts-scalable xfntscl
%endif
Obsoletes:      XFree86-fonts-scalable
Autoreqprov:    on

%description fonts-scalable
Speedo, Type 1 (Postscript) and Truetype fonts for the X Window System.



Authors:
--------
    Egbert Eich
    Keith Packard
    Roland Mainz
    Alan Coopersmith
    Russ Blaine
    Alexander Gottwald
    Alan Hourihane
    Chisato Yamauchi
    Eric Anholt
    Nolan Leake
    Stefan Dirsch
    Rik Faith
    Daniel Berrange
    Matthieu Herrb
    John Heasley
    Ryan Underwood
    Alex Deucher
    Ty Sarna
    Torrey T Lyons Darwin
    Stuart Kreitman
    Kevin E. Martin
    Greg Parker
    John Harper
    Adam Jackson
    Peter Kunzman
    Aaron Plattner
    Chisato Yamauchi
    Michel Daenzer
    Kristian Hgsberg
    Sren Sandmann
    Owen Taylor
    Mike A. Harris
    Ivan Kokshaysky
    Bryan Stine
    Guy Martin
    Paul Anderson
    Yu Shao
    David Dawes
    Harold L. Hunt II
    Andreas Luik
    Travis Tilley
    Ryan Lortie
    Ryan Breen
    Deron Johnson
    Ronny Vindenes
    Jim Gettys

%package fonts-syriac
Summary:        Syriac OpenType Fonts for the X Window System
Group:          System/X11/Utilities
Provides:       XFree86-fonts-syriac
Obsoletes:      XFree86-fonts-syriac
Autoreqprov:    on

%description fonts-syriac
Syriac OpenType Fonts for X11 created by "Beth Mardutho: The Syriac
Institute".



Authors:
--------
    Egbert Eich
    Keith Packard
    Roland Mainz
    Alan Coopersmith
    Russ Blaine
    Alexander Gottwald
    Alan Hourihane
    Chisato Yamauchi
    Eric Anholt
    Nolan Leake
    Stefan Dirsch
    Rik Faith
    Daniel Berrange
    Matthieu Herrb
    John Heasley
    Ryan Underwood
    Alex Deucher
    Ty Sarna
    Torrey T Lyons Darwin
    Stuart Kreitman
    Kevin E. Martin
    Greg Parker
    John Harper
    Adam Jackson
    Peter Kunzman
    Aaron Plattner
    Chisato Yamauchi
    Michel Daenzer
    Kristian Hgsberg
    Sren Sandmann
    Owen Taylor
    Mike A. Harris
    Ivan Kokshaysky
    Bryan Stine
    Guy Martin
    Paul Anderson
    Yu Shao
    David Dawes
    Harold L. Hunt II
    Andreas Luik
    Travis Tilley
    Ryan Lortie
    Ryan Breen
    Deron Johnson
    Ronny Vindenes
    Jim Gettys

%package driver-options
Group:          System/X11/Utilities
Obsoletes:      XFree86-driver-options
Provides:       XFree86-driver-options
Autoreqprov:    on
Summary:        X11 driver options for building SaX2

%description driver-options
This package is only useful for building SaX2.



Authors:
--------
    Egbert Eich
    Keith Packard
    Roland Mainz
    Alan Coopersmith
    Russ Blaine
    Alexander Gottwald
    Alan Hourihane
    Chisato Yamauchi
    Eric Anholt
    Nolan Leake
    Stefan Dirsch
    Rik Faith
    Daniel Berrange
    Matthieu Herrb
    John Heasley
    Ryan Underwood
    Alex Deucher
    Ty Sarna
    Torrey T Lyons Darwin
    Stuart Kreitman
    Kevin E. Martin
    Greg Parker
    John Harper
    Adam Jackson
    Peter Kunzman
    Aaron Plattner
    Chisato Yamauchi
    Michel Daenzer
    Kristian Hgsberg
    Sren Sandmann
    Owen Taylor
    Mike A. Harris
    Ivan Kokshaysky
    Bryan Stine
    Guy Martin
    Paul Anderson
    Yu Shao
    David Dawes
    Harold L. Hunt II
    Andreas Luik
    Travis Tilley
    Ryan Lortie
    Ryan Breen
    Deron Johnson
    Ronny Vindenes
    Jim Gettys

%package sdk
Group:          System/X11/Utilities
Autoreqprov:    on
Summary:        X.Org SDK for building drivers

%description sdk
Use this package for building external drivers.



Authors:
--------
    Egbert Eich
    Keith Packard
    Roland Mainz
    Alan Coopersmith
    Russ Blaine
    Alexander Gottwald
    Alan Hourihane
    Chisato Yamauchi
    Eric Anholt
    Nolan Leake
    Stefan Dirsch
    Rik Faith
    Daniel Berrange
    Matthieu Herrb
    John Heasley
    Ryan Underwood
    Alex Deucher
    Ty Sarna
    Torrey T Lyons Darwin
    Stuart Kreitman
    Kevin E. Martin
    Greg Parker
    John Harper
    Adam Jackson
    Peter Kunzman
    Aaron Plattner
    Chisato Yamauchi
    Michel Daenzer
    Kristian Hgsberg
    Sren Sandmann
    Owen Taylor
    Mike A. Harris
    Ivan Kokshaysky
    Bryan Stine
    Guy Martin
    Paul Anderson
    Yu Shao
    David Dawes
    Harold L. Hunt II
    Andreas Luik
    Travis Tilley
    Ryan Lortie
    Ryan Breen
    Deron Johnson
    Ronny Vindenes
    Jim Gettys

%prep
%setup -q -n xc -a 21 -b26
# remove orig files in tarball
find . -type f -name "*.orig" | xargs rm -vf
pushd ../libvncauth
 patch -p0 -s --suffix=".vncauth-fpic" < $RPM_SOURCE_DIR/ps_libvncauth-fpic.diff
popd
pushd ../vncviewer
 patch -p0 -s --suffix=".vncviewer" < $RPM_SOURCE_DIR/ps_vncviewer.diff
popd
%patch0 -b .suse
%patch1 -b .fixes
%patch10 -b .vnc
# New gb18030 patches from SUN
%patch24 -p1 -b .i18n-xlib
%patch7 -b .p_macintosh-kb.diff
%if %BITMAP_ENCODINGS_ON_THE_FLY
%patch52 -b .mkfontdir
%endif
%patch56 -b .libXft
%patch62 -p1 -b .p_xft_cjk
%patch111 -p0 -b .fixes-cvs
mkdir -p programs/mkcomposecache
%patch210
%patch228 -p0
pushd lib/X11
### disabled for now (Bug #70890)
#%patch233 -p0
popd
%patch237 -p0
%patch238 -p0
pushd lib/X11
%patch276
popd
%patch280
### disabled for now (Bug #70890)
#%patch232 -p0
%patch308 -p0 -b .mouse_misc
%patch282 -p0
%patch283 -p0
%patch287 -p0
%patch288 -p0
%patch292 -p0
%if !%{USE_EXTERNAL_DRIVERS}
%patch295 -p0
%endif
%patch296 -p0
%patch297 -p0
%patch400
pushd programs/Xserver/fb
### different patch applied by Eric Anholt (see X.Org #4243)
#%patch315
popd
pushd programs/Xserver/mi
%patch316
popd
%patch324 -p1
%patch325 -p0
%patch326 -p0
#%patch327 -p0
%if %USE_EXTERNAL_DRIVERS
%patch328 -p0
%endif
%if %USE_EXTERNAL_MESA
%patch330 -p0
%endif
%patch332 -p0
%patch333 -p0
%patch334 -p0
%patch335 -p1
%patch336 -p1
pushd programs/Xserver/hw/xfree86/common
%patch337 -p0
popd
pushd programs/Xserver
%patch338 -p0
popd
%patch339
%patch340
%patch341
%patch342
%patch343
pushd programs/Xserver/hw/xfree86/drivers/trident
%patch344
popd
%patch345
%ifarch s390 s390x
%patch346
%endif
pushd programs/Xserver
%patch347
popd
%patch348
pushd programs/Xserver/hw/xfree86/os-support/linux
%patch349
popd
pushd programs/Xserver/hw/xfree86/os-support/bus
%patch350
popd
%patch351
%patch352
%patch353
%patch354
%patch355 -p1
%patch356
%patch357 -p2
%patch358
%patch359
%patch360
%patch361
pushd programs/Xserver/hw/xfree86/input/mouse/
%patch362 -p1
popd
%patch363 -p0
%ifarch ia64
%patch364 -p2
%endif
pushd programs/Xserver/
%patch365 -p0
popd
%patch366 -p0
pushd lib/X11
%patch367 -p0
popd
%patch368
#
UTS_RELEASE=`uname -r`
UTS_MAJOR=${UTS_RELEASE%%%%.*}
UTS_RELEASE=${UTS_RELEASE#*.}
UTS_MINOR=${UTS_RELEASE%%%%.*}
UTS_RELEASE=${UTS_RELEASE#*.}
UTS_TEENY=${UTS_RELEASE##*.}
# remove USE_FORTIFY flags which resulted in undefined references
echo "RPM_OPT_FLAGS: $RPM_OPT_FLAGS"
RPM_OPT_FLAGS=$(echo $RPM_OPT_FLAGS | sed 's/-D_FORTIFY_SOURCE=2//g')
echo "RPM_OPT_FLAGS: $RPM_OPT_FLAGS"
cat << EOF > config/cf/host.def
#define LinuxDistribution	LinuxSuSE
#undef  OSVendor
#define OSVendor		SuSE
#undef  DefaultOSName
#define DefaultOSName		SuSE Linux
#ifndef DefaultOSMajorVersion
#define DefaultOSMajorVersion	${UTS_MAJOR}
#endif
#ifndef DefaultOSMinorVersion
#define DefaultOSMinorVersion	${UTS_MINOR}
#endif
#ifndef DefaultOSTeenyVersion
#define DefaultOSTeenyVersion	${UTS_TEENY}
#endif
#ifdef  i386Architecture
#undef  DefaultGcc2i386Opt
#define DefaultGcc2i386Opt      $RPM_OPT_FLAGS -fno-strict-aliasing
#endif
#ifdef  MipsArchitecture
#undef  DefaultGcc2MipsOpt
#define DefaultGcc2MipsOpt	$RPM_OPT_FLAGS -fno-strict-aliasing
#endif
#ifdef  PpcArchitecture
#undef  DefaultGcc2PpcOpt
#define DefaultGcc2PpcOpt       $RPM_OPT_FLAGS -fno-strict-aliasing
#endif
#ifdef  Ppc64Architecture
#undef  DefaultGcc2Ppc64Opt
#define DefaultGcc2Ppc64Opt     $RPM_OPT_FLAGS -fno-strict-aliasing
#endif
#ifdef  AMD64Architecture
#undef  DefaultGcc2AMD64Opt
#define DefaultGcc2AMD64Opt     $RPM_OPT_FLAGS -fno-strict-aliasing
#endif
#ifdef  s390xArchitecture
#undef  OptimizedCDebugFlags
#define OptimizedCDebugFlags    $RPM_OPT_FLAGS -fno-strict-aliasing
#endif
#ifdef  ia64Architecture
#undef  OptimizedCDebugFlags
#define OptimizedCDebugFlags    $RPM_OPT_FLAGS -fno-strict-aliasing
#endif
#define UseGccMakeDepend	YES
#define ForceNormalLib		YES
%ifnarch sparc sparc64 s390 s390x mips
#define UsbMouseSupport		YES
#define HasLibUsb		YES
%endif
#if defined AlphaArchitecture
#define HasXdmAuth		NO
#endif
#define HasPam			YES
/* SuSE has its own XDM configuration */
#define InstallXdmConfig	NO
#define XdmDir			/etc/X11/xdm
#define InstallXinitConfig	YES
#define InstallFSConfig		YES
/* for XDM and anyone else for use */
#define DefaultUserPath		/usr/local/bin:/bin:/usr/bin:/usr/bin/X11:
#define DefaultSystemPath	/sbin:/usr/sbin:/bin:/usr/bin:/usr/bin/X11
/* needs to be investigated */
%ifarch s390 s390x
#define BuildFontServer         YES
#define BuildServer             YES
/* the current Imakefiles in the font directories aren't ready for a font 
   server without a server */
#undef DoLoadableServer
#define DoLoadableServer        NO
%endif
/* fontconfig support */
#define HasFontconfig           YES
#define BuilderEMailAddr        "http://www.suse.de/feedback"
%ifarch %ix86
#define HaveMatroxHal           YES
%else
#define UseMatroxHal		NO
%endif
/* build also imstt driver */
%ifarch %ix86 x86_64
#define XF86ExtraCardDrivers imstt
%endif
%ifarch mips
#define MakeDllModules		YES
#define DoLoadableServer	YES
%endif
%ifarch armv4l
#define MakeDllModules		YES
%endif
/* build also vnc module */
#define XF86VNC                 YES
/* Some more OpenType/TrueType Fonts */
#define BuildEthiopicFonts		YES
#define BuildBethMarduthoFonts	YES
%if %BITMAP_ENCODINGS_ON_THE_FLY
/* bitmap fonts are now re-encoded on-the-fly */
#define DerivedUCSFonts NO
%endif
#define UsbHidLib -lusb -lresmgr
/* don't try to build any Motif samples */
#define HasMotif NO
#define HasMotif2 NO
#define XvncServer YES 
#define BuildVncExtLib YES
#define StandardIncludes -I\$(TOP)/../include
#define BuildXterm NO
%if %{USE_EXTERNAL_MESA}
/* disable build of libGL/libGLU/libGLw */
#define BuildGLXLibrary NO
%endif
%ifarch %ix86
#define BuildLibGlxWithoutPIC NO
#if 0 /* currently broken: "No rule to make target .../via_dd_tritmp.h" */
#define BuildDevelDRIDrivers YES
#define DevelDRIDrivers      ffb unichrome via
#endif
%endif
EOF
%if !%{USE_EXTERNAL_DRIVERS}
%ifarch %ix86
   # unpack library for hardware abstraction layer
   tar xvzCf programs/Xserver/hw/xfree86/drivers/mga %SOURCE19
%endif
%endif
# VNC
cp -r ../libvncauth/ lib
echo "*** Removing fuzzy backup files for patches ***"
find . -type f -name "*.orig" | xargs rm -vf

%build
umask 022
make World
# build libxf86config also for s390/s390x (Bug #145823)
%ifarch s390 s390x
make -C programs/Xserver/hw/xfree86/parser
%endif
gcc $RPM_OPT_FLAGS -o suse/keygen suse/keygen.c
pushd ../vncviewer
  ../xc/config/imake/imake -I../xc/config/cf
  make
  make -f Makefile.modules CFLAGS="$RPM_OPT_FLAGS"
popd

%install
mkdir -p $RPM_BUILD_ROOT/usr/%{_lib}
make install DESTDIR=$RPM_BUILD_ROOT
make install.man DESTDIR=$RPM_BUILD_ROOT
make install.sdk DESTDIR=$RPM_BUILD_ROOT
%ifarch s390 s390x
# make sure that fonts.dir is not empty on s390/s390x (Bug #178315)
LD_LIBRARY_PATH=$RPM_BUILD_ROOT/usr/X11R6/%{_lib} XLOCALEDIR=$RPM_BUILD_ROOT/usr/X11R6/lib/X11/locale \
  $RPM_BUILD_ROOT/usr/X11R6/bin/mkfontscale -b -s -l $RPM_BUILD_ROOT/usr/X11R6/lib/X11/fonts/misc/
install -c -m 0444 fonts/encodings/encodings.dir $RPM_BUILD_ROOT/usr/X11R6/lib/X11/fonts/misc/
head -n 1 $RPM_BUILD_ROOT/usr/X11R6/lib/X11/fonts/misc/fonts.dir | grep "^0" && exit 1
%endif
# build libxf86config also for s390/s390x (Bug #145823)
%ifarch s390 s390x
make -C programs/Xserver/hw/xfree86/parser install DESTDIR=$RPM_BUILD_ROOT
%endif
# wacom driver build in linuxwacom package
%ifnarch s390 s390x
rm $RPM_BUILD_ROOT/usr/X11R6/%{_lib}/modules/input/wacom_drv.so
%endif
pushd ../vncviewer
  install -m 755 vncviewer $RPM_BUILD_ROOT/usr/X11R6/bin/xf4vncviewer
  install -m 644 vncviewer.man \
    $RPM_BUILD_ROOT/usr/X11R6/man/man1/xf4vncviewer.1x
  install -m 755 *.so $RPM_BUILD_ROOT/usr/%{_lib}
popd
rm -f $RPM_BUILD_ROOT/usr/X11R6/lib/X11/app-defaults
mv $RPM_BUILD_ROOT/etc/X11/app-defaults \
 $RPM_BUILD_ROOT/usr/X11R6/lib/X11
pushd $RPM_BUILD_ROOT/usr/X11R6/lib/X11/config
  chmod u+w host.def
  echo "#define UseSeparateConfDir NO" >> host.def
  echo "#define BuildHtmlManPages NO" >> host.def
  chmod u-w host.def
popd
ln -snf /usr/X11R6/include/X11 $RPM_BUILD_ROOT/usr/include/X11
ln -snf X11R6 $RPM_BUILD_ROOT/usr/X11
mkdir $RPM_BUILD_ROOT/usr/bin
ln -snf ../X11R6/bin $RPM_BUILD_ROOT/usr/bin/X11
mkdir -p $RPM_BUILD_ROOT/etc/skel
mkdir -p $RPM_BUILD_ROOT/etc/X11/xinit
mkdir -p $RPM_BUILD_ROOT/etc/X11/xdm
pushd $RPM_BUILD_ROOT/etc/X11/xdm
  rm -f README
  rm -f GiveConsole TakeConsole Xsetup_0 # Not used anymore by SuSE
  rm -f authdir                          # Correct location (FHS-2.1)
  tar xzf $RPM_SOURCE_DIR/xdm.tar.gz     # SuSE default XDM configuration
  mv $RPM_BUILD_ROOT/etc/X11/xdm/xinitrc*  \
     $RPM_BUILD_ROOT/etc/X11/xinit/
  cp $RPM_BUILD_ROOT/etc/X11/xinit/xinitrc \
     $RPM_BUILD_ROOT/etc/skel/.xinitrc.template
  mkdir -p   $RPM_BUILD_ROOT/var/lib/xdm/authdir/authfiles
  chmod 0700 $RPM_BUILD_ROOT/var/lib/xdm/authdir/authfiles
  chmod 0700 $RPM_BUILD_ROOT/var/lib/xdm/authdir
  ln -snf /var/lib/xdm/authdir .
popd
mkdir -p   $RPM_BUILD_ROOT/var/log
touch      $RPM_BUILD_ROOT/var/log/xdm.errors
chmod 0640 $RPM_BUILD_ROOT/var/log/xdm.errors
mkdir -p   $RPM_BUILD_ROOT/var/run
touch      $RPM_BUILD_ROOT/var/run/xdm.pid
chmod 0640 $RPM_BUILD_ROOT/var/run/xdm.pid
%if !%{USE_EXTERNAL_MESA}
pushd $RPM_BUILD_ROOT/usr/X11R6/%{_lib}
  ln -snf libGL.a     libMesaGL.a
  ln -snf libGL.so    libMesaGL.so
  ln -snf libGL.so.1  libMesaGL.so.3
  ln -snf libGLU.a    libMesaGLU.a
  ln -snf libGLU.so   libMesaGLU.so
  ln -snf libGLU.so.1 libMesaGLU.so.3
  mv libGL.* libGLU.* libOSMesa.* libMesaGL.* libMesaGLU.* ../../%{_lib}
popd
%endif
mkdir -p $RPM_BUILD_ROOT/usr/include
XROOT=$RPM_BUILD_ROOT/usr/X11R6
mkdir -p $XROOT/lib/X11/nls
mkdir -p $RPM_BUILD_ROOT/etc/pam.d
mkdir -p $RPM_BUILD_ROOT/etc/logrotate.d
mkdir -p -m 755 $RPM_BUILD_ROOT/etc/init.d
mkdir -p -m 755 $RPM_BUILD_ROOT/var/adm/fillup-templates
mkdir -p -m 755 $RPM_BUILD_ROOT/sbin/conf.d
mkdir -p -m 755 $RPM_BUILD_ROOT/usr/share/xsessions
# C/nls.dir: 'C' language support; still required for acroread and
# other Motif-based applications
install -m 0444 suse/C                   $XROOT/lib/X11/nls/
install -m 0444 suse/nls.dir             $XROOT/lib/X11/nls/
install -m 0711 suse/keygen              $RPM_BUILD_ROOT/usr/bin/
%if %suse_version > 920
install -m 0644 suse/xdm.pamd            $RPM_BUILD_ROOT/etc/pam.d/xdm
%else
install -m 0644 suse/xdm.pamd.suse92     $RPM_BUILD_ROOT/etc/pam.d/xdm
%endif
install -m 0444 suse/Xmodmap             $RPM_BUILD_ROOT/etc/X11/
install -m 0444 suse/Xmodmap.remote      $RPM_BUILD_ROOT/etc/X11/
install -m 0444 suse/Xresources          $RPM_BUILD_ROOT/etc/X11/
install -m 0644 suse/config.xfs          $RPM_BUILD_ROOT/etc/X11/fs/config
install -m 0644 suse/logrotate.xdm       $RPM_BUILD_ROOT/etc/logrotate.d/xdm
install -m 0755 suse/rcxfs               $RPM_BUILD_ROOT/etc/init.d/xfs
install -m 0755 suse/SuSEconfig.xdm      $RPM_BUILD_ROOT/sbin/conf.d/
install -m 0644 suse/twm.desktop         $RPM_BUILD_ROOT/usr/share/xsessions/
%ifnarch s390 s390x
install -m 0755 suse/xserverrc           $RPM_BUILD_ROOT/etc/X11/xinit/xserverrc
%endif
mkdir -p -m 755 $RPM_BUILD_ROOT/usr/sbin
ln -snf /etc/init.d/xfs $RPM_BUILD_ROOT/usr/sbin/rcxfs
%ifnarch s390 s390x
# additional driver options file
cp ${RPM_SOURCE_DIR}/CardModules.addon $RPM_BUILD_ROOT/etc/X11/
%endif
mkdir -p $RPM_BUILD_ROOT/var/X11R6/xkb/compiled
mkdir -p $RPM_BUILD_ROOT/var/X11R6/bin
%ifnarch s390 s390x
echo ".so man1/Xorg.1x" > $RPM_BUILD_ROOT/usr/X11R6/man/man1/XFree86.1x
echo ".so man1/xorgconfig.1x" > $RPM_BUILD_ROOT/usr/X11R6/man/man1/xf86config.1x
echo ".so man5/xorg.conf.5x" > $RPM_BUILD_ROOT/usr/X11R6/man/man5/XF86Config.5x
ln -snf /var/X11R6/bin/X $RPM_BUILD_ROOT/usr/X11R6/bin/X
ln -snf /usr/X11R6/bin/Xorg $RPM_BUILD_ROOT/var/X11R6/bin/X
ln -snf Xorg $RPM_BUILD_ROOT/usr/X11R6/bin/XFree86
ln -snf xorgconfig $RPM_BUILD_ROOT/usr/X11R6/bin/xf86config
%endif
mkdir -p $RPM_BUILD_ROOT/usr/share/doc/packages/Xorg-Xprt
cp -a programs/Xserver/XpConfig/README \
  $RPM_BUILD_ROOT/usr/share/doc/packages/Xorg-Xprt
test -L $RPM_BUILD_ROOT/usr/include/GL && rm -f $RPM_BUILD_ROOT/usr/include/GL
mkdir -p $RPM_BUILD_ROOT/usr/include/GL
%if %{USE_EXTERNAL_MESA}
rm -rf $RPM_BUILD_ROOT/usr/include/GL/*
rm -rf $RPM_BUILD_ROOT/usr/X11R6/include/GL/
for i in glxint.h glxmd.h glxproto.h; do
  cp include/GL/$i $RPM_BUILD_ROOT/usr/include/GL
done
%else
mv $RPM_BUILD_ROOT/usr/X11R6/include/GL/* $RPM_BUILD_ROOT/usr/include/GL
mv $RPM_BUILD_ROOT/usr/include/GL/GLw*.h $RPM_BUILD_ROOT/usr/X11R6/include/GL
test -f $RPM_BUILD_ROOT/usr/include/GL/glxext.h || \
  cp programs/Xserver/GL/glx/glxext.h $RPM_BUILD_ROOT/usr/include/GL
%endif
%ifnarch s390 s390x
ln -snf /var/lib/xkb $RPM_BUILD_ROOT/etc/X11/xkb/compiled
%endif
%ifarch s390 s390x
if test ! -d $RPM_BUILD_ROOT/etc/X11/xkb; then
  rm -rf $RPM_BUILD_ROOT/etc/X11/xkb
  test -d $RPM_BUILD_ROOT/usr/X11R6/lib/X11/xkb && \
    mv $RPM_BUILD_ROOT/usr/X11R6/lib/X11/xkb $RPM_BUILD_ROOT/etc/X11
fi
%endif
#xkbcomp already in /usr/X11R6/bin
ln -snf /usr/X11R6/bin/xkbcomp $RPM_BUILD_ROOT/etc/X11/xkb/xkbcomp
%if !%{USE_EXTERNAL_DRIVERS}
%ifarch %ix86 ia64 x86_64
ln -snf nv_drv.so $RPM_BUILD_ROOT/usr/X11R6/%{_lib}/modules/drivers/nvidia_drv.so
%endif
%endif
# Compose and XI18N_OBJS files are missing for some UTF-8 locales
# XLC_LOCALE file should be the same
pushd $RPM_BUILD_ROOT/usr/X11R6/lib/X11/locale
for i in *.UTF-8; do
  echo $i
  if [ "$i" != "en_US.UTF-8" ]; then
    #disabled for now
    #cp -f en_US.UTF-8/XLC_LOCALE $i
    test -f $i/Compose    || cp en_US.UTF-8/Compose    $i
    test -f $i/XI18N_OBJS || cp en_US.UTF-8/XI18N_OBJS $i
  fi
done
popd
%ifarch sparc sparc64
#
# Hack for SPARC: Rename fbdev_drv.o on SPARC or YaST2 will fail
#
mv $RPM_BUILD_ROOT/usr/X11R6/lib/modules/drivers/fbdev_drv.o $RPM_BUILD_ROOT/usr/X11R6/lib/modules/drivers/fbdev_drv.o.problematic
%endif
# creating symlinks
%if %USE_EXTERNAL_XKB_FILES
for i in fs lbxproxy proxymngr rstart twm xdm xinit xserver xsm; do
%else
for i in fs lbxproxy proxymngr rstart twm xdm xinit xkb xserver xsm; do
%endif
  ln -snf /etc/X11/$i $RPM_BUILD_ROOT/usr/X11R6/lib/X11/$i
done
for i in Xresources Xmodmap Xmodmap.remote; do
  ln -snf /etc/X11/$i $RPM_BUILD_ROOT/usr/X11R6/lib/X11/$i
done
mkdir -p $RPM_BUILD_ROOT/usr/share/doc/packages
ln -snf /usr/X11R6/lib/X11/doc/ $RPM_BUILD_ROOT/usr/share/doc/packages/Xorg
# XftConfig is now located in package xf86tools
rm -f $RPM_BUILD_ROOT/etc/X11/XftConfig 
rm -f $RPM_BUILD_ROOT/usr/X11R6/lib/X11/XftConfig
# fonts.scale are created dynamically by /sbin/conf.d/SuSEconfig.fonts
%ifnarch s390 s390x
for i in TTF Type1; do
%else
for i in TTF; do
%endif
  grep -v "^[[:digit:]]*$" \
    $RPM_BUILD_ROOT/usr/X11R6/lib/X11/fonts/$i/fonts.scale > \
    $RPM_BUILD_ROOT/usr/X11R6/lib/X11/fonts/$i/fonts.scale.xf86
  rm -f $RPM_BUILD_ROOT/usr/X11R6/lib/X11/fonts/$i/fonts.scale
done
rm -f $RPM_BUILD_ROOT/usr/X11R6/lib/X11/fonts/CID/fonts.scale
mkdir -p $RPM_BUILD_ROOT/usr/X11R6/lib/X11/fonts/truetype
mv $RPM_BUILD_ROOT/usr/X11R6/lib/X11/fonts/TTF/* \
  $RPM_BUILD_ROOT/usr/X11R6/lib/X11/fonts/truetype
mv $RPM_BUILD_ROOT/usr/X11R6/lib/X11/fonts/OTF/*.otf \
  $RPM_BUILD_ROOT/usr/X11R6/lib/X11/fonts/truetype
grep -v "^[[:digit:]]*$" \
  $RPM_BUILD_ROOT/usr/X11R6/lib/X11/fonts/OTF/fonts.scale > \
  $RPM_BUILD_ROOT/usr/X11R6/lib/X11/fonts/truetype/fonts.scale.syriac
rm -rf $RPM_BUILD_ROOT/usr/X11R6/lib/X11/fonts/OTF
mkdir -p $RPM_BUILD_ROOT/usr/X11R6/lib/X11/fonts/CID
# some compatibility keyboard layout links
pushd $RPM_BUILD_ROOT/etc/X11/xkb/symbols
  ln -snf cz cs
  ln -snf cz_qwerty cs_qwerty
  ln -snf el gr
popd
pushd $RPM_BUILD_ROOT/etc/X11/xkb/symbols/pc
  ln -snf cz cs
  ln -snf cz_qwerty cs_qwerty
  ln -snf el gr
popd
# workaround for Bug #45354 
pushd $RPM_BUILD_ROOT/etc/X11/xkb/symbols/pc
  ln -snf ../hu hu
popd
# for FHS compliance (Bug #21857)
mv $RPM_BUILD_ROOT/etc/X11/xdm/chooser         $RPM_BUILD_ROOT/usr/X11R6/bin/
mv $RPM_BUILD_ROOT/etc/X11/rstart/rstartd.real $RPM_BUILD_ROOT/usr/X11R6/bin/
sed 's+lib/X11/rstart/rstartd.real+bin/rstartd.real+' \
  $RPM_BUILD_ROOT/usr/X11R6/bin/rstartd > rstartd.tmp
mv rstartd.tmp $RPM_BUILD_ROOT/usr/X11R6/bin/rstartd
chmod 755 $RPM_BUILD_ROOT/usr/X11R6/bin/rstartd
# use /usr/lib/pkgconfig for all .pc files (Bug #22828)
mkdir -p $RPM_BUILD_ROOT/usr/%_lib/pkgconfig
mv $RPM_BUILD_ROOT/usr/X11R6/%_lib/pkgconfig/* \
  $RPM_BUILD_ROOT/usr/%_lib/pkgconfig/
# create Xft2 cache files
pushd $RPM_BUILD_ROOT/usr/X11R6/lib/X11/fonts
  export LD_LIBRARY_PATH=$RPM_BUILD_ROOT/usr/X11R6/%_lib
  for i in misc 75dpi 100dpi cyrillic Type1 truetype; do
%if %BITMAP_ENCODINGS_ON_THE_FLY
    case $i in
      misc|75dpi|100dpi)
        # remove derived Latin1 fonts
        rm -f $i/*-*-*.pcf* $i/fonts.scale
        $RPM_BUILD_ROOT/usr/X11R6/bin/mkfontscale -b -s $i
        ;;
      *)
        ;;
    esac
%endif
%if %FC_232
    rm -f $i/%{FC_FILE}
    fc-cache -f $i
    touch -r $i $i/{%{FC_FILE},fonts.dir,fonts.scale,.fonts-config-timestamp} 
%else
    rm -f $i/fonts.cache-2
    touch -r $i $i/{fonts.dir,fonts.scale,.fonts-config-timestamp}
%endif
  done
  rm -f truetype/fonts.scale
popd
%if !%{USE_EXTERNAL_MESA}
# create dummy nvidia libGLcore.so.1 for applications, which are still 
# linked against libGL.so.1 of older nvidia driver releases
touch libGLcore.c
gcc -Wall -ansi -pedantic -c libGLcore.c
gcc -shared -Wl -o $RPM_BUILD_ROOT/usr/%{_lib}/libGLcore.so.1 libGLcore.o
# duplicate libGL to make workarounds like LD_PRELOAD possible if
# nvidia driver is installed and its libGl does not work
mkdir -p $RPM_BUILD_ROOT/usr/%{_lib}/GL
cp -a $RPM_BUILD_ROOT/usr/%{_lib}/libGL.so.1* $RPM_BUILD_ROOT/usr/%{_lib}/GL
%endif
pushd $RPM_BUILD_ROOT
  rm -f usr/X11R6/include/X11/Wraphelp.c.README
  rm -f usr/X11R6/lib/X11/Xcms.txt
%ifnarch s390 s390x
  rm -rf /usr/X11R6/src/
%endif
%ifarch s390 s390x
  rm -f etc/X11/xinit/xinitrc
  rm -f usr/X11R6/bin/xinit
  rm -f usr/X11R6/lib/X11/xinit/xinitrc
  rm -rf usr/src/kernel-modules/drm/
# necessary for other packages
  mkdir -p usr/X11R6/include/X11/pixmaps
%endif
popd
# save some space; remove broken DRI libs
%ifnarch sparc sparc64
rm -f $RPM_BUILD_ROOT/usr/X11R6/%{_lib}/modules/dri/ffb_dri.so
%endif
rm -f $RPM_BUILD_ROOT/usr/X11R6/%{_lib}/modules/dri/gamma_dri.so
# remove install script; useless anyway (Bug #29662)
rm -f $RPM_BUILD_ROOT/usr/X11R6/lib/X11/etc/Xinstall.sh
# desktop files
%suse_update_desktop_file -i -u xmag  DesktopUtility
%suse_update_desktop_file -i -u xload System Monitor
%suse_update_desktop_file -i -u Xkill DesktopUtility
%suse_update_desktop_file -i -u xcalc Calculator
%suse_update_desktop_file -i -u Xrefresh   DesktopUtility
%suse_update_desktop_file -i -u xclipboard DesktopUtility
%suse_update_desktop_file $RPM_BUILD_ROOT/usr/share/xsessions/twm.desktop
%ifnarch s390 s390x
find $RPM_BUILD_ROOT/usr/X11R6/%{_lib}/modules/ -type f | \
  sed "s@^$RPM_BUILD_ROOT@@g" | \
  grep -v libglx.so | grep -v libGLcore.so | \
  grep -v nvidia_drv.o | grep -v "/usr/X11R6/%{_lib}/modules/dri/" > files.xorg-x11-server
%endif
%ifarch s390 s390x
  rm -rf $RPM_BUILD_ROOT/etc/X11/xinit/xinitrc.d/
%else
  mkdir -p $RPM_BUILD_ROOT/etc/X11/xinit/xinitrc.d
%endif
rm -rf $RPM_BUILD_ROOT/etc/rc.d/
%ifnarch s390 s390x
# strip Xserver modules (Bug #49816)
pushd $RPM_BUILD_ROOT/usr/X11R6/%{_lib}/modules
  find . -name "*.[ao]" | xargs --no-run-if-empty chmod 644
  find . -name "*.[ao]" | xargs --no-run-if-empty strip --strip-debug
  find . -name "*.so"   | xargs --no-run-if-empty chmod 755
popd
%endif
chmod +x $RPM_BUILD_ROOT/usr/X11R6/lib/X11/locale/%{_lib}/common/*.so.*
install -m 755 $RPM_SOURCE_DIR/mkallcomposecaches.sh \
  $RPM_BUILD_ROOT/usr/X11R6/bin/mkallcomposecaches
%ifnarch s390 s390x
$RPM_BUILD_ROOT/usr/X11R6/bin/mkallcomposecaches $RPM_BUILD_ROOT
%endif
%if %USE_EXTERNAL_XKB_FILES
rm -rf $RPM_BUILD_ROOT/etc/X11/xkb
rm -f  $RPM_BUILD_ROOT/usr/X11R6/lib/X11/xkb
%endif
# get rid of ksh deps (X.Org #1407)
rm $RPM_BUILD_ROOT/usr/X11R6/bin/xauth_switch_to_sun-des-1
# xf1bpp/xf4bpp modules not build on ppc64, but required for
# building ATI driver via SDK
%ifarch ppc64
install -m 644 programs/Xserver/hw/xfree86/xf1bpp/{xf1bpp.h,mfbmap.h,mfbunmap.h} \
               programs/Xserver/hw/xfree86/xf4bpp/xf4bpp.h \
               $RPM_BUILD_ROOT/usr/X11R6/%{_lib}/Server/include
%endif
%ifnarch s390 s390x
mkdir -p $RPM_BUILD_ROOT/usr/X11R6/%{_lib}/modules/updates/{fonts,input,linux,drivers,multimedia,extensions}
install -m 644 $RPM_SOURCE_DIR/README.updates \
  $RPM_BUILD_ROOT/usr/X11R6/%{_lib}/modules/updates
%endif

%verifyscript
%verify_permissions -e /usr/X11R6/bin/dga

%verifyscript server
%verify_permissions -e /usr/X11R6/bin/Xorg

%post
# Create symbolic run level links for xfs start script:
%{fillup_and_insserv -p xfs}
%run_permissions
exit 0

%preun
%stop_on_removal xfs
exit 0

%postun
# Rearrange run level symlinks after removing the xfs init script
%{insserv_cleanup}
exit 0

%post libs -p /sbin/ldconfig

%post server
%run_permissions
rm -f var/log/XFree86.*.log*
ln -snf Xorg.0.log var/log/XFree86.0.log
ln -snf Xorg.0.log.old var/log/XFree86.0.log.old
# SaX2 writes xorg.conf since SuSE 9.3
# - create backup of XF86Config
# - copy XF86Config to xorg.conf
# - set XF86Config symlink to xorg.conf
pushd etc/X11 &> /dev/null
  # get rid of symlinks
  for file in xorg.conf XF86Config; do
    if [ -L $file ]; then
      symlink=$file
      while test -L $symlink; do
        tmp=$(readlink $symlink)
        rm -f $symlink
        symlink=$tmp
      done
      mv $symlink $file
    fi
  done
  if [ ! -f xorg.conf -a -f XF86Config ]; then
    cp XF86Config xorg.conf
  fi
  if [ -f xorg.conf ]; then
    #test -f XF86Config && old XF86Config
    ln -snf xorg.conf XF86Config
  fi
popd &> /dev/null
if [ -f etc/X11/xorg.conf -a "$YAST_IS_RUNNING" = "instsys" -a -f var/lib/YaST2/update_mode ]; then
  # disable DRI for fglrx driver (Bug #152473)
  cat etc/X11/xorg.conf | grep -v ^# | tr "\t" " " | \
    grep -q -i -E "^[\ ]*Driver[\ ]+\"fglrx\""
  if [ $? -eq 0 ]; then
    cp etc/X11/xorg.conf etc/X11/xorg.conf.fglrx
    grep -v -i -E ".*Load.*\"dri\"" etc/X11/xorg.conf.fglrx > \
      etc/X11/xorg.conf
  fi
  # keyboard driver specification seems to be case-sensitive now :-(
  # SLES9 SPx --> SLES10: i915 --> i810 driver
  # SuSE 9.3  --> SuSE 10.0: xgi --> sis driver
  # SuSE 9.3  --> SuSE 10.0: fglrx --> radeon driver
  # SuSE 9.3  --> SuSE 10.0: cz_qwerty,us --> cz(qwerty,basic) keyboard map
  # SuSE 9.3  --> SuSE 10.0: sk_qwerty,us --> sk(qwerty,basic) keyboard map
  # SuSE 9.3  --> SuSE 10.0: el --> gr keyboard map
  # SuSE 10.0 --> SuSE 10.1: r128 --> ati driver
  # SuSE 9.0  --> SuSE 9.1:  /dev/mouse --> /dev/input/mice (Bug #172260)
  sed -i.post_xorg-x11-server \
         -e 's/\"[kK]eyboard\"/\"kbd\"/g' \
         -e 's/\"i915\"/\"i810\"/g'       \
         -e 's/\"xgi\"/\"sis\"/g'         \
         -e 's/\"fglrx\"/\"radeon\"/g'    \
         -e 's/\"r128\"/\"ati\"/g'        \
         -e 's+/dev/mouse+/dev/input/mice+g' \
%if %USE_EXTERNAL_XKB_FILES
         -e '
/\"XkbLayout\".*\".*_qwerty,us\"/{
h
g
a\
  Option\t"XkbVariant" "qwerty,basic"
}
'                                     \
         -e s/_qwerty//g              \
         -e s/\"el\"/\"gr\"/g         \
%endif
      etc/X11/xorg.conf
fi
exit 0
%ifarch %ix86 x86_64
%if !%{USE_EXTERNAL_MESA}

%pre Mesa
# nvidia driver might be installed; uninstall it cleanly
test -x usr/bin/nvidia-installer && \
  usr/bin/nvidia-installer -s --uninstall &> /dev/null
exit 0

%pre Mesa-devel
# nvidia driver might be installed; uninstall it cleanly
test -x usr/bin/nvidia-installer && \
  usr/bin/nvidia-installer -s --uninstall &> /dev/null
exit 0
%endif
%endif

%post Xprt
# Create symbolic run level links for xprint start script
%{fillup_and_insserv -p xprint}
exit 0

%preun Xprt
%stop_on_removal xprint
exit 0

%postun Xprt
# Rearrange run level symlinks after removing the xprint init script
%{insserv_cleanup}
exit 0

%files
%defattr(-, root, root)
%dir /var/lib/xkb/
%dir /var/lib/xdm/
%dir /var/X11R6/xkb
%dir /var/X11R6/xkb/compiled/
%dir /var/X11R6/bin/
%dir /usr/X11R6/include/X11/
%dir /usr/X11R6/lib/X11/fonts/truetype
%dir /usr/X11R6/lib/X11/nls/
%dir /usr/share/xsessions/
%config /etc/skel/.xinitrc.template
%config /etc/pam.d/xdm
%config /etc/X11/Xmodmap
%config /etc/X11/Xmodmap.remote
%config /etc/X11/Xresources
%config /etc/X11/fs/
%config /etc/X11/lbxproxy/
%config /etc/X11/proxymngr/
%config /etc/X11/rstart/
%config /etc/X11/twm/
%config /etc/X11/xdm/
%config /etc/X11/xinit/
%if !%{USE_EXTERNAL_XKB_FILES}
%config /etc/X11/xkb/
%endif
/etc/X11/xserver/
%config /etc/X11/xsm/
%config /etc/logrotate.d/xdm
/etc/init.d/xfs
/usr/sbin/rcxfs
/sbin/conf.d/SuSEconfig.xdm
/usr/X11
/usr/bin/X11
/usr/bin/keygen
/usr/X11R6/bin/showrgb
%ifnarch s390 s390x
/usr/X11R6/bin/pcitweak
/usr/X11R6/bin/xorgcfg
%endif
/usr/X11R6/bin/Xdmx
/usr/X11R6/bin/Xmark
/usr/X11R6/bin/appres
/usr/X11R6/bin/atobm
/usr/X11R6/bin/bdftopcf
/usr/X11R6/bin/bdftruncate
/usr/X11R6/bin/beforelight
/usr/X11R6/bin/bitmap
/usr/X11R6/bin/bmtoa
/usr/X11R6/bin/ccmakedep
/usr/X11R6/bin/chooser
/usr/X11R6/bin/cleanlinks
/usr/X11R6/bin/cxpm
%verify(not mode) /usr/X11R6/bin/dga
/usr/X11R6/bin/editres
/usr/X11R6/bin/fslsfonts
/usr/X11R6/bin/fstobdf
%ifnarch s390 s390x
/usr/X11R6/bin/getconfig
/usr/X11R6/bin/getconfig.pl
%endif
%if !%{USE_EXTERNAL_MESA}
/usr/X11R6/bin/glxgears 
/usr/X11R6/bin/glxinfo
%endif
%ifnarch s390 s390x
/usr/X11R6/bin/gtf
%endif
/usr/X11R6/bin/iceauth
/usr/X11R6/bin/ico
%ifnarch ppc ppc64 sparc sparc64 s390 s390x mips armv4l hppa
/usr/X11R6/bin/inb
/usr/X11R6/bin/inl
/usr/X11R6/bin/inw
/usr/X11R6/bin/ioport
%endif
/usr/X11R6/bin/lbxproxy
/usr/X11R6/bin/listres
/usr/X11R6/bin/lndir
/usr/X11R6/bin/luit
/usr/X11R6/bin/makeg
/usr/X11R6/bin/makestrs
/usr/X11R6/bin/mergelib
/usr/X11R6/bin/mkallcomposecaches
/usr/X11R6/bin/mkcomposecache
/usr/X11R6/bin/mkcfm
/usr/X11R6/bin/mkdirhier
/usr/X11R6/bin/mkfontdir
/usr/X11R6/bin/mkfontscale
/usr/X11R6/bin/mkhtmlindex
%ifnarch s390 s390x
/usr/X11R6/bin/mmapr
/usr/X11R6/bin/mmapw
%endif
/usr/X11R6/bin/oclock
%ifnarch ppc ppc64 sparc sparc64 s390 s390x mips armv4l hppa
/usr/X11R6/bin/outb
/usr/X11R6/bin/outl
/usr/X11R6/bin/outw
%endif
/usr/X11R6/bin/proxymngr
/usr/X11R6/bin/revpath
/usr/X11R6/bin/rman
/usr/X11R6/bin/rstart
/usr/X11R6/bin/rstartd
/usr/X11R6/bin/rstartd.real
%ifnarch s390 s390x
/usr/X11R6/bin/scanpci
%endif
/usr/X11R6/bin/sessreg
/usr/X11R6/bin/setxkbmap
/usr/X11R6/bin/showfont
/usr/X11R6/bin/smproxy
/usr/X11R6/bin/startx
/usr/X11R6/bin/sxpm
/usr/X11R6/bin/twm
/usr/X11R6/bin/ucs2any
/usr/X11R6/bin/viewres
/usr/X11R6/bin/x11perf
/usr/X11R6/bin/x11perfcomp
/usr/X11R6/bin/xbiff
/usr/X11R6/bin/xcalc
/usr/X11R6/bin/xclipboard
/usr/X11R6/bin/xclock
/usr/X11R6/bin/xcmsdb
/usr/X11R6/bin/xconsole
/usr/X11R6/bin/xcursorgen
/usr/X11R6/bin/xcutsel
/usr/X11R6/bin/xditview
/usr/X11R6/bin/xdm
/usr/X11R6/bin/xdpyinfo
%if !%{USE_EXTERNAL_MESA}
/usr/X11R6/bin/xdriinfo
%endif
/usr/X11R6/bin/xedit
/usr/X11R6/bin/xev
/usr/X11R6/bin/xeyes
/usr/X11R6/bin/xfd
/usr/X11R6/bin/xfindproxy
/usr/X11R6/bin/xfontsel
/usr/X11R6/bin/xfs
/usr/X11R6/bin/xfsinfo
/usr/X11R6/bin/xfwp
/usr/X11R6/bin/xgamma
/usr/X11R6/bin/xgc
/usr/X11R6/bin/xhost
/usr/X11R6/bin/xkbbell
/usr/X11R6/bin/xkbcomp
/usr/X11R6/bin/xkbevd
/usr/X11R6/bin/xkbprint
/usr/X11R6/bin/xkbvleds
/usr/X11R6/bin/xkbwatch
/usr/X11R6/bin/xkill
/usr/X11R6/bin/xload
/usr/X11R6/bin/xlogo
/usr/X11R6/bin/xlsatoms
/usr/X11R6/bin/xlsclients
/usr/X11R6/bin/xlsfonts
/usr/X11R6/bin/xmag
/usr/X11R6/bin/xman
/usr/X11R6/bin/xmessage
/usr/X11R6/bin/xmh
/usr/X11R6/bin/xmodmap
/usr/X11R6/bin/xmore
/usr/X11R6/bin/xon
/usr/X11R6/bin/xprop
/usr/X11R6/bin/xrandr
/usr/X11R6/bin/xrdb
/usr/X11R6/bin/xrefresh
/usr/X11R6/bin/xrx
/usr/X11R6/bin/xset
/usr/X11R6/bin/xsetmode
/usr/X11R6/bin/xsetpointer
/usr/X11R6/bin/xsetroot
/usr/X11R6/bin/xsm
/usr/X11R6/bin/xstdcmap
/usr/X11R6/bin/xtrapchar
/usr/X11R6/bin/xtrapin
/usr/X11R6/bin/xtrapinfo
/usr/X11R6/bin/xtrapout
/usr/X11R6/bin/xtrapproto
/usr/X11R6/bin/xtrapreset
/usr/X11R6/bin/xtrapstats
/usr/X11R6/bin/xvidtune
/usr/X11R6/bin/xvinfo
/usr/X11R6/bin/xwd
/usr/X11R6/bin/xwininfo
/usr/X11R6/bin/xwud
/usr/X11R6/bin/vncevent
/usr/X11R6/bin/xf4vncviewer
/usr/X11R6/bin/dmxtodmx
/usr/X11R6/bin/vdltodmx
# get rid of ksh deps (X.Org #1407)
#/usr/X11R6/bin/xauth_switch_to_sun-des-1
/usr/X11R6/bin/xdbedizzy
/usr/X11R6/bin/xdmxconfig
/usr/X11R6/bin/xdpr
/usr/X11R6/bin/xpr
/usr/%{_lib}/copyrect.so
/usr/%{_lib}/corre.so
/usr/%{_lib}/hextile.so
/usr/%{_lib}/rre.so
/usr/%{_lib}/tight.so
/usr/%{_lib}/zlib.so
/usr/X11R6/include/X11/bitmaps/
%config /usr/X11R6/lib/X11/app-defaults/*
/usr/X11R6/lib/X11/XErrorDB
/usr/X11R6/lib/X11/XKeysymDB
/usr/X11R6/lib/X11/Xmodmap
/usr/X11R6/lib/X11/Xmodmap.remote    
/usr/X11R6/lib/X11/Xresources
/usr/X11R6/lib/X11/nls/C
/usr/X11R6/lib/X11/nls/nls.dir
%ifnarch s390 s390x
/usr/X11R6/lib/X11/etc/
%endif
/usr/X11R6/lib/X11/rgb.txt
#/usr/X11R6/lib/X11/Xcms.txt
%ifnarch s390 s390x
/usr/X11R6/lib/X11/Cards
/usr/X11R6/lib/X11/Options
%endif
/usr/X11R6/lib/X11/x11perfcomp/
/usr/X11R6/lib/X11/xman.help
%dir /usr/X11R6/lib/X11/fonts/encodings/
%attr (644,root,root) %verify(not md5 size mtime) /usr/X11R6/lib/X11/fonts/encodings/encodings.dir
/usr/X11R6/lib/X11/fonts/encodings/*.gz
/usr/X11R6/lib/X11/fonts/encodings/large
/usr/X11R6/lib/X11/fonts/util/
%dir /usr/X11R6/lib/X11/fonts/misc/
%verify(not md5 size mtime) /usr/X11R6/lib/X11/fonts/misc/.fonts-config-timestamp
%if ! %BITMAP_ENCODINGS_ON_THE_FLY
%attr (644,root,root) %verify(not md5 size mtime) /usr/X11R6/lib/X11/fonts/misc/encodings.dir
%endif
%attr (644,root,root) %verify(not md5 size mtime) /usr/X11R6/lib/X11/fonts/misc/fonts.alias
%if %FC_232
%attr (644,root,root) %verify(not md5 size mtime) /usr/X11R6/lib/X11/fonts/misc/%{FC_FILE}
%endif
%attr (644,root,root) %verify(not md5 size mtime) /usr/X11R6/lib/X11/fonts/misc/fonts.dir
%attr (644,root,root) %verify(not md5 size mtime) /usr/X11R6/lib/X11/fonts/misc/fonts.scale
/usr/X11R6/lib/X11/fonts/misc/*.gz
%dir /usr/X11R6/lib/X11/fonts/CID/
%attr (644,root,root) %verify(not md5 size mtime) /usr/X11R6/lib/X11/fonts/CID/fonts.dir
%dir /usr/X11R6/lib/X11/fonts/local/
%attr (644,root,root) %verify(not md5 size mtime) /usr/X11R6/lib/X11/fonts/local/fonts.dir
/usr/X11R6/lib/X11/xedit/
/usr/X11R6/lib/X11/fs
/usr/X11R6/lib/X11/lbxproxy
/usr/X11R6/lib/X11/proxymngr
/usr/X11R6/lib/X11/rstart
/usr/X11R6/lib/X11/twm
/usr/X11R6/lib/X11/xdm
/usr/X11R6/lib/X11/xinit
/usr/X11R6/lib/X11/xserver
/usr/X11R6/lib/X11/xsm
%if !%{USE_EXTERNAL_XKB_FILES}
/usr/X11R6/lib/X11/xkb
%endif
%ghost /var/log/xdm.errors
%ghost /var/run/xdm.pid
/var/lib/xdm/authdir/
/var/lib/xkb/README
/usr/X11R6/include/X11/pixmaps/
/usr/X11R6/lib/X11/icons/
%ifnarch s390 s390x
/usr/X11R6/lib/X11/getconfig/
/usr/X11R6/lib/X11/xorg.conf.eg
%endif
/usr/share/applications/Xkill.desktop
/usr/share/applications/Xrefresh.desktop
/usr/share/applications/xcalc.desktop
/usr/share/applications/xclipboard.desktop
/usr/share/applications/xload.desktop
/usr/share/applications/xmag.desktop
%if %suse_version > 920
/usr/share/pixmaps/xcalc.png
/usr/share/pixmaps/xclipboard.png
/usr/share/pixmaps/xload.png
/usr/share/pixmaps/xmag.png
%endif
/usr/share/xsessions/twm.desktop
%ifnarch s390 s390x
/var/X11R6/compose-cache/
%endif

%files fonts-75dpi
%defattr(644, root, root, 755)
%dir /usr/X11R6/lib/X11/fonts/75dpi/
%verify(not md5 size mtime) /usr/X11R6/lib/X11/fonts/75dpi/.fonts-config-timestamp
%if ! %BITMAP_ENCODINGS_ON_THE_FLY
%verify(not md5 size mtime) /usr/X11R6/lib/X11/fonts/75dpi/encodings.dir
%endif
%verify(not md5 size mtime) /usr/X11R6/lib/X11/fonts/75dpi/fonts.alias
%if %FC_232
%verify(not md5 size mtime) /usr/X11R6/lib/X11/fonts/75dpi/%{FC_FILE}
%endif
%verify(not md5 size mtime) /usr/X11R6/lib/X11/fonts/75dpi/fonts.dir
%verify(not md5 size mtime) /usr/X11R6/lib/X11/fonts/75dpi/fonts.scale
/usr/X11R6/lib/X11/fonts/75dpi/*.gz

%files doc
%defattr(-, root, root)
%doc /usr/X11R6/lib/X11/doc/
/usr/share/doc/packages/Xorg

%files libs
%defattr(-, root, root)
/usr/X11R6/bin/xauth
%dir /usr/X11R6/lib/X11/locale
%dir /usr/X11R6/lib/X11/locale/%{_lib}
%dir /usr/X11R6/lib/X11/locale/%{_lib}/common
/usr/X11R6/lib/X11/locale/[A-Za-km-z]*
/usr/X11R6/lib/X11/locale/locale.alias
/usr/X11R6/lib/X11/locale/locale.dir
/usr/X11R6/%{_lib}/lib*.so.*
/usr/X11R6/lib/X11/locale/%{_lib}/common/*.so.*
%if !%{USE_EXTERNAL_MESA}

%files Mesa
%defattr(-, root, root)
%dir %{_libdir}/GL/
%{_libdir}/libGL.so
%{_libdir}/lib*.so.*
%{_libdir}/GL/*.so.*
%ifnarch s390 s390x ppc64 %arm
%dir /usr/X11R6/%{_lib}/modules/
/usr/X11R6/%{_lib}/modules/dri/
%endif
%endif

%files man
%defattr(-, root, root)
%doc /usr/X11R6/man/man?/*
# Xserver stuff does not make any sense for S/390
%ifnarch s390 s390x

%files server -f files.xorg-x11-server
%defattr(-, root, root)
%dir /usr/X11R6/%{_lib}/modules
%dir /usr/X11R6/%{_lib}/modules/drivers
%dir /usr/X11R6/%{_lib}/modules/extensions
%dir /usr/X11R6/%{_lib}/modules/fonts
%dir /usr/X11R6/%{_lib}/modules/input
%dir /usr/X11R6/%{_lib}/modules/linux
%dir /usr/X11R6/%{_lib}/modules/multimedia
%dir /usr/X11R6/%{_lib}/modules/updates
%dir /usr/X11R6/%{_lib}/modules/updates/drivers
%dir /usr/X11R6/%{_lib}/modules/updates/extensions
%dir /usr/X11R6/%{_lib}/modules/updates/fonts
%dir /usr/X11R6/%{_lib}/modules/updates/input
%dir /usr/X11R6/%{_lib}/modules/updates/linux
%dir /usr/X11R6/%{_lib}/modules/updates/multimedia
/usr/X11R6/%{_lib}/modules/updates/README.updates
/usr/X11R6/bin/xinit
/usr/X11R6/bin/X
/var/X11R6/bin/X
/usr/X11R6/bin/XFree86
%verify(not mode) /usr/X11R6/bin/Xorg
/usr/X11R6/bin/xf86config
/usr/X11R6/bin/xorgconfig
%ifarch mips
/usr/X11R6/%{_lib}/X11/XF86Config.indy
%endif

%files server-glx
%defattr(-, root, root)
/usr/X11R6/%{_lib}/modules/extensions/libglx.so
/usr/X11R6/%{_lib}/modules/extensions/libGLcore.so
%if !%{USE_EXTERNAL_DRIVERS}
%ifarch %ix86 ia64 x86_64
/usr/X11R6/%{_lib}/modules/drivers/nvidia_drv.so
%endif
%endif
%endif

%files Xnest
%defattr(-, root, root)
/usr/X11R6/bin/Xnest

%files Xvfb
%defattr(-, root, root)
/usr/X11R6/bin/Xvfb

%files Xvnc
%defattr(-, root, root)
/usr/X11R6/bin/Xvnc

%files devel
%defattr(-, root, root)
/usr/X11R6/bin/gccmakedep
/usr/X11R6/bin/imake
/usr/X11R6/bin/makedepend
/usr/X11R6/bin/xcursor-config
/usr/X11R6/bin/xft-config
/usr/X11R6/bin/xmkmf
%if !%{USE_EXTERNAL_MESA}
/usr/X11R6/include/GL/
%else
%dir /usr/include/GL/
/usr/include/GL/glxint.h
/usr/include/GL/glxmd.h
/usr/include/GL/glxproto.h
%endif
%dir /usr/X11R6/include/X11
/usr/include/X11
/usr/X11R6/include/*.h
#/usr/X11R6/include/bitmaps/
/usr/X11R6/include/X11/*.h
/usr/X11R6/include/X11/Xft/
/usr/X11R6/include/X11/extensions/
/usr/X11R6/include/X11/fonts/
/usr/X11R6/include/X11/ICE/
/usr/X11R6/include/X11/SM/
/usr/X11R6/include/X11/Xmu/
/usr/X11R6/include/X11/Xaw/
/usr/X11R6/include/X11/PM/
/usr/X11R6/include/X11/Xcursor/
/usr/X11R6/lib/X11/config/
/usr/X11R6/%{_lib}/lib*.a
/usr/X11R6/%{_lib}/lib*.so
/usr/%{_lib}/pkgconfig/*.pc
%if !%{USE_EXTERNAL_MESA}

%files Mesa-devel
%defattr(-, root, root)
/usr/include/GL/
%{_libdir}/libGLU.a
%{_libdir}/libMesaGLU.a
%{_libdir}/libOSMesa.a
%{_libdir}/libMesaGL.so
%{_libdir}/libGLU.so
%{_libdir}/libMesaGLU.so
%{_libdir}/libOSMesa.so

%files Mesa-devel-static
%defattr(-, root, root)
%{_libdir}/libGL.a
%{_libdir}/libMesaGL.a
%endif

%files Xprt
%defattr(-, root, root)
/usr/X11R6/bin/Xprt
%doc /usr/share/doc/packages/Xorg-Xprt/
%dir /etc/X11/Xsession.d
/etc/X11/Xsession.d/92xprint-xpserverlist.sh
/etc/init.d/xprint
/etc/profile.d/xprint.csh
/etc/profile.d/xprint.sh
/usr/X11R6/bin/xphelloworld
/usr/X11R6/bin/xplsprinters
/usr/X11R6/bin/xprehashprinterlist
/usr/X11R6/bin/xpsimplehelloworld
/usr/X11R6/bin/xpxthelloworld
%dir /usr/X11R6/include/X11/XprintAppUtil
/usr/X11R6/include/X11/XprintAppUtil/xpapputil.h
%dir /usr/X11R6/include/X11/XprintUtil
/usr/X11R6/include/X11/XprintUtil/xprintutil.h

%files fonts-100dpi
%defattr(644, root, root, 755)
%dir /usr/X11R6/lib/X11/fonts/100dpi/
%verify(not md5 size mtime) /usr/X11R6/lib/X11/fonts/100dpi/.fonts-config-timestamp
%if ! %BITMAP_ENCODINGS_ON_THE_FLY
%verify(not md5 size mtime) /usr/X11R6/lib/X11/fonts/100dpi/encodings.dir
%endif
%verify(not md5 size mtime) /usr/X11R6/lib/X11/fonts/100dpi/fonts.alias
%if %FC_232
%verify(not md5 size mtime) /usr/X11R6/lib/X11/fonts/100dpi/%{FC_FILE}
%endif
%verify(not md5 size mtime) /usr/X11R6/lib/X11/fonts/100dpi/fonts.dir
%verify(not md5 size mtime) /usr/X11R6/lib/X11/fonts/100dpi/fonts.scale
/usr/X11R6/lib/X11/fonts/100dpi/*.gz

%files fonts-cyrillic
%defattr(644, root, root, 755)
%dir /usr/X11R6/lib/X11/fonts/cyrillic/
%verify(not md5 size mtime) /usr/X11R6/lib/X11/fonts/cyrillic/.fonts-config-timestamp
%verify(not md5 size mtime) /usr/X11R6/lib/X11/fonts/cyrillic/encodings.dir
%verify(not md5 size mtime) /usr/X11R6/lib/X11/fonts/cyrillic/fonts.alias
%if %FC_232
%verify(not md5 size mtime) /usr/X11R6/lib/X11/fonts/cyrillic/%{FC_FILE}
%endif
%verify(not md5 size mtime) /usr/X11R6/lib/X11/fonts/cyrillic/fonts.dir
%verify(not md5 size mtime) /usr/X11R6/lib/X11/fonts/cyrillic/fonts.scale
/usr/X11R6/lib/X11/fonts/cyrillic/*.gz

%files fonts-scalable
%defattr(644, root, root, 755)
%dir /usr/X11R6/lib/X11/fonts/Type1/
%verify(not md5 size mtime) /usr/X11R6/lib/X11/fonts/Type1/.fonts-config-timestamp
%verify(not md5 size mtime) /usr/X11R6/lib/X11/fonts/Type1/encodings.dir
%if %FC_232
%verify(not md5 size mtime) /usr/X11R6/lib/X11/fonts/Type1/%{FC_FILE}
%endif
%verify(not md5 size mtime) /usr/X11R6/lib/X11/fonts/Type1/fonts.dir
%verify(not md5 size mtime) /usr/X11R6/lib/X11/fonts/Type1/fonts.scale
%ifnarch s390 s390x
%verify(not md5 size mtime) /usr/X11R6/lib/X11/fonts/Type1/fonts.scale.xf86
%endif
/usr/X11R6/lib/X11/fonts/Type1/*.afm
/usr/X11R6/lib/X11/fonts/Type1/*.pfa
/usr/X11R6/lib/X11/fonts/Type1/*.pfb
#%verify(not md5 size mtime) /usr/X11R6/lib/X11/fonts/truetype/encodings.dir
%if %FC_232
%verify(not md5 size mtime) /usr/X11R6/lib/X11/fonts/truetype/%{FC_FILE}
%endif
%verify(not md5 size mtime) /usr/X11R6/lib/X11/fonts/truetype/fonts.dir
%verify(not md5 size mtime) /usr/X11R6/lib/X11/fonts/truetype/fonts.scale.xf86
/usr/X11R6/lib/X11/fonts/truetype/*.ttf
%verify(not md5 size mtime) /usr/X11R6/lib/X11/fonts/truetype/.fonts-config-timestamp

%files fonts-syriac
%defattr(644, root, root, 755)
/usr/X11R6/lib/X11/fonts/truetype/fonts.scale.syriac
/usr/X11R6/lib/X11/fonts/truetype/*.otf
%ifnarch s390 s390x

%files driver-options
%defattr(-, root, root)
/etc/X11/CardModules.addon

%files sdk
%defattr(-, root, root)
/usr/X11R6/%{_lib}/Server
%endif

%clean

%changelog -n xorg-x11
* Thu Jun 08 2006 - sndirsch@suse.de
- p_xnest-ignore-getimage-errors.diff:
  * ignores the X error on GetImage in Xnest (Bug #174228)
* Fri Jun 02 2006 - sndirsch@suse.de
- pc_xf86-pci.diff:
  * fixes broken BIOS reading (due to changes in recent Linux
  kernels), which is required for dual card support (Bug #171453,
  X.Org Bug #6751)
- removed no longer required patch
  "p_xlib_skip_select_substructure_redirect.diff" again (Bug #151836)
* Wed May 31 2006 - sndirsch@suse.de
- generate /usr/X11R6/lib/X11/fonts/misc/fonts.dir on s390/s390x
  during %%install (Bug #178315)
* Tue May 30 2006 - sndirsch@suse.de
- fixed check for empty /usr/X11R6/lib/X11/fonts/misc/fonts.dir
  (Bug #178315)
* Mon May 29 2006 - sndirsch@suse.de
- p_xlib_skip_select_substructure_redirect.diff:
  * fool java swing apps that no WM is running (Bug #151836)
* Mon May 22 2006 - sndirsch@suse.de
- p_xlib_skip_ext_env.diff:
  * added support for disabling extensions through environment
  variables (Bug #167317)
- no longer remove NVIDIA installer in %%pre of xorg-x11-server-glx,
  since it's no longer conflicting with the NVIDIA driver package
  (Bug #175683)
- make sure that /usr/X11R6/lib/X11/fonts/misc/fonts.dir is not
  empty (Bug #178315)
* Fri May 19 2006 - sndirsch@suse.de
- /etc/X11/xdm/Xsetup:
  * start compiz on gdm when GLX_EXT_texture_from_pixmap is
  available to fix horrible performance (Bug #173901)
* Thu May 11 2006 - sndirsch@suse.de
- p_pci-legacy-mmap.diff:
  * fixes legacy area mapping on IA64 (Bug #166112)
- p_xorg-fbcompose-radek2.diff:
  * fixes massive Xrender corruption (Bug #152730, X.Org Bug #6827)
* Tue May 09 2006 - sndirsch@suse.de
- %%post of xorg-x11-server: "/dev/mouse" --> "/dev/input/mice" in
  /etc/X11/xorg.conf (Bug #172260)
* Fri Apr 28 2006 - sndirsch@suse.de
- /etc/X11/xdm/Xsetup: moved the sleep to the correct location
  (Bug #149957)
* Thu Apr 27 2006 - sndirsch@suse.de
- p_xrender-mitri.diff:
  * fixed buffer overflow in Xrender (CVE-2006-1526, Bug #168712)
* Mon Apr 24 2006 - sndirsch@suse.de
- fixed sys.xsession when ~/.xinitrc is not executable (Bug #168600)
* Fri Apr 21 2006 - sndirsch@suse.de
- updated p_mouse-wheel-multibit.diff (Bug #144682, comment #20)
* Thu Apr 20 2006 - sndirsch@suse.de
- p_mouse-wheel-multibit.diff:
  * Overhaul of wheel processing. Does work correctly with multibit
  zaxis events now (mhopf, Bug #144682)
* Wed Apr 19 2006 - sndirsch@suse.de
- removed XLC_LOCALE files with critical license (Bug #153744)
* Thu Apr 13 2006 - sndirsch@suse.de
- added /usr/X11R6/%%{_lib}/modules/updates/README.updates to
  document Xserver module update mechanism
* Wed Apr 12 2006 - sndirsch@suse.de
- p_default-module-path.diff:
  * enhanced module search path for driver updates (FATE #300553)
* Fri Apr 07 2006 - sndirsch@suse.de
- only change xorg.conf file during system update (Bug #162789)
* Tue Apr 04 2006 - sndirsch@suse.de
- xorg-x11 provides/obsoletes XFree86-Xprt/XFree86-driver-options
* Fri Mar 31 2006 - sndirsch@suse.de
- xdm.tar.gz: converted to .gz format (has been .bz2)
* Fri Mar 31 2006 - werner@suse.de
- Do not use killall within the xdm scripts to avoid to kill xvkbd
  of other running sessions maybe local or remote (bug #149957)
- Avoid error message of not existent device tty0 (bug #162365)
* Thu Mar 30 2006 - sndirsch@suse.de
- p_x86_renderinit.diff:
  * should fix the Xrender related segfault (Bug #152730, comment #39)
* Tue Mar 28 2006 - sndirsch@suse.de
- p_mappciBIOS_complete.diff:
  * fixes system hang (IERR on PCI bus) on Dell (Bug #151644)
- p_xauth.diff:
  * fixed remaining issues (dmueller, Bug #98627/147691)
* Sun Mar 26 2006 - sndirsch@suse.de
- p_setxkbmap.diff:
  * fixed invalid free() in setxkbmap (Bug #71244)
* Fri Mar 24 2006 - sndirsch@suse.de
- p_pci-ce-x.diff:
  * fixes PCI bus scanning on CE systems (pci-pci bridges)
  (Bug #147261)
* Wed Mar 22 2006 - sndirsch@suse.de
- p_xmodmap.diff: simpler warning message (Bug #154357)
* Mon Mar 13 2006 - sndirsch@suse.de
- p_zx2_pcie.diff:
  * IA64 zx2 fix (Bug #157610)
* Mon Mar 13 2006 - sndirsch@suse.de
- kill xvkbd at startup to prevent multiple xvkbds running
  (Bug #149957, comments #10/11)
* Mon Mar 13 2006 - hpj@suse.de
- Make sure the scripts in xinitrc.d are executed on login.
  (FATE #300505)
* Wed Mar 08 2006 - sndirsch@suse.de
- cleanup: removed glide stuff (Bug #156093)
* Mon Mar 06 2006 - sndirsch@suse.de
- p_xmodmap.diff:
  * no longer need to specify the values for all available buttons
  (Bug #154357)
* Wed Mar 01 2006 - sndirsch@suse.de
- p_xkills_wrong_client.diff:
  * This patch has unveiled two other problems. One is rather
  serious as there seems to be a non-zero possibility that the
  Xserver closes the wrong connection and this closes the wrong
  client when it looks for stale sockets of clients that have
  disappeared (eich, Bug #150869)
- p_twm_sig11.diff:
  * twm can segfault when it cannot collect attribute information
  on a window that has been destroyed before it got a chance to
  collect it's attribute. twm seems to assume that it is always
  able to collect this information and disregards the error if
  the function that attempts to collect it fails (eich, Bug #150869)
* Sun Feb 26 2006 - sndirsch@suse.de
- adjusted PreReq of xorg-x11-server to latest changes in %%post
* Sat Feb 25 2006 - sndirsch@suse.de
- disabled DRI when switching to radeon driver (Bug #152473)
- disabled DEBUG info for ACPI code (Bug #153442)
* Wed Feb 22 2006 - sndirsch@suse.de
- added "Provides:  locale(xorg-x11:ru)" to xorg-x11-fonts-cyrillic
  package
* Mon Feb 20 2006 - sndirsch@suse.de
- p_pci-ia64.diff:
  Mach64 driver bails out on ia64 because it cannot map device
  memory. It turns out that some bogus and unneeded code attempts
  to find the root bridge of the device and fails to do so proberly
  as there this host-to-pci bridge is not existant. This code has
  been around for years although it completely unclear what it had
  been intended for. Fixing this by eliminating the bogus code.
  (eich, Bug #145953)
* Mon Feb 20 2006 - sndirsch@suse.de
- moved /usr/X11R6/bin/X and /var/X11R6/bin/X symlinks from %%post
  to filelist of xorg-x11-server to prevent these being removed
  during a package update
* Fri Feb 17 2006 - schwab@suse.de
- Fix last change.
* Fri Feb 17 2006 - sndirsch@suse.de
- strip X11 locale libs (Bug #151801)
* Thu Feb 16 2006 - sndirsch@suse.de
- Xgl related change: /usr/X11R6/bin/X should no longer be a
  symlink to Xorg and packaged; instead create symlinks
  /usr/X11R6/bin/X --> /var/X11R6/bin/X --> /usr/X11R6/bin/Xorg
  in %%post
* Wed Feb 15 2006 - sndirsch@suse.de
- p_xorg_acpi.diff:
  * try to reconnect to acpid when acpid is no longer available
  (Bug #148384)
* Mon Feb 13 2006 - sndirsch@suse.de
- /etc/X11/xdm/Xsetup:
  * start xvkbd (virtual keyboard) if a TabletPC is detected
  (Bug #149957, FATE #300345)
* Thu Feb 09 2006 - sndirsch@suse.de
- p_xrdb.diff:
  * fix xrdb when hostname is set to "(none)" (Bug #149007)
* Mon Feb 06 2006 - sndirsch@suse.de
- fixed filelist on x86, ppc64 and s390
* Thu Feb 02 2006 - sndirsch@suse.de
- p_xorg-compositefastpath-4320.diff:
  * improves Fastpath from XAAComposite (Bug #117163)
* Wed Feb 01 2006 - sndirsch@suse.de
- ps_parser.diff:
  * build libxf86config.a also on s390/s390x (Bug #145823)
* Mon Jan 30 2006 - sndirsch@suse.de
- p_lnx_Kbd.diff:
  * fixes console switching on ppc (Bug #144353)
* Mon Jan 30 2006 - sndirsch@suse.de
- p_xf86Mode.diff:
  * removes wrong warning (Bug #139510, comment #31)
- pc_trident.diff:
  * adds XGI (aka Trident) Volari XP5 support (Alan Hourihane)
* Wed Jan 25 2006 - mls@suse.de
- converted neededforbuild to BuildRequires
* Sat Jan 21 2006 - sndirsch@suse.de
- mkallcomposecaches.sh:
  * disabled authentication for Xvfb start (Bug #144617)
* Fri Jan 20 2006 - sndirsch@suse.de
- p_khmer-locale.diff:
  * km_KH locale support (Bug #144397)
* Wed Jan 18 2006 - sndirsch@suse.de
- CardModules.addon:
  * removed drivers, for which options can be detected during
  runtime now (ati, r128, nv)
  * updated driver options: radeon(X.Org 6.9/7.0), fglrx(8.21.5),
  nvidia (1.0-8178)
  * added options for cirrus driver (X.Org 6.9/7.0)
* Tue Jan 17 2006 - sndirsch@suse.de
- p_khmer-compose.diff:
  * added required compose entries for Khmer (Bug #143348)
* Tue Jan 17 2006 - sndirsch@suse.de
- p_ppc64.diff:
  * fixes build on ppc64 (<asm/memory.h> no longer available)
* Tue Jan 17 2006 - sndirsch@suse.de
- fixed build on s390/s390x
* Mon Jan 16 2006 - sndirsch@suse.de
- p_evdev_abs.diff:
  * adds support for absolute coordinate mice to evdev (Bug #142649)
* Thu Jan 12 2006 - sndirsch@suse.de
- p_mouse_wheelemu_fix_x-5071.diff:
  * fixes mouse wheel emulation (X.Org Bug #5071)
* Wed Jan 11 2006 - werner@suse.de
- Check for an already running dbus session before launching a
  new session (bug #118291).
* Wed Jan 11 2006 - sndirsch@suse.de
- removed xsload tarball; obsoleted by ps_showopts.diff (see below)
* Wed Jan 11 2006 - schwab@suse.de
- p_pci-domain.diff: Fix off-by-one domain numbering.
* Mon Jan 09 2006 - sndirsch@suse.de
- ps_showopts.diff (Marcus Schaefer <ms@suse.de>):
  * new Xserver "-showopts" option to print available driver
  options (Bug #137374)
* Thu Jan 05 2006 - sndirsch@suse.de
- p_xorg_rom_read.diff:
  * read rom in big chunks instead of byte-at-a-time (Bug #140811)
- no longer create/touch fonts.cache files for fontconfig > 2.3.2
* Tue Jan 03 2006 - sndirsch@suse.de
- p_xft_register.diff:
  * new fontconfig objects needs to be registered first (Bug #141216)
* Thu Dec 22 2005 - sndirsch@suse.de
- updated to X.Org 6.9.0 (final release)
* Mon Dec 19 2005 - sndirsch@suse.de
- added previously unpackages files to filelist
* Fri Dec 16 2005 - sndirsch@suse.de
- updated to X.Org 6.9 RC4 (final full Release Candidate)
* Thu Dec 15 2005 - werner@suse.de
- Fix Xsession script to work with new bash 3.1 (bug #139189)
* Tue Dec 13 2005 - schwab@suse.de
- Fix misaligned compose cache.
* Wed Dec 07 2005 - sndirsch@suse.de
- xsload: fixed nvidia driver suffix (.o --> .so)
* Sun Dec 04 2005 - sndirsch@suse.de
- updated to X.Org 6.9 RC3
* Fri Dec 02 2005 - sndirsch@suse.de
- ps_suse.diff:
  * xft.pc: removed xproto requires, which only exists for modular
  build
- ps_disable-drivers.diff:
  * disabled build of i810 driver (#130718)
* Fri Dec 02 2005 - sndirsch@suse.de
- CardModules.addon:
  * added new "CapabilitiesEx" option for fglrx driver
* Thu Dec 01 2005 - sndirsch@suse.de
- update to current X.Org CVS (2005-12-01)
  * obsoletes pc_mouse.diff
- adjusted patches (p_xauth.diff, ps_suse.diff)
* Tue Nov 29 2005 - sndirsch@suse.de
- p_pci-domain.diff:
  * fixes Xserver crash on SGI Altix machines (#132308)
* Mon Nov 28 2005 - sndirsch@suse.de
- p_vga-crashfix.diff:
  * fixes vga driver crash (#133989)
* Sun Nov 27 2005 - sndirsch@suse.de
- fixed build on s390/s390x
* Sun Nov 27 2005 - sndirsch@suse.de
- switched to external built drivers (ati, mga, nv, via, sis)
* Fri Nov 25 2005 - schwab@suse.de
- Use $RPM_OPT_FLAGS for keygen.
* Wed Nov 23 2005 - sndirsch@suse.de
- removed obsolete X.Org wacom driver (use external wacom driver)
* Tue Nov 22 2005 - sndirsch@suse.de
- /etc/X11/xdm/Xsetup: fixed gdm detection (#134986)
* Tue Nov 22 2005 - sndirsch@suse.de
- ps_acpi.diff (obsoletes p_disable-acpi.diff):
  * disable fallback to proc acpi event interface (#133440)
* Mon Nov 21 2005 - sndirsch@suse.de
- fixed syntax error in Xsession script
* Mon Nov 21 2005 - werner@suse.de
- Be sure that we use system X session script for forced session
  type to have ssh-agent and gpg-agent around.
* Mon Nov 21 2005 - sndirsch@suse.de
- /etc/X11/xdm/Xsession:
  * fixed syntax error
  * fixed exec_login call, when WINDOWMANAGER is set to a command
  with arguments, e.g. "dbus-launcher <options> $WM"
* Sun Nov 20 2005 - sndirsch@suse.de
- fixed build on 10.0
* Fri Nov 18 2005 - sndirsch@suse.de
- p_disable-acpi.diff:
  * disables ACPI code for now (#133440, X.Org #4718)
* Fri Nov 18 2005 - werner@suse.de
- Move all common code of Xsession and Xinit scripts into one file
- The choosen window manager wins over the users scripts (#134311)
- Make it possible to use Xkbmap files
- Put template xinitrc script into xdm tar ball
* Thu Nov 17 2005 - sndirsch@suse.de
- %%post of xorg-x11-server: "r128" --> "ati" in /etc/X11/xorg.conf
* Wed Nov 16 2005 - uli@suse.de
- enable server-glx on ARM
* Tue Nov 15 2005 - sndirsch@suse.de
- xsload: fixed driver suffix (.o --> .so)
- CardModules.addon: added nvidia driver options (no longer
  generated during SaX2 build)
- added mfbmap.h/mfbunmap.h to SDK on ppc64 (required for building
  ATI driver via SDK)
* Mon Nov 14 2005 - sndirsch@suse.de
- pc_mouse.diff:
  * mouse driver fix from CVS
* Fri Nov 11 2005 - sndirsch@suse.de
- updated to X.Org 6.9 RC2
  * obsoletes p_radeon_mga_sis_metamodes.diff,
  p_xorg-mousebuttons-4915.diff
- adjusted p_bug96328.diff, p_xauth.diff, ps_suse.diff
* Mon Nov 07 2005 - sndirsch@suse.de
- switched to external built Mesa
- ps_glxproto.diff:
  * new MESA_render_texture extension for Xgl (dreveman/mhopf)
* Fri Nov 04 2005 - sndirsch@suse.de
- fixed build for fontconfig 2.3.9x
* Fri Nov 04 2005 - schwab@suse.de
- Use $RPM_OPT_FLAGS.
* Wed Nov 02 2005 - sndirsch@suse.de
- update to current X.Org CVS (2005-11-02)
* Fri Oct 28 2005 - sndirsch@suse.de
- p_xorg-mousebuttons-4915.diff:
  * adds ButtonMapping option (X.Org #4915)
* Thu Oct 27 2005 - sndirsch@suse.de
- added xf1bpp.h/xf4bpp.h to SDK on ppc64 (required for building
  ATI driver via SDK)
- adjusted build for fontconfig downgrade
* Thu Oct 27 2005 - werner@suse.de
- Do not use restricted shells for script execution
* Wed Oct 26 2005 - werner@suse.de
- Use the login shell of the user to run the logon scripts
* Wed Oct 26 2005 - sndirsch@suse.de
- SuSEconfig.xdm:
  * Xgl specific changes
* Tue Oct 25 2005 - werner@suse.de
- Check for PROFILEREAD/CSHRCREAD before souring profiles
* Tue Oct 25 2005 - sndirsch@suse.de
- update to current X.Org CVS (2005-10-25)
  * obsoletes p_xcursor-reset-theme-name.diff
  * adjusted p_fixes-cvs.diff, p_freetype-crashfix.diff
- disabled workaround for Bug #120331 (p_gcc410.diff)
- enabled build of external built drivers (xorg-x11-driver-video)
  again (DRI problems with different size of I830DRIRec structure)
* Sun Oct 23 2005 - sndirsch@suse.de
- ps_disable-drivers.diff:
  * disable build of external built drivers (xorg-x11-driver-video)
* Fri Oct 21 2005 - sndirsch@suse.de
- p_sdk.diff:
  * added xf86xvpriv.h/i2c_def.h required by sis/ati driver to SDK
* Fri Oct 21 2005 - sndirsch@suse.de
- prepared build for external built Mesa
- removed obsolete patches (ps_mga-dri.diff/ps_x86-64_ioctl32.diff)
* Tue Oct 18 2005 - sndirsch@suse.de
- HALlib-4.2.tar.gz: updated HAL library
- no longer install libglide (disables 3Dfx DRI support)
* Mon Oct 17 2005 - sndirsch@suse.de
- no longer create XF86Config backup files during -server %%post
* Thu Oct 13 2005 - sndirsch@suse.de
- update to current X.Org CVS (2005-10-13)
  * obsoletes p_xf86rules_dll.diff
  * adjusted ps_vnc.diff
- removed xauth_switch_to_sun-des-1 from filelist to get rid of ksh
  deps (X.Org #1407)
- use RPM_OPT_FLAGS for building vncviewer encoding plugins
* Mon Oct 10 2005 - sndirsch@suse.de
- p_gcc410.diff:
  * workaround for new gcc 4.1.0 compile failure (Bug #120331)
- font cache file name has changed: fonts.cache-1 --> fonts.cache-2
* Thu Oct 06 2005 - sndirsch@suse.de
- p_fbdev.diff:
  * warning fix
* Sat Oct 01 2005 - sndirsch@suse.de
- update to current X.Org CVS (2005-10-02)
  * removed obsolete patches and sources
  * adjusted patches
  * adjusted filelist
- p_64bit-clean.diff:
  * required for 64bit clean build on SUSE
- removed km_drm subpackage (no longer used since SUSE 9.3)
* Wed Sep 28 2005 - sndirsch@suse.de
- p_bugzilla-117193-luit-sometimes-hangs.diff:
  * fixes luit hangups (#117193)
- xdm/Xsetup: fixed typo, beautified script (#118255)
* Wed Sep 28 2005 - sndirsch@suse.de
- p_nv-crashfix.diff:
  * finally nv driver livelock resolved (#113203)
* Sat Sep 24 2005 - sndirsch@suse.de
- p_nv-accel.diff:
  * Fix possible cause of some acceleration instability on some
  GeForce6xxx parts (#113203)
* Sun Sep 18 2005 - sndirsch@suse.de
- pc_nv-pixmap.diff:
  * Fix a potential problem with pixmap cache corruption on GeForce
  6xxx and 7xxx parts (#113203)
* Tue Sep 13 2005 - sndirsch@suse.de
- fix build on beta-<arch>
- fixed and beautified xfs init script (#98513)
* Mon Sep 12 2005 - sndirsch@suse.de
- p_xcursor-reset-theme-name.diff:
  * let XcursorSetTheme(display, NULL) set the theme to the initial
  default rather than to NULL (#114490, X.Org #4244)
* Sat Sep 10 2005 - sndirsch@suse.de
- ps_mga-dri.diff:
  * required for 32bit DRI client support (Bug #106890)
- ps_x86-64_ioctl32.diff:
  * drm_handle_t --> drmHandle (Bug #106890)
* Fri Sep 09 2005 - sndirsch@suse.de
- p_CAN-2005-4095.diff:
  * Security patch (#113227)
* Thu Sep 08 2005 - sndirsch@suse.de
- pc_i810-bug114144.diff:
  * prevent undesireable side effects when accel is disabled
  (#114144, comments #18-21)
* Wed Sep 07 2005 - sndirsch@suse.de
- pc_savage.diff:
  * fixed 24bit color depth (#113810)
* Tue Sep 06 2005 - sndirsch@suse.de
- pc_i810-bug114144.diff:
  * fixes console switch crash and gamma correction (Bug #114144)
* Mon Sep 05 2005 - coolo@suse.de
- only kill preload if it's installed (#115201)
* Fri Sep 02 2005 - sndirsch@suse.de
- removed ghostscript-mini from #neededforbuild
- p_bug3822.diff/p_bug4243.diff/p_bug4247.diff
  * fixed failure in handling dynamic memory (Bug #113745,
  X.Org Bug #3822/4243/4247)
* Fri Aug 26 2005 - sndirsch@suse.de
- p_i810-refresh.diff:
  * refresh rates fixes (Bug #102345)
* Thu Aug 25 2005 - sndirsch@suse.de
- pc_dpms.diff:
  * added missing pieces in r128_driver.c (eich, Bug #105511)
* Thu Aug 25 2005 - coolo@suse.de
- kill pending preload processes in Xstartup
* Wed Aug 24 2005 - sndirsch@suse.de
- p_kbd.diff:
  * save us one second during Xserver start
* Mon Aug 22 2005 - sndirsch@suse.de
- ps_via.diff:
  * fixed via DRI support (Bug #106015)
* Mon Aug 22 2005 - werner@suse.de
- Do not remove an existing ~/.xsession-error (bug #105939)
* Fri Aug 19 2005 - sndirsch@suse.de
- pc_dpms.diff:
  * removed r128 hunk for now (Bug #105511)
* Fri Aug 19 2005 - sndirsch@suse.de
- p_enable-via-on-AMD64.diff:
  * enable via driver build on AMD64 (Bug #98907, Comment #27/28)
* Thu Aug 18 2005 - sndirsch@suse.de
- simplified filelist
* Wed Aug 17 2005 - sndirsch@suse.de
- updated exa module/sis driver to current CVS version (2005-08-17)
  * Fix the exa pixmap offset/pitch alignment to deal with non-POT
  alignment requirements.  MGA, notably, uses a multiple of 3 in
  some cases.
  * Rename the pixmap offset/pitch alignment fields to more clearly
  state their meaning.
- adjusted ps_x86-64_ioctl32.diff
* Mon Aug 15 2005 - sndirsch@suse.de
- fixed i915 DRI support (Bug #103135)
  * dri-i915-Mesa-6.2_branch_060815.tar.bz2:
- i915 DRI driver (Mesa 6.2 branch) with support for i915GM/i945G
  * ps_dri-i915.diff:
- required for using Mesa 6.2 i915 DRI driver
- removes debug output for non-i386 platforms
  * makes external package x11-dri-i915 obsolete again
* Sun Aug 14 2005 - sndirsch@suse.de
- pc_ati-RN50.diff:
  * support for ATI RN50/ES1000 chipsets
* Sat Aug 13 2005 - sndirsch@suse.de
- updated i810/nv/sis drivers to current CVS version (2005-08-13)
  * obsoletes pc_i810-bios.diff, pc_i810-gamma.diff,
  pc_nv-20050203.diff, pc_nv-dpms-gf4.diff, pc_nv-dpms.diff,
  pc_nv-g70.diff, pc_nv-limitmem.diff, pc_sis-bufsize.diff,
  pc_sis-sisctrl.diff
- ps_via-i2c_dpms.diff --> ps_via.diff
- updated exa module to current CVS version (2005-08-13)
* Thu Aug 11 2005 - sndirsch@suse.de
- via-missing-CVS-2005-07-07.tar.bz2:
  * missing new XvMC files from CVS (Bug #104090)
- p_radeon_mga_sis_metamodes.diff:
  * allow the use of ',' and ';' as delimiter for metamodes
  (Bug #104069)
- pc_sis-bufsize.diff:
  * Rename BUFSIZ to something else to avoid confusion with stdio's
  BUFSIZ
* Wed Aug 10 2005 - sndirsch@suse.de
- xkbvariant needs to be "qwerty,basic" for "sk/cz,us" (Bug #102657)
* Tue Aug 09 2005 - sndirsch@suse.de
- adjust keyboard configuration during update (Bug #102657)
  * cz_qwerty --> cz(qwerty)
  * sk_qwerty --> sk(qwerty)
  * el --> gr
- pc_ati-xpress.diff:
  * radeon XPRESS chips are actually RV3xx based
* Mon Aug 08 2005 - sndirsch@suse.de
- pc_i810-gamma.diff:
  * Enable gamma correction bit even for 8bit modes. The pipeconf
  register handles the real enablement. (alanh)
- p_sr_CS-compose.diff/p_sr_CS-locales.diff:
  * support for sr_CS locale (Bug #95813)
- pc_sis-sisctrl.diff:
  * add some convenience for SiSCtrl
- rcxfs: fix insecure tempfile usage (Bug #98513)
* Sun Aug 07 2005 - sndirsch@suse.de
- pc_i810-bios.diff
  * Adjust newPipe code for BIOS's starting at 1200 (alanh)
- pu_macintosh-kb.diff:
  * EJEC --> EJCT
- pc_nv-limitmem.diff:
  * Workaround for 512 Meg video cards (can only map 256 Meg of
  it). (Mark Vojkovich)
- replace "fglrx" with "radeon" video driver during update
* Thu Aug 04 2005 - ro@suse.de
- added patch for mouse detection fallback (#96328)
- added patch for better cairo performance (#100469)
* Fri Jul 29 2005 - sndirsch@suse.de
- reverted last change, i.e. use external xkb files again
  (Bug #98980)
* Thu Jul 28 2005 - sndirsch@suse.de
- use internal xkb files again; currently to big problems
  (Bug #98980)
* Thu Jul 28 2005 - sndirsch@suse.de
- adjusted ps_x86-64_ioctl32.diff
* Wed Jul 27 2005 - sndirsch@suse.de
- updated i810 driver (CVS 2005-07-27)
  * Fix non-DRI builds (X.Org Bug #3850)
  * Bump the DDX version to 1.4.0 to indicate the removal of
  drmAddress. Thus allowing 32/64bit clients to cohabit.
- p_xauth.diff:
  * Let X authorization be tolerant to hostname changes (Bug #98627)
* Mon Jul 25 2005 - sndirsch@suse.de
- p_new-locales.diff:
  * support for new indic/african locales (Bug #98262)
* Sat Jul 23 2005 - sndirsch@suse.de
- p_xft-crashfix.diff
  * fixes Xft crash; required by Gnome
* Fri Jul 22 2005 - sndirsch@suse.de
- removed patch for non-fatal build warnings, which was never
  reviewed by anyone and nobody is interested in upstream
* Tue Jul 19 2005 - sndirsch@suse.de
- added missing "xorg-x11-Mesa" Requires for xorg-x11-Mesa-devel
- p_freetype-crashfix.diff:
  * fixes freetype related crash with freetype 2.1.10 (Bug #97202)
- xf4vnc-20050720.tar.bz2:
  * latest xf4vnc CVS version
  * obsoletes p_vnc-crash.diff
- udpated sis driver (CVS 2005-07-20)
  * Some fixes for multiple cards. Small fix for mode switching
  on newer machines. Prepare for Dave's PCI cleanup.
* Tue Jul 19 2005 - sndirsch@suse.de
- updated sis driver
  * Fix xv offscreen memory allocation for Xv etc.
* Mon Jul 18 2005 - sndirsch@suse.de
- updated sis driver
  * minor fixes
- added xglx support to SuSEconfig.xdm
* Fri Jul 15 2005 - sndirsch@suse.de
- vnc-crash.diff --> p_vnc-crash.diff
- updated "sis" driver
  * some minor fixes (mainly for XGI)
* Sun Jul 10 2005 - schwab@suse.de
- Fix crash in vnc module.
* Sun Jul 10 2005 - sndirsch@suse.de
- pc_nv-g70.diff (X.Org Bug #3740)
  * Change some console restore code for NV11.  Hopefully, we can
  more reliably restore the console for desktop systems using DVI.
  This may correct a recent regression on NV11. Also, new PCI IDs
  (G70).
- i810-20050710.tar.bz2 / ps_i810.diff
  * latest i810 driver from CVS
  changes: Copy mode strings upon mode copy (alanh)
  * obsoletes pc_i810*/pc_i915* patches
- updated "exa" module
  * Patch from Thomas Winischhofer to kick out all pixmaps to system
  ram upon a VT switch and vice versa when returning.
* Fri Jul 08 2005 - sndirsch@suse.de
- updated "exa" module
  * mark drawable as dirty on copying/painting windows
- updated "sis" driver
  * clean up VBFlags mess
* Fri Jul 08 2005 - sndirsch@suse.de
- updated "exa" module (CVS 20050708)
* Thu Jul 07 2005 - sndirsch@suse.de
- p_xlib-threadsafe.diff:
  * don't have the input filter wrapped by the display lock
  (Bug #55962)
- update via/sis driver to current CVS (2005-07-07)
  * obsoletes ps_via-XvMC.diff
  * adjusted ps_via-i2c_dpms.diff
  * adjusted ps_x86-64_ioctl32.diff
  * obsoletes xgi driver (xorg.conf: xgi --> sis)
- update "exa" module (vtSema fix)
* Thu Jul 07 2005 - sndirsch@suse.de
- pc_i810-nullcheck.diff:
  * NULL check
- pc_i810-xvideo.diff [KEEP?]
  * Fix Xvideo when operating in one line mode and video is pushed
  off the top of the screen. Also some fixes for Xvideo skew in
  certain resolutions.
- added "exa" module
* Wed Jul 06 2005 - sndirsch@suse.de
- use external xkb data files from xkeyboard-config package
* Sat Jul 02 2005 - meissner@suse.de
- use RPM_OPT_FLAGS for ppc, ppc64 and amd64 (ia64, s390 still
  missing but difficult).
* Fri Jul 01 2005 - sndirsch@suse.de
- build i915 DRI module separately (x11-dri-i915 package);
  regenerated pc_i915GM.diff because of this
* Thu Jun 30 2005 - sndirsch@suse.de
- fixes from CVS, which were backported to X.Org 6.8.2 by Benjamin
  Herrenschmidt (Bug #76860)
  * pc_radeon-no-vga.diff
  * pc_radeon-fix-crtc2-offset-cntl.diff
  * pc_radeon-fix-pll-probing.diff
  * pc_radeon-display-bandwidth-calc-fix.diff
  * pc_radeon-fix-mergedfb-bios-dividers.diff
  * pc_radeon-surface-cntl-dual-head.diff
  * pc_radeon-pll2-tmds-no-odd-value.diff
  * pc_radeon-reverse-ddc-option.diff
  * pc_radeon-lvds-probe-pll.diff
  * pc_radeon-fix-divider-select.diff
  * pc_radeon-pll-errata-workarounds.diff
  * pc_radeon-release-i2c-lines.diff
  * pc_radeon-fix-one-mode-ddc.diff
* Wed Jun 29 2005 - sndirsch@suse.de
- pc_nv-dpms-gf4.diff
  * Experimental DPMS support for GeForce4 and later laptops (X.Org
  Bug #3657)
- pc_radeon-r300-dri.diff [KEEP?]
  * required to get DRI support on Radeon >= R300 chips (Bug #91439)
* Tue Jun 28 2005 - sndirsch@suse.de
- pc_i810-check_vesamodes.diff:
  * add support to check the in-built VESA mode list (alanh)
* Sun Jun 26 2005 - sndirsch@suse.de
- pc_radeon_new_pciids.diff:
  * add new Radeon PCI Ids (Bug #76860, X.Org Bug #2827)
  * obsoletes pc_radeon-5969.diff
* Thu Jun 23 2005 - sndirsch@suse.de
- CardModules.addon: added options for fglrx driver (#93519)
* Tue Jun 21 2005 - schwab@suse.de
- Don't strip debug from *.so files.
* Fri Jun 17 2005 - sndirsch@suse.de
- p_libXau-fpic.diff:
  * build libXau with -fPIC (Bug #91187)
- new p_xlc-locale.diff
  * added more encodings (X.Org Bug #2676)
* Mon Jun 13 2005 - sndirsch@suse.de
- pc_i810-resume.diff:
  * added missing hunk
* Mon Jun 13 2005 - sndirsch@suse.de
- removed USE_FORTIFY flags which resulted in undefined references
* Thu Jun 09 2005 - sndirsch@suse.de
- pc_i810-mode_validation.diff
  * Fix the mode validation such that using function 5f05 to set
  the refresh rate works again (alanh)
- pc_i810-resume.diff (X.Org #3496)
  * Remove a bogus check for DRM 1.2 for resume functionality as it's
  been present since 1.1 (alanh)
* Wed Jun 08 2005 - sndirsch@suse.de
- pc_i810-text_restore.diff:
  * Fix text restoration when display switching has been activated
  and we could be potentially on a different display than the
  initial one (alanh)
* Tue Jun 07 2005 - sndirsch@suse.de
- pc_i810-video.diff (X.Org #3436)
  * Fix some offset, pitch and overlay scaler size problems with
  the video overlay. Solves various spontaneous lockups (alanh)
* Thu Jun 02 2005 - uli@suse.de
- fixed to build on ARM
* Wed Jun 01 2005 - sndirsch@suse.de
- pc_i810-945g.diff:
  * support for Intel 945G
* Wed May 25 2005 - sndirsch@suse.de
- pc_i810-custom_modes.diff (alanh)
  * Change the sequence on how refresh rates are set in the
  i830 driver. This works much better with custom modelines.
* Mon May 23 2005 - sndirsch@suse.de
- pc_dpms.diff
  * Explicitely disable DPMS power states during close screen.
  Fix macro that takes a value and a mask of bits to modify
  to be behave evquvalently if the bits that should remain
  unchanged are set or unset in the value (X.Org Bugzilla #3369).
* Sat May 21 2005 - sndirsch@suse.de
- pc_i810-display_switch
  * Much better display switching support for mobile chipsets using
  the Fn+F? combination keys. Add DirectColor support. Add gamma
  correction support. (X.Org #2339,1064,3055)
- pc_i810-e7221.diff
  * Support the Intel E7221 server chipset (X.Org #2585)
- pc_i810-shadowfb.diff
  * Add shadowFB support to Intel driver (Dima Dorfman) (X.Org #3292)
- pc_i810-cvs050521.diff
  * remaining differences to current CVS from 05-05-21
* Tue May 17 2005 - sndirsch@suse.de
- adjusted pc_savage.diff; enabled it
* Tue May 17 2005 - sndirsch@suse.de
- p_xkb-el.diff
  * greek keyboard fix (Bug #84008)
- pc_savage.diff (X.Org Bugzilla #3309); disabled for now!
  Set the hardware to 8bit CLUT mode in 8 bpp. We used to flag an
  8 bit DAC to DDX but did not make sure it actually was running
  in 8 bit mode.
  On Savage4 the HW cursor doesn't seem to be truecolor in 8bpp
- not even with the streams engine running.
  Fix SavageProbeDDC() to load vbe module and initialize it before
  using it.
- gcc4/sentinel patches now in CVS (X.Org Bug #3268)
  * p_gcc4.diff     --> pc_gcc4.diff
  * p_sentinel.diff --> pc_sentinel.diff
* Sun May 15 2005 - sndirsch@suse.de
- fixed some of the uninitialized warnings
* Mon May 09 2005 - sndirsch@suse.de
- p_vesa-modeset.diff:
  * VBE Set Mode (0x02) to not clear the screen causes problems
  on some BIOSes. This fix adds an option to disable it
  (Bug #80333, X.Org Bug #3246).
- p_vesa-r100.diff:
  * Don't call VBESetGetDACPaletteFormat() in the vesa driver for
  modes with depth > 8. This fixes a problem with a Toshiba R100
  laptop. (Bug #80333)
* Wed May 04 2005 - sndirsch@suse.de
- xgi driver build moved to x11-driver-xgi package
- p_sdk.diff: panoramiXproto.h requrired for compiling xgi driver
* Wed May 04 2005 - sndirsch@suse.de
- Requires: xf86tools --> x11-tools
* Wed May 04 2005 - uli@suse.de
- fixed installation rules for DLL module platforms (e.g. ARM)
* Wed May 04 2005 - sndirsch@suse.de
- wacom driver build moved to linuxwacom package
* Tue May 03 2005 - sndirsch@suse.de
- synaptics driver build moved to xorg-x11-server-input package
* Fri Apr 29 2005 - sndirsch@suse.de
- ps_xgi-no_xvideo_on_z7 [KEEP?]
  * disabled xvideo on Z7 (X.Org Bug #2761, comment #11-13)
* Thu Apr 28 2005 - sndirsch@suse.de
- %%post (xorg-x11-server):
  * simplified patching of config file
  * i915 --> i810 driver (SLES9 SPx introduced an additional i915
  driver for i915G/i195GM support)
* Wed Apr 27 2005 - sndirsch@suse.de
- p_block_signals.diff --> pc_block_signals.diff (now in CVS head)
* Tue Apr 26 2005 - sndirsch@suse.de
- new ps_suse.diff:
  * removed xdm patch, which forces xdm to ignore the "reserve"
  keyword in /etc/X11/xdm/Xservers is no longer required since
  kdm no longer uses this config file (Bug #80310)
- remove "reserve" lines from /etc/X11/xdm/Xservers (Bug #80310)
* Sat Apr 23 2005 - sndirsch@suse.de
- new ps_x86-64_ioctl32.diff (Bug #78708):
  * Fix for offset of AGP base on mga
  * Fix to achieve consistent structure size on 32 and 64bit
- p_xlc-locale.diff [KEEP?]
  fixes strange font mixups, when fontsets are still used (#74299)
* Thu Apr 21 2005 - sndirsch@suse.de
- p_block_signals.diff:
  * Fix adding missing block for SIGCLD (#65740)
- pc_startx_cpp.diff
  * Create separate server authorization file (#65740, X.Org #3078)
* Wed Apr 20 2005 - sndirsch@suse.de
- set background (darkslateblue) when twm is used (Bug #78368)
* Mon Apr 18 2005 - sndirsch@suse.de
- removed ps_vmware-render.diff:
  * disable RENDER for vmware driver (X.Org Bug #1300, comment #7)
- p_nv-dpms.diff:
  * Some panel DPMS support that went into 4.5 really only worked
  for TMDS and caused some panel blooming on some LVDS panels.
  This skips the panel DPMS code when the panel is LVDS (mvojkovi)
* Sun Apr 17 2005 - sndirsch@suse.de
- new pc_i915GM-ddc-fix.diff:
  * Fix initial DDC parameters when validating modes (alanh)
* Sat Apr 16 2005 - sndirsch@suse.de
- pu_fixes.diff:
  * updated locale normalization patch
* Mon Apr 11 2005 - sndirsch@suse.de
- disabled p_xim_spot.diff for now (Bug #70890, comment #7)
- disabled p_pended_events.diff for now (ABI changes, Bug #70890)
- renamed patches once more:
  * p_fixes.diff --> pu_fixes.diff
  * pu_XFree86-4.2.0-i18n-xlib-20020322.diff -->
  p_XFree86-4.2.0-i18n-xlib-20020322.diff
  * pu_pci-validation.diff --> pc_pci-validation.diff
  * pu_miwideline.diff --> pc_miwideline.diff
  * pu_neomagic.diff --> pc_neomagic.diff
  * pu_trident.diff --> p_trident.diff
  * p_ppc-no-signed-char.diff --> pc_ppc-no-signed-char.diff
- p_fixes-cvs.diff:
  * removed drm hunk (already in kernel DRM sources)
* Sun Apr 10 2005 - sndirsch@suse.de
- renamed some patches again (pu_* --> p_*); these still need to be
  discussed before we can submit them upstream
* Sat Apr 09 2005 - sndirsch@suse.de
- drm_lock.diff obsolete (we no longer use X.Org DRM sources)
- renamed patches (Bug #62150)
* Sat Apr 09 2005 - sndirsch@suse.de
- p_i915GM-more3.diff:
  * Check the VESA BIOS scanline requirements and adjust the
  displayWidth accordingly. Fixes an assumption that the
  screen width was always used as the displayWidth (alanh)
- p_x-noroot.diff:
  * allow the Xserver run under the permission of ordinary users
  (limited to drivers without direct HW access) (Bug #62600)
- p_xim_spot.diff:
  * enables XNSpotLocation event for OnTheSpot mode (Bug #70890)
- p_pended_events.patch:
  * process pended callback events before processing seticvalues
  (Bug #70890)
- added Driver SDK package (xorg-x11-sdk) (Bug #75696)
* Tue Apr 05 2005 - uli@suse.de
- %%ifnarch entire server-glx package on ARM
* Mon Apr 04 2005 - sndirsch@suse.de
- p_ppc-no-signed-char.diff:
  * no longer use -fsigned-char for ppc(64) (Bug #74325)
* Sun Apr 03 2005 - aj@suse.de
- Fix Vector extensions usage for GCC4 in fbmmx.
* Sun Apr 03 2005 - sndirsch@suse.de
- FILES: added new patches by aj/schwab
* Sun Apr 03 2005 - schwab@suse.de
- Fix sentinel warnings.
- Fix printf attribute.
- Fix range checking logic.
* Sun Apr 03 2005 - aj@suse.de
- Fix GCC 4 issue in drivers/xgi.
* Fri Apr 01 2005 - uli@suse.de
- fixed to build on ARM, for real
* Thu Mar 24 2005 - uli@suse.de
- fixed to build on ARM
* Tue Mar 22 2005 - sndirsch@suse.de
- p_neomagic.diff (eich, Bug #74255)
  * fixes a hard system lockup in neomagic driver
  * prunes out interlaced modes as they are not supported
  * eliminates highres doublescan modes as we don't know how to
  support them either
- p_trident.diff (eich, Bug #63053)
  * fixes almost all issues with BladeXP on Tecra 8200
* Tue Mar 22 2005 - sndirsch@suse.de
- p_xkb-tml.diff:
  * tml keyboard: use "UNI" instead of "TSCII" by default (#73996)
* Mon Mar 21 2005 - sndirsch@suse.de
- xgi-20050318.tar.bz2/p_xgi-no_dri_autoload.diff:
  * added xgi driver (Bug #74130, X.Org Bug #2761)
- p_i915GM-agp-align.diff:
  * Fix some bad alignment problems when allocating memory from the
  end of AGP space (X.Org Bug #2764)
- p_i915GM-ddc-fix.diff:
  * a one line fixup to the UseDDC code (alanh)
* Fri Mar 18 2005 - mhopf@suse.de
- p_mouse_misc.diff: patch to fix X server crashes with synaptics
  driver (Bug #61702) (eich).
* Fri Mar 18 2005 - sndirsch@suse.de
- reverted the changes in sys.xsession (see changelog below)
* Thu Mar 17 2005 - sndirsch@suse.de
- p_i915GM-more2.diff:
  * LFP's may exist on Pipe A in older i830's. Check that case so
  that Panel ID can be obtained and Xvideo is correctly setup for
  panel fitting (alanh)
- /etc/X11/xdm/sys.xsession:
  * start beagled if configured and available (gekker)
* Tue Mar 15 2005 - sndirsch@suse.de
- new p_x86-64_ioctl32.diff; enabled on AMD64 again (Bug #64554)
* Tue Mar 15 2005 - sndirsch@suse.de
- p_i915GM-ddc.diff:
  * fixes inconsistences in handling resolutions during startup and
  after vt switching (Bug #71198, X.Org Bug #2701)
* Fri Mar 11 2005 - sndirsch@suse.de
- p_miwideline.diff (X.Org Bugzilla #2690)
  fixed crash in miFillPolygon() when doing miWideDash() and
  leftFace has dx == 0 and dy < 0
- p_nosymbols.diff (Bug #66910)
  convert misleading error message to info message
* Fri Mar 04 2005 - sndirsch@suse.de
- p_i915GM-more.diff (AlanH):
  * i830_dri.c (CVS 1.6 --> 1.7)
  Check return value of i830InitDma() and fail to initialize the
  DRI if that fails.
  Also, check the DRM module name that it matches i915 and not
  the older i830 driver which some people were still trying to
  use and was causing Dma Initialization failures and lockups.
  * i830_video.c (CVS 1.7 --> 1.11)
- Setup the Xv atoms correctly.
- Fix pixmap cache corruption when Xv was in use due to a
  memory allocator calculation problem.
- Fix unaligned YV12 videos that caused skew when playing.
- Fix an off by one error when scaling which caused occasional
  overlay color lines at the far right and bottom of the window.
* Thu Mar 03 2005 - sndirsch@suse.de
- enabled again p_i915GM.diff
- p_i915GM-modefix.diff (Bug #65981)
  * Limit the maximum refresh rate to 85Hz and remove the bogus
  100Hz and 120Hz settings as they don't match close enough and
  are really unsupported.
* Wed Mar 02 2005 - sndirsch@suse.de
- p_pci-validation.diff:
  * fixes PCI validation code (X.Org Bugzilla #2019)
- mkallcomposecaches.sh (Bug #59781, comment #70)
  * only create compose cache files for UTF-8 encodings for now
- new p_compose-cache.diff (Bug #59781, comment #71)
  * locale needs to be set to create a compose cache file
* Tue Mar 01 2005 - sndirsch@suse.de
- disabled p_i915GM.diff for now; we still don't have any hardware
  for testing and up to now we only saw regresssions with this
  patch included :-(
- new p_compose-cache.diff (Bug #59781, comment #66)
  * fixed wrong comparison of getgid/egid
- mkallcomposecaches:
  * added option for rgb.txt location
  * fixed permissions for global cache files, which need to be
  readable by everyone
* Mon Feb 28 2005 - sndirsch@suse.de
- remove .orig files in tarball (packaged accidently)
- new compose_cache.diff (Bug #59781, comments #62-64)
  * wrong Compose file was used for checking rights and ownership
  * security: check for egid binaries as well
  * changed global cache directory name (typo):
  /var/X11R6/compose_cache --> /var/X11R6/compose-cache
- mkallcomposecaches
  * /var/X11R6/compose_cache --> /var/X11R6/compose-cache
* Sat Feb 26 2005 - sndirsch@suse.de
- rewritten mkallcomposecaches; used in build process now, but
  currently unfunctional (cache files are not created) :-(
* Fri Feb 25 2005 - sndirsch@suse.de
- new compose_cache.diff (Bug #59781, comments #55-57)
  * adds parsing of XCOMPOSECACHE environment variable. This is
  needed for creating cache files while loading Compose files
  from different locations than they will be utimately loaded
  from (building X11 with DESTDIR).
  * mkcomposecache:
  This tool is used for explicitely creating cache files
- add mkallcomposecaches:
  * example script to create compose caches for all locales using
  the Xvfb server; will be used later in build process
- p_missing-radeon-blank.diff:
  * Radeon Dualhead fix missing in X.Org 6.8.2 (Bug #60982)
* Fri Feb 25 2005 - sndirsch@suse.de
- updated synaptics driver to 0.14.0
* Thu Feb 24 2005 - sndirsch@suse.de
- p_via-i2c_dpms.diff:
  * add another fix for via to prevent color distortion
  * add missing include file vldXvMC.h
* Tue Feb 22 2005 - sndirsch@suse.de
- new compose_cache.diff:
  * nukes 2 leftover Xfree()s (Bug #59781/66147)
- p_compose-typos.diff:
  * fixed typos in compose table (X.Org Bugzilla #2592)
* Mon Feb 21 2005 - sndirsch@suse.de
- xinitrc: use dbus-launch for starting windowmanager if installed
* Mon Feb 21 2005 - sndirsch@suse.de
- moved /etc/X11/xim (/etc/skel/.xim.template) to xf86tools package
* Sat Feb 19 2005 - sndirsch@suse.de
- xpm-sec10.diff:
  * another XPM security fix (X.Org Bugzilla #1920, comments #33-36)
- p_radeon-5969.diff
  * add support for ATI RN50/ES1000 (X.Org Bugzilla #2576)
* Fri Feb 18 2005 - sndirsch@suse.de
- new p_rest_font.diff (Bug #35127, comment #96)
* Sun Feb 13 2005 - sndirsch@suse.de
- xf4vnc-20050213.tar.bz2:
  * latest xf4vnc CVS version
  * adjusted p_vnc.diff
* Sat Feb 12 2005 - sndirsch@suse.de
- via-CVS-2005-02-12.tar.bz2:
  * latest via driver/XvMC sources from CVS head
  * obsoletes p_via-fix.diff
- p_via-XvMC.diff
  * enables build of libviaXvMC
* Thu Feb 10 2005 - sndirsch@suse.de
- updated to X.Org 6.8.2 (final release)
- added twm desktop file
- disabled p_x86-64_ioctl32-drm.diff for now (Bug #49554)
* Mon Feb 07 2005 - sndirsch@suse.de
- p_i915GM.diff:
  * Check the pixel clock choosen for a specific refresh rate
  against the maximally allowed pixel clock when choosing
  mode lines for VBESetVBEMode() and VESA BIOS version >= 3.0
  (X.Org Bugzilla #2486).
* Sun Feb 06 2005 - sndirsch@suse.de
- p_nv-20050203.diff:
  * support for new nvidia devices
- no longer switch from "fglrx" to "radeon" driver during update
* Sat Feb 05 2005 - sndirsch@suse.de
- fixed stripping of X11 modules (Bug #49816)
* Thu Feb 03 2005 - sndirsch@suse.de
- updated to X.Org 6.8.2 RC4
- p_gcc4.diff:
  * added sentinel patches for libXt/libXft (meissner)
* Thu Jan 27 2005 - sndirsch@suse.de
- p_gcc4.diff:
  * added sentinel patch by meissner to detect wrongly terminated
  va_lists + fix for current sentinel warnings
* Wed Jan 26 2005 - sndirsch@suse.de
- fixed build on s390/s390x (there are no Xserver modules to strip)
* Tue Jan 25 2005 - sndirsch@suse.de
- updated to X.Org 6.8.2 RC3
- cleanup in host.def
- strip Xserver modules (Bug #49816)
- p_nv-20050120.diff:
  * new nvidia Devices (Bug #50030)
- updated CardModules.addon (Bug #50166)
* Tue Jan 25 2005 - sndirsch@suse.de
- updated to current 6.8.2 branch
  * obsoletes p_i810vtswitch.diff
  * p_fixes-cvs.diff: disabling RenderAccel on radeon no longer
  required
* Mon Jan 24 2005 - sndirsch@suse.de
- added "Requires:xorg-x11" for xorg-x11-server (fonts required)
- fixed build on ppc64
* Mon Jan 24 2005 - coolo@suse.de
- patched Xsetup to not set a blue background for kdm and gdm
* Mon Jan 24 2005 - sndirsch@suse.de
- updated to current 6.8.2 branch
- adjusted host.def/p_gcc4.diff
- added xrx/libxrx/libxrxnest to filelist
* Thu Jan 20 2005 - sndirsch@suse.de
- rewrite X.Org config file in %%post of xorg-x11-server package now
  (was xorg-x11 package before); use xorg.conf instead of XF86Config
- no longer rewrite fontpath and keyboard model settings in X.Org
  config file
* Wed Jan 19 2005 - sndirsch@suse.de
- p_i810vtswitch.diff:
  * fixes console switching crash on i815 (Bug #49953)
* Mon Jan 17 2005 - sndirsch@suse.de
- p_apm.diff:
  * fixes one powersave related problem (Bug #48672)
- p_compose-cache.diff:
  * added compose cache (Bug #44781)
* Sun Jan 16 2005 - sndirsch@suse.de
- p_via-fix.diff:
  * fix VIA DRI initialization so that the correct visuals are
  exported
  * add alpha buffer initialization to 32bpp modes for GLX
  * move 24/8 mode to first exported mode as it works best
  (currently)
* Sat Jan 15 2005 - sndirsch@suse.de
- p_i915GM.diff: support for i915GM (Bug #49719)
* Thu Jan 13 2005 - sndirsch@suse.de
- fixed build on hppa (p_missing-hppa.diff)
* Thu Jan 13 2005 - sndirsch@suse.de
- updated to X.Org 6.8.2 RC2
  * adjusted p_gcc4.diff
- setting of XkbServerDefines in host.def not required
- mips: set DoLoadableServer in host.def / cleanup in
  p_mips-fixes.diff; adjusted p_missing-hppa.diff
* Thu Jan 06 2005 - sndirsch@suse.de
- reintroduced xf86/xshared/xdevel/xfntscl Provides for SuSE <= 9.2
* Wed Jan 05 2005 - sndirsch@suse.de
- new p_gcc4.diff:
  * fixes build with gcc 4 on non-i386 platforms (Bug #49364)
  * added missing return value in xorgconfig.c
- some more cleanup in host.def
* Tue Jan 04 2005 - sndirsch@suse.de
- p_gcc4.diff
  * fixes build with gcc 4 (Bug #49364)
- some more cleanup in host.def
* Mon Jan 03 2005 - sndirsch@suse.de
- use old xdm pam config file for SuSE <= 9.2
- adjust filelist (some desktop png files) for SuSE <= 9.2
* Sat Jan 01 2005 - sndirsch@suse.de
- added missing patches in X.Org 6.8.2 RC1 (Bug #49553):
  * p_missing-hppa.diff
  * p_missing-i18n-font_encodings-20030609.diff
  * p_missing-i18n-nls-20030609.diff
  * p_missing-ppc64.diff
  * p_missing-misc.diff
  * p_missing-xkb.diff
  * p_missing-pcibus.diff
* Sat Jan 01 2005 - sndirsch@suse.de
- switched to X.Org 6.8.2 RC1
  * adjusted filelist
  * adjusted p_fixes-cvs.diff, p_mips-fixes.diff, p_suse.diff,
  p_vnc.diff, p_x86-64_ioctl32.diff
* Wed Dec 29 2004 - sndirsch@suse.de
- linuxwacom-0.6.6.diff:
  * use -D_XSERVER64 on AMD64
* Tue Dec 28 2004 - sndirsch@suse.de
- cleanup in host.def (Bug #49377)
* Mon Dec 27 2004 - sndirsch@suse.de
- remove the X.Org wacom driver and install the up-to-date external
  build wacom driver to the correct location (Bug #49506)
* Tue Dec 14 2004 - sndirsch@suse.de
- p_rest_font.diff:
  * fixes screen drawing on VGA console (Bug #35127)
* Mon Dec 13 2004 - sndirsch@suse.de
- updated to current CVS version 2004-12-13
  * includes fixes for the libXpm security patch related problems
  * obsoletes libXpm hunks in p_fixes-cvs.diff
- disabled use of the same XLC_LOCALE (en_US.UTF-8) for all UTF-8
  encodings for now
* Sat Dec 11 2004 - sndirsch@suse.de
- HALlib-4.1.tar.gz: updated HAL library
* Fri Dec 10 2004 - sndirsch@suse.de
- p_fixes-cvs.diff:
  * use of wbinvd() macro (X.Org Bug #2047)
* Fri Dec 10 2004 - sndirsch@suse.de
- updated to current CVS version 2004-12-10
  * includes latest important nv driver changes (X.Org Bug #1985)
* Tue Dec 07 2004 - sndirsch@suse.de
- p_fixes-cvs.diff:
  * enabled backing store initialization in Xvfb again, which fixes
  the following tests in lsb-test-vsw4:
  /tset/CH03/mprsd/Test 12 UNRESOLVED
  /tset/CH03/mpsbws/Test 11 UNRESOLVED
  /tset/CH03/mpsbws/Test 12 UNRESOLVED
  /tset/CH03/mpwdw/Test 12 UNRESOLVED
  /tset/CH03/mpwdw/Test 13 UNRESOLVED
* Tue Dec 07 2004 - sndirsch@suse.de
- updated wacom driver to release 0.6.6
  * Fixed a P4 bug in wcmSerial.c
* Mon Dec 06 2004 - sndirsch@suse.de
- etc/X11/xim:
  * improved parsing of $HOME/.kde/share/config/skimrc
  * check for wnn7 by using test instead of rpm
  * disable Gnome integration for OpenOffice when wnn7 is used
  * improved position of wnn7 input method status window
* Sun Dec 05 2004 - sndirsch@suse.de
- xorg-x11-devel needs to require xorg-x11-libs (Bug #48926)
* Fri Dec 03 2004 - sndirsch@suse.de
- p_fixes-cvs.diff:
  * removes restrictive checks about filename/path (X.Org #1924);
  not yet in X.Org CVS
* Thu Dec 02 2004 - sndirsch@suse.de
- updated to current CVS version 2004-12-02
  * fixes also unresolved symbols in libtype1.a/libdri.a/libdrm.a
  (Bug #48849)
- p_nv-04-11-30.diff (latest nv driver sources):
  * various driver cleanups (Marc Aurele La France)
  * Fix some DAC/Graphics memory contention issues on newer NVIDIA
  chips (specifically, NV40) (Mark Vojkovich)
* Wed Dec 01 2004 - sndirsch@suse.de
- etc/X11/xim: added support for Wnn7
* Mon Nov 29 2004 - sndirsch@suse.de
- %%post(server): XF86Config --> xorg.conf (SaX2 now writes xorg.conf
  instead of XF86Config)
* Sat Nov 27 2004 - sndirsch@suse.de
- updated to current CVS version 2004-11-27
  * obsoletes xpm security patches (xpm-sec5.diff,
  xpm-secfix-thomas.diff, xpm-secfix-imakefile-thomas.diff)
  * adjusted p_x86-64_ioctl32.diff
* Thu Nov 25 2004 - sndirsch@suse.de
- skel.tar.gz:xinitrc.template
  * autoload nvidia settings if available
* Tue Nov 23 2004 - sndirsch@suse.de
- updated to current CVS version 2004-11-23
  * obsoletes workaround in p_fixes-cvs.diff/xvmc.c
  * adjusted p_fixes.diff
* Tue Nov 23 2004 - sndirsch@suse.de
- p_fixes.diff:
  * fixed xtest drwtxt(16) failures (Bug #48413)
- permission handling fixes for /usr/X11R6/bin/Xorg
* Mon Nov 22 2004 - sndirsch@suse.de
- updated to current CVS version 2004-11-22
  * p_fixes-cvs.diff: workaround in xvmc.c to fix build on s390(x)
* Wed Nov 17 2004 - sndirsch@suse.de
- updated wacom driver to release 0.6.5
  * adds Intuos3 support
  * fixes z-rot valuator initialization error
  * obsoletes p_linuxwacom-0.6.3.diff
* Tue Nov 16 2004 - sndirsch@suse.de
- added icon files for xcalc, xclipboard, xload, xmag to filelist
* Mon Nov 15 2004 - sndirsch@suse.de
-skel.tar.gz:xinitrc.template
  * no longer use xbounce; meanwhile fixed by the kernel
* Mon Nov 15 2004 - kukuk@suse.de
- xdm.pamd: Remove duplicate pam_limits.so from session
* Thu Nov 11 2004 - werner@suse.de
- Xdm: Check for IP addresses within display name for the utmp line
* Thu Nov 11 2004 - sndirsch@suse.de
- updated to current CVS version 2004-11-11
  * obsoletes p_nv-041015.diff (X.Org Bug #1777)
- p_fixes-cvs.diff:
  * enable "-fPIC" for shared libGL on i386 again (Bug #47893)
- drm_lock.diff:
  * fixed locking checks in DRM for i810/i830/i915 driver
  (Bug #47888, X.Org Bug #1803)
* Wed Nov 10 2004 - sndirsch@suse.de
- moved permission handling fixes to first %%post; removed second
  %%post
* Wed Nov 10 2004 - ro@suse.de
- permission handling fixes
* Tue Nov 09 2004 - sndirsch@suse.de
- added current xpm security patches (xpm-sec5.diff,
  xpm-secfix-thomas.diff, xpm-secfix-imakefile-thomas.diff)
- moved libGL.a/libMesaGL.a to the new xorg-x11-Mesa-devel-static
  package (Bug #47952)
* Tue Nov 09 2004 - sndirsch@suse.de
- updated to current CVS version 2004-11-09
  * p_fixes-cvs.diff: sis hunk obsolete now; enabled build of xpr
  again (warnings, which were fatal for the build, were fixed)
- suse-addons.tar.bz2:
  * xdm.pamd: use new common PAM configuration files
* Thu Nov 04 2004 - sndirsch@suse.de
- updated to current CVS version 2004-11-04
  * p_fixes-cvs.diff: removed obsolete hunk; fixed sis driver build
  for non-i386 platforms; disabled build of xpr for now
  * added libviaXvMC and new programs (pclcomp,xdbedizzy,xdpr,xpr)
  to filelist
* Sun Oct 31 2004 - sndirsch@suse.de
- HALlib-4.0.tar.gz: updated HAL library
* Fri Oct 29 2004 - sndirsch@suse.de
- disable build of xsload and synaptics driver when
  DoLoadableServer is not set; fixes build of a static Xserver
- p_fixes-cvs.diff:
  * fixes Segfault, when XCloseDisplay() is called after
  XScreenSaverUnsetAttr()
* Tue Oct 26 2004 - sndirsch@suse.de
- p_libXft.diff:
  * corrected libXft version number: 2.1.5 --> 2.1.6
- suse-addons.tar.bz2:
  * removed Backarrow2BackSpace/Backarrow2Delete; moved to xterm
  package
* Tue Oct 26 2004 - sndirsch@suse.de
- removed subshells with pushd/popd, so build errors won't fail
  any longer silently
- no longer try to create fonts.scale.xf86 in Speedo/CID font
  directories as these are empty and the speedo font module was
  dropped anyway
- set host.def to writable before adding additional stuff
* Sun Oct 24 2004 - sndirsch@suse.de
- switched to norootforbuild
- split build/install of wacom driver and vncviewer
* Sat Oct 23 2004 - sndirsch@suse.de
- no longer build and package xterm, which is now built seperately
* Fri Oct 22 2004 - sndirsch@suse.de
- use symlink instead of copy for the nvidia dummy driver
- p_suse.diff += p_fpic.diff p_xsload.diff p_xdm.diff
- removed obsolete Xmodmap files
- moved config.xfs, logrotate.xdm, rcxfs, SuSEconfig.xdm, xserverrc
  into suse-addons.tar.bz2
* Fri Oct 22 2004 - sndirsch@suse.de
- merged p_macintosh-kb.diff/p_XFree86-4.3-kbdmapping.diff
- merged Makefile/Makefile.x86_64
- use modified nv driver for dummy nvidia driver instead of
  copy and modify nv driver (p_suse.diff)
- removed alpha build hack for twm (most likely obsolete)
- use locale normalization patch instead of locale.awk
  (p_fixes.diff)
- merged hunks of p_xsload.diff into xsload.tar.gz
- removed xsload.sh (wrapper) completely; no longer required and
  broken anyway
* Thu Oct 21 2004 - sndirsch@suse.de
- /etc/X11/xdm/sys.xsession:
  * start gpg-agent only once per user (Bug #45272)
* Wed Oct 20 2004 - sndirsch@suse.de
- some more cleanup in specfile
  * remove no longer used defines MODEXT/MODEXT_A
  * no longer touch build system with glide headers/libs
  * show and remove fuzzy backup files for patches
* Tue Oct 19 2004 - sndirsch@suse.de
-  updated to current CVS version 2004-10-19a
  * obsoletes p_hppa.diff
  * adjusted p_mips-fixes.diff
* Tue Oct 19 2004 - sndirsch@suse.de
- some cleanup in specfile
* Tue Oct 19 2004 - sndirsch@suse.de
- recreated p_vnc.diff, p_xterm-settings.diff
* Tue Oct 19 2004 - sndirsch@suse.de
- updated to current CVS version 2004-10-19
  * adjusted p_fixes-cvs.diff
- removed xcursor.tar.gz (cursor theme), which isn't packaged since
  a long time anyway
- updated xf4nvc to CVS version 2004-10-19
  * adjusted p_vnc.diff
  * set correct XF4VNC version in host.def (specfile)
- some cleanup in specfile
* Tue Oct 19 2004 - sndirsch@suse.de
- no longer build Xvnc in a second run; build it together with the
  other stuff while running 'make World'
  * obsoletes host.def.vnc, p_XOrg-X11R6_7_0-workaround.diff
  * p_vnc.diff adjusted for this
* Mon Oct 18 2004 - sndirsch@suse.de
- updated to current CVS version 2004-10-18
  * obsoletes p_XFree86-4.3-ppc64.diff, p_tdfx.diff, p_xim_spot.diff,
  p_XFree86-4.3.0-i18n-font_encodings-20030609.diff,
  p_XFree86-4.3.0-i18n-nls-20030609.diff
  * adjusted p_fixes-cvs.diff, p_fixes.diff, p_suse.diff
- startx --> p_suse.diff
* Sat Oct 16 2004 - sndirsch@suse.de
- updated to current CVS version 2004-10-15
  * adjusted p_suse.diff
- p_nv-041015.diff
  * support for new NVIDIA chips
* Fri Oct 15 2004 - sndirsch@suse.de
- removed obsolete xterm patches in xterm-patches.tar.gz
- xterm-patches.tar.gz -> p_xterm-config.diff/p_xterm-settings.diff
- improved startx script (Bug #47307)
* Fri Oct 15 2004 - sndirsch@suse.de
- removed obsolete p_kbd.diff
- p_suse.diff/p_fixes.diff:
  * removed obsolete patches
- moved "programs/xterm/main.h" hunk from p_fixes.diff to
  xterm-simple.patch
* Thu Oct 14 2004 - sndirsch@suse.de
- p_fixes-cvs.diff:
  * fixes "control reaches end of non-void function" warning in
  radeon_render.c; fixes build on hppa
- p_nv-041012.diff:
  * Workaround for some NV31 DVI artifacts
* Wed Oct 13 2004 - sndirsch@suse.de
- p_fixes-cvs.diff:
  * disable broken Render functions (Bug #46922)
* Wed Oct 13 2004 - sndirsch@suse.de
- adjusted and improved p_hppa.diff
* Tue Oct 12 2004 - sndirsch@suse.de
- updated to current CVS version 2004-10-12a
  * obsoletes the following patches:
  p_i810-accel.diff
  p_i915-fb.diff
  p_ibm_space_saver.diff
  p_nv-presario3000.diff
  p_ppc-usefbdev.diff
  p_xf86pciBus.diff
  p_xkb-cherryblueb.diff
  * adjusted p_fpic.diff, p_nv-041009.diff
- removed p_nodri.diff (obsolete and broken anyway)
- removed p_xdm-openport.diff (obsolete)
- removed p_noansi.diff (obsolete)
* Tue Oct 12 2004 - sndirsch@suse.de
- updated to current CVS version 2004-10-12
  * removed p_radeon-dri-resume.diff; already applied upstream
- removed p_855_display_switch.diff:
  * problem already fixed upstream in a different way; this patch
  might even harm
- removed p_i810-sig11.diff:
  * not required and might even harm together with p_i810-accel.diff
- p_ppc-usefbdev.diff:
  * first hunk was unnecessary
* Mon Oct 11 2004 - sndirsch@suse.de
- updated to current CVS version 2004-10-11
  * adjusted p_i810-accel.diff
  * removed already upstream applied patches:
  p_i810dri-memfix.diff
  p_dpms-radeon.diff
  p_radeon-blank.diff
- p_fixes-cvs.diff:
  * xauth_switch_to_sun-des-1: use bash instead of ksh
- p_tdfx.diff:
  * use abort now, which is more reasonable in this situation
- updated to latest nv driver:
  * p_nv-040827.diff --> p_nv-041009.diff
* Mon Oct 11 2004 - sndirsch@suse.de
- p_fixes-cvs.diff:
  * xorgversion.def needs to be installed
* Sat Oct 09 2004 - schwab@suse.de
- p_macintosh-kb.diff:
  Add more keys from the Apple Extended USB keyboard.
* Fri Oct 08 2004 - sndirsch@suse.de
- merged patches:
  * p_XFree86-4.3.0-i18n-font_encodings-20030609.diff +
  p_XFree86-4.3.0-i18n-font_encodings-20030609-incr.diff =
  p_XFree86-4.3.0-i18n-font_encodings-20030609.diff
  * p_fixes.diff + p_fixes-incr.diff + p_fixes2.diff = p_fixes.diff
  * p_nv-040722.diff + p_nv-040722-040827.diff = p_nv-040827.diff
- removed patches:
  * p_bug17759.diff
  * p_ia64-debug.diff
* Fri Oct 08 2004 - sndirsch@suse.de
- updated to current CVS version 2004-10-07
  * removed patches already applied in CVS
  p_bigfont.diff
  p_glext.diff
  p_hp-zx1.diff
  p_imInsClbk.diff
  p_init-pScreen.diff
  p_keyboard.diff
  p_smart_schedule_timer_overflow.diff
  p_switch-extensions.diff
  p_xaw-sig11fix.diff
  xorg-6.8.0-to-6.8.1.patch
  * added new files to filelist
  xauth_switch_to_sun-des-1
  xrx
  libXvMCW
  libxrx
  libxrxnest
  modules/multimedia/
  * adjusted patches to CVS
  p_XOrg-X11R6_7_0-workaround.diff
  p_suse.diff
  p_vnc.diff
  p_xsload.diff
- added still missing .so symlinks:
  * libI810XvMC, libFS, libGLw, libXcomposite, libXdamage, libXevie,
  libXfixes, libXvMC, libXxf86rush, libxkbui
- cleanup in specfile; no longer supports build for SuSE < 9.2
* Thu Oct 07 2004 - sndirsch@suse.de
- p_ibm_space_saver.diff:
  * added config support for IBM Space Saver keyboard (Bug #44788)
* Wed Oct 06 2004 - sndirsch@suse.de
- xinitrc: fixed typo in failsafe xterm title
- added missing .so symlinks for libXv, libXxf86dga, libXxf86misc,
  libXxf86vm, libXinerama, libfontenc, libxkbfile, libXss; most
  hacks in p_fpic.diff are therefore no longer required and removed
- enabled Autoreqprov again for xorg-x11-server/xorg-x11-server-glx
- cleanup in Obsoletes/Provides; we don't need to support updates
  from 8.1 or older
* Mon Oct 04 2004 - sndirsch@suse.de
- p_radeon-blank.diff:
  * fixes Dual Head with DVI monitors connected (Bug #45982)
* Mon Oct 04 2004 - sndirsch@suse.de
- improved p_glext.diff (Bug #46757,#45827)
* Fri Oct 01 2004 - sndirsch@suse.de
- added missing libXRes.so symlink to filelist
* Fri Oct 01 2004 - sndirsch@suse.de
- p_glext.diff:
  * fixes double free, when DRI is used and user is not allowed to
  access /dev/dri (Bug #45827)
- p_dpms-radeon.diff:
  * DPMS needs to be disabled before VT switching (Bug #45983)
* Thu Sep 30 2004 - sndirsch@suse.de
- new /etc/X11/xim file:
  * start scim instead of skim, if skim is not installed or is not
  autostarted by the KDE session
* Wed Sep 29 2004 - sndirsch@suse.de
- p_i810-accel.diff:
  * fixed non-working acceleration (Bug #45870)
- p_i915-fb.diff:
  * fixed broken framebuffer on i915 (Bug #45743)
- p_i810dri-memfix.diff:
  * fixes mem allocation for i810/815 with DRI enabled (Bug #45870)
- removed printk debug messages in p_x86-64_ioctl32.diff
- adjusted p_fixes.diff
* Wed Sep 29 2004 - sndirsch@suse.de
- improved p_vmware-render.diff (X.Org Bugzilla #1300)
* Wed Sep 29 2004 - sndirsch@suse.de
- fixed p_nv-presario3000.diff (Bug #46360, comment #9)
- improved p_radeon-dri-resume.diff; RADEONSetFBLocation should
  be called no matter if DRI is compiled in or not (Bug #45602)
* Tue Sep 28 2004 - sndirsch@suse.de
- p_nv-presario3000.diff:
  * makes nv driver work on HP Presario 3000 (Bug #46360)
- p_radeon-dri-resume.diff:
  * fixes DRI resume problems on radeon chips (Bug #45602)
* Fri Sep 24 2004 - sndirsch@suse.de
- p_i810-sig11.diff:
  * fixes Sig11 in i810 driver (Bug #45870)
* Fri Sep 24 2004 - sndirsch@suse.de
- new p_fixes-incr.diff:
  * fixed compose.dir entries for ja_JP, ko_KR, zh_TW UTF-8 locales
* Wed Sep 22 2004 - sndirsch@suse.de
- new p_vnc.diff:
  * fixed Xserver crash (Bug #45599)
* Tue Sep 21 2004 - sndirsch@suse.de
- improved p_xaw-sig11fix.diff (Bug #44037, comment #74)
* Tue Sep 21 2004 - sndirsch@suse.de
- no longer create backup files, when applying p_x86-64_ioctl32.diff,
  which resulted in empty files with wrong file permisssions in
  km_drm package
* Mon Sep 20 2004 - sndirsch@suse.de
- updated and reenabled 32bit DRI patch (p_x86-64_ioctl32.diff)
  for AMD64 (Bug #45152); p_amd64-radeon_setparam.diff no longer
  required
- workaround for missing "hu" kbd layout definition (Bug #45354)
- p_bigfont.diff:
  * fixes Xnest crashes if SHM is compiled in but not available
  (X.Org Bugzilla #1402)
* Sun Sep 19 2004 - sndirsch@suse.de
- p_init-pScreen.diff:
  * fixes random crashes (like in DAMAGE code etc.) in Xnest due
  uninitalised GetWindowPixmap (X.Org Bugzilla #1404)
* Sat Sep 18 2004 - sndirsch@suse.de
- fixed p_switch-extensions.diff (Bug #45417)
* Sat Sep 18 2004 - sndirsch@suse.de
- new xorg-6.8.0-to-6.8.1.patch:
  * patch created from CVS; the old one was not complete
* Fri Sep 17 2004 - sndirsch@suse.de
- p_keyboard.diff:
  * The server segfaulted during shutdown as the keyboard procedure
  was not yet initialized (Bug #45383).
* Fri Sep 17 2004 - sndirsch@suse.de
- p_xaw-sig11fix.diff:
  * fixes Xaw fontset related segfault when fonts.dir is not
  up-to-date (Bug #44037)
* Thu Sep 16 2004 - sndirsch@suse.de
- p_switch-extensions.diff:
  * enables switching on/off extensions like Xdamage, Xfixes and
  others for testing/workaround purposes (Bug #45417)
* Wed Sep 15 2004 - sndirsch@suse.de
- update to X.Org 6.8.1 (xorg-6.8.0-to-6.8.1.patch):
  * This version is purely a security release, addressing multiple
  integer and stack overflows in libXpm, the X Pixmap library.
  The CVE numbers for these vulnerabilities are CAN-2004-0687
  (integer overflows) and CAN-2004-0688 (stack overflows).
* Wed Sep 15 2004 - sndirsch@suse.de
- fixed permisions of /etc/X11/xim (Bug #45359)
* Wed Sep 15 2004 - sndirsch@suse.de
- improved p_vmware-render.diff
* Tue Sep 14 2004 - sndirsch@suse.de
- Xprt config files are no longer copied manually; according to
  Roland Mainz this is no longer required and might even result
  in a disaster
- p_vmware-render.diff:
  * enables Render acceleration in vmware driver (X.Org Bug #1300)
* Mon Sep 13 2004 - sndirsch@suse.de
- p_hp-zx1.diff:
  * fixes chipset probing on non-ZX1 systems (Bug #42737)
* Mon Sep 13 2004 - sndirsch@suse.de
- p_imInsClbk.diff:
  * fixes Bug #44443
- latest xim config file
* Thu Sep 09 2004 - schwab@suse.de
- Fix 64bit bug in smart scheduler [#32243].
* Wed Sep 08 2004 - sndirsch@suse.de
- updated to final release of X.Org 6.8.0 (only changes in docs)
* Sat Sep 04 2004 - sndirsch@suse.de
- updated to X.Org 6.8.0
- new xim config file:
  * SCIM is now default for CJK (not only for chinese)
* Thu Sep 02 2004 - sndirsch@suse.de
- fixed km_drm build on AMD64
* Thu Sep 02 2004 - sndirsch@suse.de
- updated to X.Org 6.8.0 RC4
  * removed p_lkup.diff, p_i855-colorfix.diff (applied upstream)
  * adjusted filelist
* Wed Sep 01 2004 - sndirsch@suse.de
- p_synaptics.diff:
  * added new sources for synaptics driver build (Bug #44598)
* Tue Aug 31 2004 - sndirsch@suse.de
- p_i855-colorfix.diff:
  * fixes DRI color mixup (red <-> blue) for Intel >= 830; tested
  with 845G/855 (Bug #44392)
* Sat Aug 28 2004 - sndirsch@suse.de
- updated to X.Org 6.8.0 RC3
  * removed p_amd64-fix.diff (already applied upstream)
* Fri Aug 27 2004 - sndirsch@suse.de
- p_nv-040722-040827.diff:
  * New chip support and workaround for Toshiba M30 laptop issue.
* Thu Aug 26 2004 - sndirsch@suse.de
- updated to X.Org CVS release 04-08-26
  * adjusted filelist
- improved p_lkup.diff, which now also fixes Bug #43247
- fixed "[kK]ebyord" --> "kbd" replacement in XF86Config during
  update
* Wed Aug 25 2004 - sndirsch@suse.de
- updated synaptics driver to 0.13.5
- use /sbin/ldconfig instead of %%ld_config
- added compatibility symlink xorg.conf --> XF86Config in /etc/X11
  if it doesn't exist yet
* Tue Aug 24 2004 - sndirsch@suse.de
- p_lkup.diff:
  * splits XGetWindowAttributes into two pieces (Bug #40962)
* Sun Aug 22 2004 - sndirsch@suse.de
- updated to X.Org CVS release 04-08-22
- p_fixes.diff:
  * disabled wrongly activated DPMS mode when DPMS Standby,
  DPMS Suspend or DPMS Off is set to 0 (XFree86 Bugzilla #1252)
* Sat Aug 21 2004 - sndirsch@suse.de
- updated to X.Org CVS release 04-08-21
  * Wraphelp.c now included upstream and used for build by default
  * adjusted p_suse.diff
* Fri Aug 20 2004 - sndirsch@suse.de
- enabled build of i810 graphics driver and i810 + i915 DRI drivers
  on AMD64
* Thu Aug 19 2004 - od@suse.de
- switched off incorrect additional check for /dev/console in
  xconsole.c, so the compiled-in default /dev/xconsole is used
  (#43931)
* Thu Aug 19 2004 - werner@suse.de
- Fix bug #43931 by using showconsole to get the real virtual
  console of the Xserver for Give/TakeDevice
* Thu Aug 19 2004 - sndirsch@suse.de
- updated to X.Org CVS release 04-08-19
  * adjusted filelist
* Mon Aug 16 2004 - sndirsch@suse.de
- updated to X.Org CVS release 04-08-17
  * no longer set UseDeprecatedKeyboardDriver to YES; no longer
  required
  * adjusted p_vnc.diff
  * removed xmore from filelist
  * added libXevie and according pkconfig file to filelist
  * %%post: Driver "?eyboard" --> Driver "kbd" (Bug #43695)
  * fixes bug which prevents Xvfb to start in 8bpp (Bug #43837)
- fixed PreReq for xorg-x11-server; needs to be xorg-x11-server-glx
  now instead of XFree86-server-glx
- added ln, rm to PreReq of xorg-x11-server
* Mon Aug 16 2004 - sndirsch@suse.de
- fixed build on ia64 by adding XF86Config.indy to ia64 filelist
* Sun Aug 15 2004 - sndirsch@suse.de
- updated to X.Org CVS release 04-08-15
  * adjusted p_fixes.diff, p_xterm_noluit.diff,
  p_XFree86-4.3-ppc64.diff, ./xterm-color-bug33180.dif,
  xterm-simple.patch
  * p_fixes.diff: fixed xterm build
* Thu Aug 12 2004 - sndirsch@suse.de
- updated wacom driver to release 0.6.4
* Tue Aug 10 2004 - sndirsch@suse.de
- updated to X.Org CVS release 04-08-10
- enabled build of deprecated keyboard driver unless SaX2,
  installation and update is not adjusted yet
- fixed unresolved symbols in ati driver: RADEONOptionsWeak,
  RADEONFillInScreenInfo
* Sat Aug 07 2004 - sndirsch@suse.de
- updated to X.Org CVS release 04-08-07
- no longer disable build of Composite extensions; nvidia driver
  issue is fixed (fd.org Bugzilla #976)
* Wed Aug 04 2004 - sndirsch@suse.de
- disabled build of Composite extension (fd.org Bugzilla #976)
* Tue Aug 03 2004 - sndirsch@suse.de
- updated to X.Org CVS release 04-08-03
* Mon Aug 02 2004 - sndirsch@suse.de
- fixed build on s390, s390x, ppc64
- fixed build with new automake 1.9
* Sat Jul 31 2004 - sndirsch@suse.de
- updated to X.Org CVS release 04-07-31
  * removed p_atof.diff (fixed upstream)
  * adjusted p_fixes.diff, p_nv-040722.diff, p_vnc.diff
  * added XComposite/Xdamage/Xfixes libs and pkgconfig files to
  filelist
* Thu Jul 29 2004 - sndirsch@suse.de
- updated to X.Org CVS release 04-07-29
  * adjusted p_vnc.diff
  * p_fixes.diff: fixed build on s390/s390x; miext/damage needs to
  be compiled also on platforms with no Xorg server
- build static freetype module on SuSE <= 9.1
- added insserv/stop_on_removal calls to %%post/%%preun/%%postun of
  xprint package
* Wed Jul 28 2004 - sndirsch@suse.de
- use the upstream graphics driver list (+ fbdev) for ppc
* Sun Jul 25 2004 - sndirsch@suse.de
- updated to X.Org CVS release 04-07-25
  * p_tdfx.diff: fixes build
* Sat Jul 24 2004 - sndirsch@suse.de
- enabled build of shared Xv, Xxf86misc, Xxf86dga libs again
  (default now)
* Thu Jul 22 2004 - sndirsch@suse.de
- p_nv-040722.diff:
  * latest nv driver of XFree86 CVS
* Wed Jul 21 2004 - kukuk@suse.de
- Add pam_limits to session management of pam.d/xdm
* Wed Jul 21 2004 - sndirsch@suse.de
- updated to X.Org CVS release 04-07-21
  * adjusted xterm-simple.patch
  * addded ghostscript-mini to #neededforbuild (required for build)
- remove old XFree86 logfiles and create symlinks to new Xorg
  logfiles during update
- added compatibility manual pages for XFree86, xf86config and
  XF86Config
* Sun Jul 18 2004 - sndirsch@suse.de
- updated to X.Org CVS release 04-07-18
  * fixes binary compatibility, i.e. 3rd party drivers like nvidia
  work again (Bug #43022)
* Fri Jul 16 2004 - sndirsch@suse.de
- updated wacom driver to release 0.6.3
* Thu Jul 15 2004 - sndirsch@suse.de
- updated to X.Org CVS release 04-07-15
* Mon Jul 12 2004 - sndirsch@suse.de
- updated to X.Org CVS release 04-07-12
* Sun Jul 11 2004 - sndirsch@suse.de
- updated to X.Org CVS release 04-07-11
* Wed Jul 07 2004 - sndirsch@suse.de
- updated to X.Org CVS release 04-07-07
  * removed p_align.diff, p_i810-switchmode.diff,
  p_max-pci-devices.diff (already applied upstream)
  * adjusted p_amd64-fix.diff, p_fixes.diff, p_vnc.diff and
  Wraphelp.c
  * added xrender.pc to filelist
* Mon Jul 05 2004 - sndirsch@suse.de
- p_ia64-debug.diff:
  * debug info for IA64 (Bug #32243)
* Sun Jul 04 2004 - schwab@suse.de
- Avoid backup files in xkb directories.
* Thu Jul 01 2004 - sndirsch@suse.de
- new p_amd64-fix.diff:
  * additional build fix for hppa
* Sun Jun 27 2004 - sndirsch@suse.de
- updated to X.Org CVS release 04-06-27
  * adjusted p_fixes.diff, p_855_display_switch.diff
  * 92xprint-xpserverlist --> 92xprint-xpserverlist.sh
  * removed i915 from DriDrivers list on IA64 (fixes build)
* Fri Jun 25 2004 - sndirsch@suse.de
- p_vnc.diff:
  * fixed wrong keyboard mapping (Bug #42456)
* Sun Jun 20 2004 - sndirsch@suse.de
- p_i810-switchmode.diff:
  fixes resolution switching on i810/i815 chipsets (Bug #41945)
- p_align.diff:
  * fix for the unaligned access problem (Bug #41616)
- p_xf86pciBus.diff:
  * ignore host bridges from which the target bus is not known
  (Bug #41610)
- p_nodri.diff:
  * fixes build on non-DRI architectures
* Fri Jun 18 2004 - sndirsch@suse.de
- Makefile/Makefile.x86_64:
  * added new DRM modules to build: i915, savage, via, mach64
  * use -DVMAP_4_ARGS for x86_64 as well
* Thu Jun 17 2004 - sndirsch@suse.de
- updated to X.Org CVS release 04-06-17
  * adjusted p_vnc.diff
  * removed p_drm.diff (already applied upstream)
  * added p_atof.diff (workaround for building Xvnc server)
  * added p_amd64-fix.diff (fixes build on AMD64)
  * disabled 32bit DRI support on AMD64 for now
  (patches p_x86-64_ioctl32.diff, p_amd64-radeon_setparam.diff)
* Tue Jun 15 2004 - sndirsch@suse.de
- p_xdm-openport.diff:
  * This security fix resolves random listening to ports by xdm,
  that allows to connect via XDMCP (Bug #41971)
* Mon Jun 07 2004 - sndirsch@suse.de
- new p_hppa.diff:
  * fixes finally build on hppa (serious compiler warnings)
* Sun Jun 06 2004 - meissner@suse.de
- p_ppc-usefbdev.diff: radeon usefbdev hack is not needed for G5.
* Sat Jun 05 2004 - schwab@suse.de
- Build kernel modules with -DVMAP_4_ARG.
* Fri Jun 04 2004 - sndirsch@suse.de
- p_hppa.diff:
  * fixes build on hppa
* Thu Jun 03 2004 - sndirsch@suse.de
- updated to X.Org CVS release 04-06-03
  * adjusted p_suse.diff
* Sat May 29 2004 - sndirsch@suse.de
- updated to X.Org CVS release 04-05-29
  * adjusted p_fixes.diff, p_suse.diff; some patches already
  applied upstream, fixed compiler warning in sm_manager.c to
  fix build
  * removed p_ConnDis.diff; already applied upstream
  * added xmore to filelist
- SuSEconfig.xdm: handle Xservers file correctly (Bug #41421)
* Sat May 29 2004 - sndirsch@suse.de
- p_amd64-radeon_setparam.diff:
  * added missing 32bit iotcl (Bug #41260)
* Thu May 27 2004 - sndirsch@suse.de
- p_max-pci-devices.diff:
  * support 128 instead of 64 PCI devices (Bug #41274)
* Wed May 26 2004 - sndirsch@suse.de
- moved libGL.so to xorg-x11-Mesa (Bug #41118)
* Tue May 25 2004 - sndirsch@suse.de
- updated to release 0.6.2
  * fixes DoubleSpeed, DoubleRadius and TwinView issues
* Mon May 24 2004 - sndirsch@suse.de
- p_vnc.diff:
  * added empty ddxInitGlobals() function to VNC DDX; obsoletes
  p_ddx.diff
* Sat May 22 2004 - sndirsch@suse.de
- updated to X.Org CVS release 04-05-22
- removed patches already applied upstream
  * p_xlib-rmdb.diff
  * p_amd64-afb.diff
  * p_amd64-v4l.diff
- adjusted patches:
  * p_XFree86-4.3.0-i18n-font_encodings-20030609-incr.diff
  * p_fixes2.diff (partially alreay applied upstream)
  * p_suse.diff
  * p_vnc.diff
- p_ddx.diff:
  * build workaround: ddxInitGlobals() cannot be resolved and is
  an empty function anyway; need a better fix for this ...
- specfile changes:
  * disabled build of Motif samples
  * removed from filelist:
  /usr/X11R6/lib/libXfontcache.so.1.2
  /usr/X11R6/lib/modules/codeconv/
  /usr/X11R6/lib/X11/fonts/Speedo/
  * added to filelist
  /etc/X11/Xsession.d/92xprint-xpserverlist
  /etc/X11/xserver/C/Imakefile
  /etc/X11/xserver/C/Makefile
  /etc/X11/xserver/README
  /etc/X11/xserver/en_US/print/attributes/document
  /etc/init.d/xprint
  /etc/profile.d/xprint.csh
  /etc/profile.d/xprint.sh
  /usr/X11R6/bin/xphelloworld
  /usr/X11R6/bin/xplsprinters
  /usr/X11R6/bin/xpsimplehelloworld
  /usr/X11R6/bin/xpxthelloworld
  /usr/X11R6/include/X11/XprintAppUtil/xpapputil.h
  /usr/X11R6/include/X11/XprintUtil/xprintutil.h
* Fri May 21 2004 - sndirsch@suse.de
- p_drm.diff:
  * fixed build for newer kernel sources; reading/changing
  page->count has changed:
  include/linux/mm.c:
  // read
  static inline int page_count(struct page *p);
  // increment
  static inline void get_page(struct page *page);
  // decrement
  static inline void put_page(struct page *page);
* Wed May 19 2004 - sndirsch@suse.de
- no longer build Xvnc server in a subshell
* Wed May 19 2004 - sndirsch@suse.de
- xf4vnc-20040519.tar.bz2:
  * latest xf4vnc CVS version; obsoletes p_vnc-region.diff and
  p_vnc-2004-04-06.diff
- integrated the build of libvncauth in "make World"
* Tue May 11 2004 - sndirsch@suse.de
- p_ConnDis.diff:
  * lib/X11/ConnDis.c (GetAuthorization): make the unique members
  more finegraned (Bug #38512)
* Mon May 10 2004 - schwab@suse.de
- Provide/obsolete vnc-x86 on ia64.
* Tue May 04 2004 - sndirsch@suse.de
- - p_ppc-usefbdev.diff:
  * enables option 'usefbdev' for r128/radeon drivers on ppc by
  default (Bug #39793)
* Thu Apr 29 2004 - sndirsch@suse.de
- p_fpic.diff:
  * build static libXRes with "-fPIC"
* Fri Apr 23 2004 - sndirsch@suse.de
- more detailed obsoletes (version number) for old XFree86 packages
* Fri Apr 23 2004 - sndirsch@suse.de
- new p_XFree86-4.3-ppc64.diff:
  * fixed build on ppc64; xorg.cf is now used instead of xfree86.cf
- fixed build on s390x (use "-fno-strict-aliasing" for building
  Xvnc server as well)
* Wed Apr 21 2004 - sndirsch@suse.de
- renamed packages to xorg-x11
- fixed xterm font configuration (Bug #39226)
* Mon Apr 19 2004 - sndirsch@suse.de
- no longer use a global Xmodmap for SuSE default keyboard mapping;
  adjusted xkb files instead (Bug #32686)
- p_noansi.diff:
  * remove "-ansi -pedantic" in some Imakefiles; "-ansi" is not
  allowed when compiling kernel headers; at least not on ia64
- added "-fno-strict-aliasing" for s390x
* Fri Apr 16 2004 - sndirsch@suse.de
- p_suse.diff:
  * fixed build (serious compiler warnings)
* Thu Apr 15 2004 - sndirsch@suse.de
- p_fixes.diff:
  * fixed broken setxkbmap by adding compatibilty symlinks
  xfree86-it.lst, xfree86.lst, xfree86.xml in /etc/X11/xkb/rules/
- enabled build of synaptics driver again (build problems fixed)
- p_855_display_switch.diff:
  * Fix for Intel 855 mobile chipsets to work around the problem
  that the video BIOS misadjusts the framebuffer start address
  and doesn't set up HW cursor correctly when switching output
  channels (internal (LCD) external (CRT) both). The patch simply
  adds a timer function to the driver which interrogates the BIOS
  once per second if anything has changed.
* Wed Apr 14 2004 - sndirsch@suse.de
- xim config file:
  * set the environment variable USE_XOPENIM to "yes" when ATOK-X
  is used to make ATOK-X work with OpenOffice (Bug #38903)
* Tue Apr 13 2004 - sndirsch@suse.de
- added README for synaptics input driver (Bug #38822)
- removed wrong DRI provides in XFree86-server
* Sat Apr 10 2004 - sndirsch@suse.de
- updated to official release X.Org X11R6.7.0 (we used a CVS
  version for 9.1)
- p_XOrg-X11R6_7_0-workaround.diff:
  * workaround for Xvnc build
- p_amd64-afb.diff:
  * fixed AMD64 build (X.Org Bugzilla #448)
- p_amd64-v4l.diff
  * enabled v4l build on AMD64 (X.Org Bugzilla #449)
- adjusted some patches to new X11 sources:
  * xterm-simple.patch (xterm-patches.tar.gz)
  * p_XFree86-4.3-kbdmapping.diff
  * p_fixes.diff
  * p_xkb-cherryblueb.diff
- disabled build of synaptics driver for now (build problems)
- Xserver: added compatibility link XFree86 --> Xorg on SUSE > 9.1;
  renamed Xorg --> XFree86 on SUSE <= 9.1
- added compatibility link xf86config --> xorgconfig
- adjusted fileslist to new filenames:
  * xf86cfg --> xorgcfg
  * removed fonttosfnt (no longer available, simply not working yet)
  * libXft.so.2.1.1 --> libXft.so.2.1.2
  * added /usr/X11R6/bin/Xorg for SuSE > 9.1
  * added xorgconfig
* Sun Apr 04 2004 - sndirsch@suse.de
- p_XFree86-4.3.0-i18n-font_encodings-20030609-incr.diff,
  p_XFree86-4.3.0-i18n-nls-20030609-incr.diff, p_fixes-incr.diff:
  * incremental patches for improving gb18030 support (Bug #38201)
- p_vnc-2004-04-06.diff:
  * updated to Alan's latest VNC sources; probably fixes some input
  related problems
* Sun Apr 04 2004 - mfabian@suse.de
- Bugzilla #38256: "xterm should use the new IUTF8 flag"
  add p_xterm_iutf8.diff.
- Bugzilla #38203: "Let libX11 forward XNSpotLocation event to XIM
  server in OffTheSpot and Root mode."
  add p_xim_spot.diff.
- Bugzilla #38202: "Add fake bold support to Xft library."
  add p_xft_cjk.diff.
* Thu Apr 01 2004 - sndirsch@suse.de
- xdm configuration:
  * Xsetup: fixed gnome path (Bug #37852)
* Thu Apr 01 2004 - sndirsch@suse.de
- xdm/xinit configuration:
  * sys.xsession: fixed use of x11-ssh-askpass for AMD64
  * xinitrc: added "#ssh-add"; so it's disabled by default
* Wed Mar 31 2004 - sndirsch@suse.de
- p_fixes.diff:
  * programs/Xserver/hw/xfree86/drivers/i810/i830_driver.c:
  fixed memory detection/allocation for i845G chipsets
* Wed Mar 31 2004 - sndirsch@suse.de
- p_fixes.diff
  * programs/Xserver/GL/glx/single2.c:
  Fix the GLLibraryVersion string allocation to accomodate for
  the terminating \0 character which would otherwise corrupt the
  malloc heap (Bugzilla@fd.o 385, John Dennis). (Bug #36706)
* Mon Mar 29 2004 - sndirsch@suse.de
- removed workaround in p_suse.diff for kaffeine crashes
- p_xlib-rmdb.diff:
  * correct fix for kaffeine crashes (Bug #35957)
* Fri Mar 26 2004 - sndirsch@suse.de
- p_suse.diff:
  * reverted 'fix' for memory leak in libX11 to prevent Kaffeine
  and probably other (multithreaded?) applications from crashing
  on exit (Bug #35957)
* Wed Mar 24 2004 - sndirsch@suse.de
- switch driver fglrx --> radeon in %%post of XFree86, as fglrx
  driver simply doesn't work on SuSE 9.1. It's not yet adjusted for
  current XFree86 version and kernel 2.6 with REGPARM enabled
  (Bug #35859).
* Tue Mar 23 2004 - sndirsch@suse.de
- added support for HP ZX2 chipsets (IA64)
* Mon Mar 22 2004 - sndirsch@suse.de
- host.def:
  * specified "/dev/urandom" as random device file (Bug #35872)
- p_fixes.dif:
  * enabled build of i810 driver on AMD64 (Bug #36581)
- XFree86-Mesa package:
  * added /usr/X11R6/%%{_lib}/modules to filelist
* Fri Mar 19 2004 - sndirsch@suse.de
- new p_x86-64_ioctl32.diff:
  * improved OpenGL 32bit application support on AMD64
- p_fixes2.diff (more fixes by Egbert Eich):
  * Protect removeOverlapsWithBrides() from NULL pointer in target
  * Fixed stretching option and centering in C&T driver
  * Added support for memory size tweaking in BIOS for i845
  * Removed video playback dependency on Accel in NSC drivers
  * Fix HW cursor state when entering VT as some BIOSes seem to
  enable it unconditionally
  * Fixed Emulate3Button message to distinguish between 'hard'
  (ie. configured) and 'soft' (ie. automatic emulation that is
  disabled as soon as the middle button is pressed)
* Fri Mar 19 2004 - sndirsch@suse.de
- moved the GL driver libs in /usr/X11R6/%%{_lib}/modules/dri/*.so
  to XFree86-Mesa to get rid of XFree86-server-32bit
* Thu Mar 18 2004 - sndirsch@suse.de
- updated to Xorg CVS snapshot 2004-03-18:
  50. Protect removeOverlapsWithBrides() from NULL pointer in target
  (Egbert Eich).
  49. Merge fixes required to build and run on Solaris x86 with Sun compilers
  from XORG-CURRENT branch.  (Alan Coopersmith)
  48. Allow printver program to fail to build, which is required by
  distributions that do not include the Xserver/hw/xfree86
  directory (Harold L Hunt II).
  47. Fix Xaw shared lib build on Cygwin (Ralf Habacker).
  46. Can now build XLOAD under Cygwin (Earle F. Philhower III).
  45. Readding Monitor information obtained by DDC to the config file
  in commented out form (Egbert Eich).
  44. Making a log message by the mouse driver more meaningful (Egbert Eich).
  43. Incorporate ServerInterpreted address family authentication from IPv6
  second public review.  (Alan Coopersmith)
  42. Use system version of FreeType on Solaris 10 and provide instructions on
  using it if it's installed on previous releases.  (Alan Coopersmith)
  41. Fix for insufficient allocation of a list in
  GetDeviceDontPropagateList() on 64bit machines (Andreas Luik).
  40. Update SHAPE extension protocol spec to version 1.0.1, fixing
  freedesktop.org bugzilla #282 (old X.org defect #9453) (Alan Coopersmith)
  39. Preparing branch for TMc (Egbert Eich).
  38. Backing out patch 27 as it was inappropriate for the RELEASE branch
  and bogus anyway (see bugzilla #303) (Egbert Eich).
  37. backing out 30.: the sleep() exists to bring the log message to the
  attention of the user which points to a problem elsewhere. Therefore
  the problem should be fixed where it originates. To be strict we could
  make the function fail instead of just trying to point the user at
  the problem (Egbert Eich).
- added p_XFree86-4.3-ppc64.diff again (see Changelog 38.)
- updated synaptics driver to 0.12.5
- p_fixes.diff:
  * xterm fix: remove  call  to  ShowCursor  from  SetCursorBlink()
  since that is redundant, and can cause display glitches if the
  cursor is already blinking (Bug #34359, Andreas Schwab)
* Tue Mar 16 2004 - sndirsch@suse.de
- go back to upstream libXft; added p_libXft.diff, which fixes
  bitmap rendering together with a freetype2 patch (Bug #36143)
* Tue Mar 16 2004 - sndirsch@suse.de
- libXft-2.1.3-old.tar.bz2:
  * go back to our *old* libXft "2.1.3" as bitmap font rendering
  via Xft is completely broken since 2.1.3; our *old*  2.1.3 is
  *not* the official 2.1.3 release you can download now; looks like
  Keith made a new tarball of 2.1.3 with new sources and radical
  changes in it :-(
* Mon Mar 15 2004 - sndirsch@suse.de
- fixed VNC standalone server (Bug #33716)
  * removed p_vnc-pscreen.diff
  * new p_vnc-region.diff
* Sun Mar 14 2004 - sndirsch@suse.de
- don't build shared libXxf86vm for SuSE <= 9.0
* Sun Mar 14 2004 - sndirsch@suse.de
- updated to Xorg CVS snapshot 2004-03-14:
  36. Fix linker flags & library dependencies for libXfont and freetype font
  module on Solaris builds.  (Alan Coopersmith)
  35. Added a hack to fc-lang and fc-list to prevent installation if
  define InstallFontconfigLibrary NO (Egbert Eich).
  34. Updated Xft to 2.1.5 (Egbert Eich).
  33. Make ELF loader work on systems with non-exec stack/heaps (bugzilla #296,
  John Dennis, Mike Harris).
  32. Fix for xdm to work on a non-IPv6 system when built with IPv6 support
  (bugzilla #287, Peter Breitenlohner) (confirmed by: Alan Coopersmith).
  31. Fix Xi XselectExtensionEvent for 64 bit machines (bugzilla #285,
  Andreas Luik) (confirmed by: Paul Anderson, Alan Coopersmith).
* Sun Mar 14 2004 - schwab@suse.de
- More fixes for macintosh keyboard and apply them everywhere.
* Thu Mar 11 2004 - sndirsch@suse.de
- updated to Xorg CVS snapshot 2004-03-11
- removed p_XFree86-4.3-ppc64.diff (merged upstream)
* Wed Mar 10 2004 - sndirsch@suse.de
- xdm/kdm configuration:
  * Xservers: start Xserver with "-br" (black background)
  * Xsession: fixed finally tmp race (Bug #34253)
  * Xsession: do not load global Xmodmap file (Bug #35213)
* Tue Mar 09 2004 - sndirsch@suse.de
- p_fixes.diff:
  * SharedXrandrReqs already defined in lnxLib.tmpl of xorg tree
- updated to Xorg CVS snapshot 2004-03-09
- removed no longer required patches
  * p_libXft-2.1.3.diff
  * p_libXft-2.1.3-fix.diff
* Tue Mar 09 2004 - sndirsch@suse.de
- switched to xorg tree on fd.o (snapshot 2004-03-08)
- removed no longer required patches
  * p_4.3.99.902-4.4.0.diff
  * p_freetype.diff
- adjusted patches
  * p_XFree86-4.3-ppc64.diff
  * p_XFree86-4.3.0-i18n-font_encodings-20030609.diff
  * p_XFree86-4.3.0-i18n-nls-20030609.diff
  * p_fixes.diff
  * p_libXft-2.1.3.diff
  * p_mips-fixes.diff
  * p_suse.diff
  * p_vnc-region.diff
  * p_vnc.diff
  * p_x86-64_ioctl32.diff
* Sun Mar 07 2004 - sndirsch@suse.de
- fixed filelist for axp
* Thu Mar 04 2004 - sndirsch@suse.de
- xterm-color-bug33180.dif:
  * use old xterm color scheme for better contrast (Bug #33180)
* Thu Mar 04 2004 - sndirsch@suse.de
- reverted broken security fix for Xsession script (see also
  comment #16 of Bug#34253)
* Thu Mar 04 2004 - sndirsch@suse.de
- Xsession script:
  * removed resetting of default background and cursor completely
* Tue Mar 02 2004 - sndirsch@suse.de
- xf4vnc-20040302.tar.bz2:
  * latest xf4vnc CVS version; obsoletes p_xf4vnc-20040201.diff
* Tue Mar 02 2004 - sndirsch@suse.de
- p_4.3.99.902-4.4.0.diff: more fixes
* Mon Mar 01 2004 - schwab@suse.de
- Make DISPLAYMANAGER_XSERVER_TCP_PORT_6000_OPEN work.
* Mon Mar 01 2004 - sndirsch@suse.de
-  compile libXxf86vm also as shared library as it is now used by
  shared libGL, which is replaced by nvidia driver (Bug #35188)
* Sun Feb 29 2004 - sndirsch@suse.de
- fixed build for ppc64
* Sat Feb 28 2004 - sndirsch@suse.de
- don't build XFree86-server-glx for s390/s390x (fixes build)
- p_4.3.99.902-040228.diff: more fixes
* Fri Feb 27 2004 - sndirsch@suse.de
- moved files, which are replaced by nvidia installer, to new
  package XFree86-server-glx to make updates of XFree86-server
  via YOU easier; nvidia driver no longer needs to be uninstalled
  if XFree86-server needs to be updated
- XFree86-server-glx needs to be prerequired by XFree86-server
  for a complete SuSE Linux update to make sure that nvidia driver
  is uninstalled
- uninstall nvidia driver installation before an update of
  Mesa-devel as well (bugfix)
- xdm pam config file uses pam_pwcheck now
* Thu Feb 26 2004 - sndirsch@suse.de
- fixed tmp race in /etc/X11/xdm/Xsession script (Bug #34253)
* Mon Feb 23 2004 - sndirsch@suse.de
- p_x86-64_ioctl32.diff:
  * added missing ioctl32 functions
* Sat Feb 21 2004 - sndirsch@suse.de
- p_4.3.99.902-040221.diff: more fixes
* Fri Feb 20 2004 - sndirsch@suse.de
- added support for 3D accelerated 32bit OpenGL applications in
  AMD64 64 bit environment (again)
* Fri Feb 20 2004 - sndirsch@suse.de
- p_suse.diff:
  * use shared libusb on SuSE > 9.0 for linking Xserver
* Thu Feb 19 2004 - sndirsch@suse.de
- downgraded to 4.3.99.902 (4.4.0 RC2) because of license issues
* Wed Feb 18 2004 - sndirsch@suse.de
- added missing require XFree86-devel to XFree86-Mesa-devel
* Tue Feb 17 2004 - kukuk@suse.de
- Include /usr/X11R6/include/X11/pixmaps on s390/s390x
* Mon Feb 16 2004 - sndirsch@suse.de
- libXft: reverted bump to version 2.1.1, which made more problems
  than gave us benefit; it's now 2.1 again
* Thu Feb 12 2004 - ro@suse.de
- lib/Xft/Imakefile: output VERSION like PACKAGE_VERSION
  in SUBSTVARS
* Tue Feb 10 2004 - sndirsch@suse.de
- updated libXft to release 2.1.3 (libXft.so.2.1.1)
* Mon Feb 09 2004 - sndirsch@suse.de
- CardModules.addon: removed options for firegl23 driver
- updated HALlib (release: 2003-07-21)
- removed tdfx DRI support on axp
- no longer set FX_GLIDE_SWAPINTERVAL for Banshee boards
- removed driver for Gunze touch panels
- updated wacom driver to stable release 0.6.0
- removed pacebook touchscreen driver
- xserverrc: handle new sysconfig variable
  DISPLAYMANAGER_XSERVER_TCP_PORT_6000_OPEN to start Xserver
  accordingly
* Sun Feb 08 2004 - sndirsch@suse.de
- updated to XFree86 CVS 04-02-08
- removed graphireusb input module; no longer required with the new
  wacom driver
* Sat Feb 07 2004 - sndirsch@suse.de
- handle new sysconfig variable
  DISPLAYMANAGER_XSERVER_TCP_PORT_6000_OPEN in SuSEconfig.xdm to
  configure Xservers file accordingly; use it by startx as well
- use the same Xservers file for xdm and kdm
* Fri Feb 06 2004 - sndirsch@suse.de
- p_xdm.diff:
  * ignore reserve lines in /etc/X11/xdm/Xservers; required for kdm
* Sun Feb 01 2004 - sndirsch@suse.de
- updated to XFree86 CVS 04-02-02
- added required "-fno-strict-aliasing" to wacom driver build
- p_XFree86-4.3.0-i18n-nls-20030609.diff:
  * added missing XI18N_OBJS files for zh_CN.gb18030, zh_HK.big5
  (Bug #34282)
- added missing compatibility symlinks for gr, cs, cs_qwerty in
  /etc/X11/xkb/symbols/pc
* Sun Feb 01 2004 - sndirsch@suse.de
- updated to VNC CVS 04-02-01 (including host.def)
* Tue Jan 27 2004 - sndirsch@suse.de
- updated to XFree86 CVS 04-01-27
- linuxwacom-0.5.4-beta.tar.bz2/p_linuxwacom-0.5.4-beta.diff:
  * use latest sources from linuxwacom.sf.net for wacom driver now
* Sat Jan 24 2004 - sndirsch@suse.de
- fixed install path for DRM kernel modules
* Sat Jan 24 2004 - sndirsch@suse.de
- use official installed 'nvidia-installer' instead of
  'tiny-nvidia-installer' for uninstalling nvidia driver cleanly
  (enabled now for x86_64 as well)
* Fri Jan 23 2004 - sndirsch@suse.de
- cleanup in Makefile.module (Kernel 2.4 build)
* Thu Jan 22 2004 - sndirsch@suse.de
- adjusted build of DRM modules to new kernel 2.6 build mechanism
* Sun Jan 18 2004 - sndirsch@suse.de
- new p_fixes.diff:
  * fixed dynamic dependancies of libXrandr (Bug #34012)
* Fri Jan 16 2004 - sndirsch@suse.de
- updated to XFree86 CVS 04-01-16
- xim: add option "-cannaserver unix" for kinput2
* Fri Jan 16 2004 - kukuk@suse.de
- Add pam-devel to neededforbuild
* Wed Jan 14 2004 - agruen@suse.de
- updated synaptics input driver to version 0.12.3
* Tue Jan 13 2004 - sndirsch@suse.de
- updated to XFree86 CVS 04-01-12
- fixed build on ppc64
* Fri Jan 09 2004 - sndirsch@suse.de
- updated to XFree86 CVS 04-01-09
- adjusted p_fixes.diff
* Thu Jan 08 2004 - sndirsch@suse.de
- p_xterm_bold_noluit.diff --> p_xterm_noluit.diff (fixes for
  emulated bold fonts already applied upstream)
- xterm-fontsettings.dif: *locale: true --> checkfont
* Thu Jan 08 2004 - sndirsch@suse.de
- p_suse.diff:
  * don't install Vera Fonts (already in an external package)
* Tue Jan 06 2004 - sndirsch@suse.de
- don't build shared libxkbui/libxkbfile on SuSE <= 9.0
- build static freetype module on SuSE <= 9.0
* Mon Jan 05 2004 - schwab@suse.de
- Use macintosh keymap for all mac models.
* Mon Jan 05 2004 - sndirsch@suse.de
- p_xsload.diff:
  * fixed loading of new nvidia driver (1.0-5328)
* Sun Jan 04 2004 - sndirsch@suse.de
- updated to XFree86 CVS 04-01-04
* Sat Dec 27 2003 - sndirsch@suse.de
- updated to XFree86 CVS 03-12-27
* Mon Dec 22 2003 - sndirsch@suse.de
- updated to XFree86 CVS 03-12-22
- adjusted p_fixes.diff, p_XFree86-4.3.0-i18n-nls-20030609.diff,
  xterm-simple.patch and Wraphelp.c
- updated synaptics input driver
* Sat Dec 20 2003 - sndirsch@suse.de
- xsload.sh:
  * wrapper script for xsload: workaround if nvidia driver module
  can't be loaded by xsload
* Tue Dec 09 2003 - sndirsch@suse.de
- updated to XFree86 CVS 03-12-09
- adusted p_vnc-region.diff
- enabled build of DRM kernel modules for Kernel 2.6
- p_freetype.diff
  * improved version of Imakefile
  * fixed build for freetype 2.1.7
- cleanup in specfile
* Fri Dec 05 2003 - sndirsch@suse.de
- fixed build for ppc64
* Wed Dec 03 2003 - sndirsch@suse.de
- updated to XFree86 CVS 03-12-03
- disabled bitmap encoding on-the-fly for now as it currently
  simply doesn't work at all
- fixed build for s390(x)
* Sat Nov 29 2003 - sndirsch@suse.de
- updated to XFree86 CVS 03-11-23:
  * fixes CID-keyed font related crash (Bug #33247)
- adusted p_vnc-region.diff
* Fri Nov 28 2003 - sndirsch@suse.de
- UCS derived fonts are no longer built/installed; patched mkfontdir
  to create entries for all possible encodings (p_suse.diff)
  (Bug #26091)
* Wed Nov 26 2003 - sndirsch@suse.de
- updated to XFree86 CVS 03-11-26
  * fixes font related Xserver crash (Bug #33340)
* Sun Nov 23 2003 - sndirsch@suse.de
- updated to XFree86 CVS 03-11-23
* Sat Nov 22 2003 - sndirsch@suse.de
- use old REGION macros for VNC module / Xvnc server (Bug #33258)
* Thu Nov 20 2003 - sndirsch@suse.de
- build v4l driver also for AMD64
- p_xkb-cherryblueb.diff:
  * support for "Cherry CyMotion Master XPress" keyboard
* Sun Nov 16 2003 - sndirsch@suse.de
- updated to XFree86 CVS 03-11-16
* Fri Nov 14 2003 - sndirsch@suse.de
- removed dangling symlinks /etc/X11/xdm/{xdm-pid,xdm-error}; these
  are now created by the xdm script, when xdm is used; too many
  customers are complaining about
* Thu Nov 13 2003 - sndirsch@suse.de
- updated to XFree86 CVS 03-11-13
  * adjusted ppc64 patch
  * adjusted freetype patch
  * removed ia64 patch; already applied upstream
  * added p_vnc-pscreen.diff to fix VNC build
* Wed Nov 12 2003 - sndirsch@suse.de
- Xsetup script for xdm:
  * only check for kdm if installed
* Tue Nov 11 2003 - sndirsch@suse.de
- km_drm:
  * disabled build for kernel 2.6; use the DRM modules of
  kernel 2.6 because these are more up-to-date than the
  one of XFree86
* Mon Nov 10 2003 - sndirsch@suse.de
- adjusted ppc64 patch, so it can be applied for all architectures
* Fri Nov 07 2003 - sndirsch@suse.de
- xf4vnc changes:
  * enabled build of vncevent/libXvncExt and vncviewer (including
  encoding plugins)
- some cleanup in specfile
* Thu Nov 06 2003 - sndirsch@suse.de
- updated to xf4vnc CVS 2003-04-24, which no longer requires to
  patch the video drivers; adjusted p_vnc.diff and host.def for
  this
* Sun Nov 02 2003 - sndirsch@suse.de
- updated to XFree86 CVS 03-11-02
- adjusted p_fpic.diff, p_xsload.diff, xterm patches to new sources
- added shared libGLw to filelist of XFree86-libs
* Sun Nov 02 2003 - sndirsch@suse.de
- new p_vnc.diff:
  * fixed build for mips/gcc-3.4
* Fri Oct 31 2003 - sndirsch@suse.de
- build static libxkbfile with "-fPIC"
- fixed build for s390/s390x
- added scanpci to filelist for mips
* Fri Oct 31 2003 - sndirsch@suse.de
- build static libfontenc with "-fPIC"
* Thu Oct 30 2003 - sndirsch@suse.de
- disabled build of shared Xv, Xxf86misc, Xxf86dga, Xxf86vm libs
- removed XFree86-compat-libs; XFree86-compat-libs.sh of package
  xf86tools can be used to create the shared libs, if still
  required
- fixed build on ppc64 (adjusted p_XFree86-4.3-ppc64.diff)
- Xresources, Xmodmap and Xmodmap.remote in /usr/X11R6/lib/X11 are
  now symlinks to the one in /etc/X11; they were empty before, which
  was simply wrong
* Thu Oct 30 2003 - sndirsch@suse.de
- link dynamic libGL against static libXxf86vm; should fix a lot
  of build errors of other packages
* Wed Oct 29 2003 - sndirsch@suse.de
- p_ia64-dri.diff: fixes build on IA64
* Wed Oct 29 2003 - sndirsch@suse.de
- XTerm.ad: use "*locale: true" as long as p_xterm_bold_noluit.diff
  is not adjusted yet
* Wed Oct 29 2003 - sndirsch@suse.de
- fixed xsload on x86_64 (Bug #32723)
- updated to XFree86 CVS 03-10-27
  * adjusted xterm patches
  * adjusted GB18030 patches from SUN
  (p_XFree86-4.3.0-i18n-font_encodings-20030609.diff,
  p_XFree86-4.3.0-i18n-nls-20030609.diff)
  * adjusted p_fixes.diff
  * adjusted p_fpic.diff
  * adjusted p_freetype.diff
  * adjusted p_suse.diff
  * adjusted p_vnc.diff
  * adjusted p_xsload.diff
  * renamed mips_fixes.diff to p_mips-fixes.diff
  * enabled -fPIC for libvncauth (p_libvncauth-fpic.diff)
  * removed p_i18n-20021015.diff (old GB18030 patch from Turbolinux
  for UL1, we're using SUN GB18030 patches now)
  * removed no longer required patches (already in CVS)
- drivers_03-08-19.diff
- drivers_03-08-19.x86_64.diff
- drivers_03-08-19_ati.diff
- drivers_03-08-19_nv-xaa.diff
- drivers_03-08-19_nv.diff
- drivers_03-08-19_r128.diff
- drivers_03-08-19_vnc.diff
- p_driver-fixes.diff
- p_driver_updates2.diff
- p_driver_updates3.diff
- p_driver_updates4.diff
- p_i8xx-loader.diff
- p_jmp-ia64.diff
- p_kbd-ja.diff
- p_more_fixes.diff
- p_more_fixes2.diff
- p_radeon-agpbase.diff
- p_xfs-sec.diff
- p_xkb2.diff
- p_xlib.diff
- p_xterm.diff
* Sat Oct 25 2003 - sndirsch@suse.de
- XFree86-Mesa provides/obsoletes mesa (Bug #32551)
* Tue Oct 14 2003 - sndirsch@suse.de
- removed "-mminimal-toc" compiler option for ppc64; not required
  any more
* Mon Oct 06 2003 - adrian@suse.de
- fix build for mips, ppc and glibc 2.2 enviroments
- use RPM_OPT_FLAGS on mips
* Wed Oct 01 2003 - sndirsch@suse.de
- specfile cleanup:
  * use of mktemp
  * removed ghosts
* Mon Sep 29 2003 - sndirsch@suse.de
- p_fpic.diff:
  * compile also static libfontenc with "-fPIC"
* Mon Sep 22 2003 - sndirsch@suse.de
- new drivers_03-08-19_nv-xaa.diff:
  * replaced workaround (disabling of XAA-SolidTwoPointLine) with
  a real fix by Mark V. (Bug #31078)
- new p_more_fixes2.diff:
  * fixed wrong XML in rules/xfree86.xml (Bug #31723)
* Mon Sep 22 2003 - mls@suse.de
- remove "Provides: XFree86-doc" from XFree86
* Fri Sep 19 2003 - sndirsch@suse.de
- drivers_03-08-19_nv-xaa.diff:
  * disabled XAA-SolidTwoPointLine in nv driver; workaround for
  xscreensaver, which crashes Xserver sometimes (Bug #31078)
- p_driver_updates4.diff:
  * fix artefacts on xvideo playback windows, when cursor themes
  are used (Bug #31427)
* Tue Sep 16 2003 - sndirsch@suse.de
- set attributes of all shell scripts below /etc/X11/xdm to 755
  (Bug #30903)
- p_jmp-ia64.diff:
  * important patch for IA64
* Tue Sep 16 2003 - sndirsch@suse.de
- p_radeon-agpbase.diff:
  * fixes machine freeze during console switching when DRI is
  enabled on AMD64 (Bug #29512)
- only require tiny-nvidia-installer for x86 (Bug #31008)
* Fri Sep 12 2003 - sndirsch@suse.de
- p_driver_updates3.diff:
  * driver fixes for sis and i810
* Fri Sep 12 2003 - sndirsch@suse.de
- nvidia-installer --> tiny-nvidia-installer (see also changes
  in xf86tools package)
- p_more_fixes2.diff:
  * important fixes from current XFree86 CVS Head
* Thu Sep 11 2003 - sndirsch@suse.de
- set attributes of etc/X11/xdm/Xsession to 755 (Bug #30539)
* Thu Sep 11 2003 - sndirsch@suse.de
- global Xresources:
  * moved xterm resources to xterm app-defaults
  * removed duplicate entries
* Thu Sep 11 2003 - sndirsch@suse.de
- drivers_03-08-19.x86_64.diff:
  * fixed Xvideo Xserver crash on x86_64 with ATI driver
* Wed Sep 10 2003 - sndirsch@suse.de
- new drivers_03-08-19_ati.diff:
  * AMD64Architecture --> x86_64Architecture (Bug #30393)
* Mon Sep 08 2003 - sndirsch@suse.de
- new p_xkb2.diff:
  * added missing th_tis/th_pat keytables
* Mon Sep 08 2003 - sndirsch@suse.de
- diff.driver_updates2:
  * sis driver update
  * missing hunks of previous patches
  * fixes for tdfx, glint, i810 and trident driver
  * some important bugfixes from current XFree86 CVS
- diff.xkb2:
  * xkb fixes
* Sun Sep 07 2003 - sndirsch@suse.de
- drivers_03-08-19_vnc.diff:
  * added vnc support for nv/ati/r128/radeon drivers again
* Sat Sep 06 2003 - sndirsch@suse.de
- p_kbd-ja.diff:
  * jp106: fixed backslash/underscore, bracketright/braceright
- drivers_03-08-19_r128.diff:
  * fixed r128 driver start on FSC E-Series Lifebook (Bug #30106)
* Thu Sep 04 2003 - sndirsch@suse.de
- new p_fixes.diff:
  * don't build libxdmgreet any longer on axp
- added desktop files
- moved xterm resources from global Xresources file to xterm
  app-defaults
* Wed Sep 03 2003 - schwab@suse.de
- Remove obsolete elfloader patch.
* Wed Sep 03 2003 - kukuk@suse.de
- Fix initial file permissions of extra font data
* Tue Sep 02 2003 - sndirsch@suse.de
- drivers_03-08-19_2.diff renamed to drivers_03-08-19_ati.diff
- drivers_03-08-19_nv.diff:
  * fixes Xserver crash when Xvideo is used (unresolved symbols)
* Tue Sep 02 2003 - sndirsch@suse.de
- new p_fixes.diff:
  * updated armada (Compaq Evo support)
  Author: Andrej Primc <andrej.primc@siol.net>
* Mon Sep 01 2003 - kukuk@suse.de
- Add %%verify option for extra font data
* Mon Sep 01 2003 - sndirsch@suse.de
- rcxfs: added $remote_fs to Required-Start (Bug #29785)
- fixed XFree86 version in specfile (now 4.3.0.1)
* Fri Aug 29 2003 - sndirsch@suse.de
- xdm changes:
  * global Xmodmap/Xresources are loaded now (Bug #29538)
  * feedback@suse --> http://www.suse.de/feedback (Bug #29638)
- removed install script (Bug #29662)
* Thu Aug 28 2003 - sndirsch@suse.de
- new p_more_fixes.diff:
  * fixed Sig11 in mkfontscale (Bug #29504)
* Wed Aug 27 2003 - sndirsch@suse.de
- removed unusable ffb/gamma DRI libs to save some space
* Tue Aug 26 2003 - sndirsch@suse.de
- new p_xlib.diff (still disabled):
  * some additional xlib patches
* Tue Aug 26 2003 - sndirsch@suse.de
- new p_fixes.diff:
  * fixed XIM Bug #618 (XFree86 Bugzilla)
* Mon Aug 25 2003 - sndirsch@suse.de
- removed p_s3-trio64.diff
- p_driver-fixes.diff: driver fixes
- new drivers_03-08-19.tar.gz: removed sis/s3 driver from tarball
* Mon Aug 25 2003 - sndirsch@suse.de
- disabled p_xlib.diff as it breaks keyboard handling for (x)emacs
  totally (Bug #28995); reverted adjustments for p_bug17759.diff
  therefore
* Sat Aug 23 2003 - sndirsch@suse.de
- adjusted p_x86-64_ioctl32.diff to new p_fixes.diff
* Fri Aug 22 2003 - sndirsch@suse.de
- p_xfs-sec.diff:
  * security patch for xfs (Bug #29262)
- new p_fixes.diff
  * fixed Bug #484 of XFree86 Bugzilla
- adjusted p_i8xx-loader.diff to new p_fixes.diff
* Fri Aug 22 2003 - sndirsch@suse.de
- p_more_fixes.diff/p_xlib.diff/p_xterm.diff:
  * important fixes from current XFree86 CVS Head
- adjusted patches because of above new patches:
  * xterm patches
  * p_XFree86-4.2.0-i18n-xlib-20020322.diff
  * p_XFree86-4.3.0-i18n-nls-20030609.diff
  * p_bug17759.diff
  * p_vnc-drivers.diff
- disabled p_s3-trio64.diff
* Thu Aug 21 2003 - sndirsch@suse.de
- drivers_03-08-19.diff/drivers_03-08-19_2.diff/::
  * fixed ATI/R128/RADEON driver start (Bug #29157)
- added "Requires: fontconfig-devel" to XFree86-devel package
* Tue Aug 19 2003 - sndirsch@suse.de
- drivers_03-08-19.tar.gz: updated nv driver
* Mon Aug 18 2003 - sndirsch@suse.de
- stop xfs daemon if XFree86 package is removed (Bug #29055)
* Sun Aug 17 2003 - sndirsch@suse.de
- new p_XFree86-4.3-kbdmapping.diff by olh (fixes 2.6 kernel)
* Sun Aug 17 2003 - sndirsch@suse.de
- new drivers (nv, s3, ati/r128/radeon, sis, via) from current CVS
* Fri Aug 15 2003 - sndirsch@suse.de
- global xinitrc should be executable (Bug #29002)
* Wed Aug 13 2003 - sndirsch@suse.de
- XFree86-4.3.0.tar.bz2 --> XFree86-4.3-branch_03-08-13.tar.bz2:
  * updated XFree86 sources to current stable 'xf-4_3-branch'
  XFree86 branch (date: 03-08-13)
- p_fixes.diff, p_suse.diff:
  * adjusted our fixes and SuSE specific patches to the new
  sources
* Wed Aug 06 2003 - sndirsch@suse.de
- .xim: handle zh_HK locales as well (using xcin)
* Wed Jul 30 2003 - sndirsch@suse.de
- XFree86-Mesa package: duplicate libGL to make workarounds like
  LD_PRELOAD possible if nvidia driver is installed and its libGl
  does not work (see Bug #26665 for an example)
* Thu Jul 24 2003 - sndirsch@suse.de
- p_fpic.diff:
  * compile also static libXau with "-fPIC"
* Thu Jul 10 2003 - sndirsch@suse.de
- .xim: use SCIM instead of xcin for simplified chinese
* Wed Jul 09 2003 - sndirsch@suse.de
- p_fixes.diff:
  * savage driver: set the correct clock for some BIOSes (Bug #27354)
* Fri Jul 04 2003 - sndirsch@suse.de
- p_s3-trio64.diff:
  * added doublescan support (320x240)
* Thu Jul 03 2003 - sndirsch@suse.de
- p_suse.diff:
  * added some more combinations to type EUR symbol to UTF-8
  Compose table
- p_s3-trio64.diff:
  * support for some S3 Trio64 boards
* Tue Jul 01 2003 - sndirsch@suse.de
- added gb18030 support (Qingjiang (Brian) Yuan):
  * p_XFree86-4.2.0-i18n-xlib-20020322.diff
  * p_XFree86-4.3.0-i18n-font_encodings-20030609.diff
  * p_XFree86-4.3.0-i18n-nls-20030609.diff
* Wed Jun 25 2003 - sndirsch@suse.de
- p_fixes.diff:
  * O_SYNC no longer required for ia64 according to Andreas Schwab
* Wed Jun 25 2003 - sndirsch@suse.de
- p_fixes.diff:
  * reverted O_SYNC patch, which broke our Xvideo performance (Bug #26715)
- removed wrong resource for grok in Xresources file (Bug #27519)
* Mon Jun 23 2003 - sndirsch@suse.de
- p_fixes.diff:
  * fixed build on sparc (Thorsten Kukuk)
* Mon Jun 16 2003 - sndirsch@suse.de
- p_fixes.diff:
  * fixed recognition of Explorer mouse (Egbert Eich).
* Wed Jun 11 2003 - sndirsch@suse.de
- p_fixes.diff:
  * make zh_CN an alias to zh_CN.eucCN again (zh_CN.eucCN is the same
  as zh_CN.GB2312) to make it agree with glibc. For glibc zh_CN uses
  GB2312 encoding. This change makes xcin work again in zh_CN locale.
* Wed Jun 11 2003 - kukuk@suse.de
- Fix list of included directories
* Thu Jun 05 2003 - sndirsch@suse.de
- fixed Xvnc build for s390/s390x
- p_fixes.diff:
  * integrated p_elfloader.diff
- p_suse.diff:
  * treat acute as apostrophe in Latin9 via Compose
* Wed Jun 04 2003 - sndirsch@suse.de
- added logfile "/var/log/xdm.errors" and pidfile "/var/run/xdm.pid"
  as ghosts to specfile
- create rcxfs as an absolute symlink
- touch /var/X11R6/bin/X
- new xim config file (Mike Fabian):
  Don't force locale to ko_KR for Korean to make the new Ami able to use
  the UTF-8 improvements when running in ko_KR.UTF-8 locale.
  To be able to to enter Hangul syllables which are included in Unicode
  but are not included in KS X 1001 repertoire (For example
  U+AC02. U+AC02 can be typed as the keysequence 'r', 'k', 'R' on a
  qwerty KBD) you need to run both ami and the XIM client with
  LC_CTYPE="ko_KR.UTF-8".
  Also don't force the locale to ja_JP when starting kinput2, kinput2
  doesn't care at all for the locale, this is just superfluous and
  confusing.
* Mon Jun 02 2003 - schwab@suse.de
- Fix elfloader again.
- Fix feedback address.
- Fix release number parsing.
* Sun May 25 2003 - sndirsch@suse.de
- updated Tamil keyboard map now in p_fixes.diff
* Fri May 23 2003 - sndirsch@suse.de
- marked 'ta' file as source in specfile
* Fri May 23 2003 - sndirsch@suse.de
- added Tamil keyboard table (Bug #26888)
* Sun May 18 2003 - sndirsch@suse.de
- fixed build for mips
- some cleanup in specfile
* Thu May 15 2003 - ro@suse.de
- removed config-dist.sh
* Thu May 15 2003 - sndirsch@suse.de
- fixed filelist
* Tue May 13 2003 - sndirsch@suse.de
- p_fixes.diff:
  * improved last patch (C compliant code, fixed memory leak)
* Mon May 12 2003 - sndirsch@suse.de
- moved /usr/X11R6/lib/X11/locale/ to XFree86-libs (Bug #26788)
* Mon May 12 2003 - sndirsch@suse.de
- p_fixes.diff:
  * workaround for font embedding bug in Qt3 (Bug #26806)
* Sat May 10 2003 - sndirsch@suse.de
- p_kbd.diff:
  * rate element in struct kbd_repeat was renamed
* Tue Apr 29 2003 - sndirsch@suse.de
- build also standalone VNC Xserver
* Sun Apr 27 2003 - sndirsch@suse.de
- uninstall nvidia driver cleanly in %%pre of XFree86-server and
  XFree86-Mesa as some files of a possible nvidia driver installation
  would be overwritten otherwise; added /usr/bin/nvidia-installer
  (located in xf86tools), which is used for this to 'Prereq:' of
  these packages
* Thu Apr 24 2003 - sndirsch@suse.de
- new p_fixes.diff:
  * Add test for vtSema to i8x0Sync() to prevent touching MMIO
  registers while switched away (Egbert Eich).
* Thu Apr 24 2003 - sndirsch@suse.de
- latest vnc sources (xf4vnc-20030424.tar.bz2)
- added vnc support for graphics drivers (p_vnc-drivers.diff,
  Bug #26436)
* Tue Apr 22 2003 - sndirsch@suse.de
- get rid of .xinitrc skel file
* Mon Apr 14 2003 - sndirsch@suse.de
- use system fontconfig for build
* Sat Apr 12 2003 - sndirsch@suse.de
- get rid of skel files (Bug #26166)
* Fri Apr 11 2003 - sndirsch@suse.de
- moved makedepend to -devel package
* Mon Apr 07 2003 - sndirsch@suse.de
- fixed build for mips
* Mon Apr 07 2003 - sndirsch@suse.de
- fixed build for mips/armv4l/hppa
* Sat Apr 05 2003 - sndirsch@suse.de
- new packages XFree86-Mesa/XFree86-Mesa-devel; will make XFree86
  driver-only updates easier
* Fri Apr 04 2003 - sndirsch@suse.de
- fixed installation of libGLcore.so.1 for x86_64
* Fri Apr 04 2003 - sndirsch@suse.de
- provide dummy nvidia libGLcore.so.1 for applications, which are
  still linked against libGL.so.1 of older nvidia driver releases
* Sun Mar 30 2003 - sndirsch@suse.de
- OpenGL libs (libGL/libGLU/libOSMesa/libGLw) now in XFree86-libs/
  XFree86-devel; removed XFree86-GLX/XFree86-GLX-devel therefore
- XFree86-libs/XFree86-devel also provides/obsoletes mesasoft/
  mesa-devel/mesaglu-devel now
- disabled pseudocore cursors
- cleanup in specfile
* Sun Mar 30 2003 - sndirsch@suse.de
- removed support for 3Dfx Voodoo Addon boards, as Glide 2.x will
  be dropped from distribution
- XFree86_GLX replaces mesa3dfx during update
* Sun Mar 30 2003 - sndirsch@suse.de
- changes as XFree86 3.x will be dropped:
  * xinit4/xf86config4 --> xinit/xf86config
  * simplified xserverrc
* Thu Mar 27 2003 - sndirsch@suse.de
- p_fixes.diff:
  * don't modify scanCode when using CustomKeycodes (Andreas Schwab)
  * fixed buffer overflow vulnerability (XLC locale dir)
- removed sux; now in xf86tools package
* Fri Mar 21 2003 - sndirsch@suse.de
- removed p_fontconfig.diff; fonts.conf is in xf86tools package
- integrated following patches into p_fixes.diff:
  * p_compose.diff
  * p_freetype-xlfd.diff
  * p_i830_cursor.diff
  * p_i830_savescreen.diff
  * p_i830_sync.diff
  * p_lucida.diff
  * p_mouse-pnp.diff
  * p_neo-fastfb.diff
  * p_r300-typo.diff
  * p_radeon-dri.diff
  * p_rendition.diff
  * p_savage.diff
  * p_us-bksl.diff
  * p_us-kpdl.diff
  * p_x86-64_lp64.diff
  * p_xaa-sig11.diff
  * p_xlib-memleak.diff
  * p_xterm-dec2ucs.diff
  * p_xterm_utmp.diff
* Thu Mar 20 2003 - sndirsch@suse.de
- fixed typo in Xsession/sys.xsession (Bug #25654)
* Tue Mar 18 2003 - sndirsch@suse.de
- removed "?" and ":" from xterm *charClass
* Tue Mar 18 2003 - sndirsch@suse.de
- p_i830_cursor.diff:
- fixes hw cursor position on i845/i855/i865 (Bug #25551)
* Mon Mar 17 2003 - sndirsch@suse.de
- p_x86-64_lp64.diff:
  * fixed build for new gcc (defines now LP64)
- p_XFree86-4.3-kbdmapping.diff
  * added missing special keys (Andreas Schwab)
* Mon Mar 17 2003 - ro@suse.de
- set "usessh" and "usegpg" to default "no" in .xsession
  to avoid hanging agent processes
* Mon Mar 17 2003 - werner@suse.de
- Change scanning order of X auth entries: local first (bug #25427)
* Fri Mar 14 2003 - sndirsch@suse.de
- p_i830_sync.diff:
  * XFree86 crashes in SaX2 with the i830 driver.
  Cause: XAAComposite() checks NeedToSync and calls driver
  Sync function. NeedToSync is set TRUE erronously in LeaveVT()
  which is called on a vt switch. (Bug #25402)
* Fri Mar 14 2003 - sndirsch@suse.de
- p_radeon-dri.diff:
  * fixes hangup during logout for Radeon Mobility M6/M7 chips when
  KDM is used and DRI enabled (Bug #25019)
* Fri Mar 14 2003 - sndirsch@suse.de
- p_xaa-sig11.diff:
  * fixes possible Sig11 in XAA (Bug #25376)
- enhanced XkbModel replacement (pc104 --> pc105) during update
  (Bug #25348)
* Fri Mar 14 2003 - werner@suse.de
- Make sux work even if no network available (bug #25315)
* Thu Mar 13 2003 - sndirsch@suse.de
- p_xlib-memleak.diff:
  * fixed memory leak in Xlib (Bug #25265)
* Wed Mar 12 2003 - sndirsch@suse.de
- p_rendition.diff:
  * fixes rendition driver crash (Bug #24962)
* Tue Mar 11 2003 - sndirsch@suse.de
- p_i8xx-loader.diff/p_mouse-pnp.diff:
  * better detection for protocol "Auto"; e.g. Exlorer PS/2 mouse is
  now detected
  * accelerated start of Xserver up to 20 seconds for people using
  gpm as repeater
- fixed typo in xterm font specification
* Tue Mar 11 2003 - sndirsch@suse.de
- p_XFree86-4.3-kbdmapping.diff:
  * fixes keyboard for macintosh
* Mon Mar 10 2003 - sndirsch@suse.de
- p_i830_savescreen.diff:
  * don't call saveScreen when switched away
- p_neo-fastfb.diff:
  * gives faster framebuffer writes on Neomagic (important for
  Xvideo support!)
- p_us-kpdl.diff:
  * added missing <KPDL> symbol (Bug #15581)
- p_xterm-dec2ucs.diff:
  * better support for line drawing characters in UTF-8 mode
* Fri Mar 07 2003 - sndirsch@suse.de
- p_i8xx-loader.diff:
  * some important fixes mainly for i8xx chips and XFree86 loader
- p_lucida.diff:
  * fixes average width in 19 pixel lucida fonts
- fixed ppc build
* Fri Mar 07 2003 - sndirsch@suse.de
- p_freetype-xlfd.diff:
  * fixes wrong sign of XLFD property UNDERLINE_POSITION (Bug #24789)
- p_r300-typo.diff:
  * typo in ATI Radeon R300 driver; fixes wrong dotclocks and text
  mode restoration
- new p_XFree86-4.3-kbdmapping.diff by olh (only affects ppc)
* Wed Mar 05 2003 - sndirsch@suse.de
- p_compose.diff:
  * fixes compose for ja_JP.UTF-8, ko_KR.UTF-8, zh_TW.UTF-8
* Wed Mar 05 2003 - werner@suse.de
- Fix bug #24698: Allow displays other than :0 for VNC sessions.
* Tue Mar 04 2003 - sndirsch@suse.de
- removed wrong ghost entries (Bug #24551)
  * /usr/X11R6/lib/X11/xdm/chooser
  * /usr/X11R6/lib/X11/rstart/rstartd.real
* Mon Mar 03 2003 - sndirsch@suse.de
- changes in config-dist.sh:
  * don't include nvidia dummy driver for SuSE 8.0/8.1
  * don't require resmgr for SuSE 8.0/8.1
* Mon Mar 03 2003 - sndirsch@suse.de
- p_us-bksl.diff:
  * adds missing backslash key to us keymap, which makes problems
  if multiple layouts are used, eg. in Czech (Bug #24554)
* Mon Mar 03 2003 - werner@suse.de
- Part two of fix for bug #24546: use /usr/X11R6/bin/BackGround
* Mon Mar 03 2003 - sndirsch@suse.de
- moved /etc/fonts/fonts.conf to package xf86tools (Bug #22846)
* Mon Mar 03 2003 - werner@suse.de
- Workaround in sux due broken gnome session managment (bug #24052)
* Sat Mar 01 2003 - sndirsch@suse.de
- changes in p_fixes.diff/p_x86-64_ioctl32.diff/Makefile.module
  * using Makefile.kernel now for compiling DRM sources
* Fri Feb 28 2003 - sndirsch@suse.de
- CardModules.addon:
  * added nv driver options
- system and skel .xsession:
  * using gpg-agent now
- new xsload sources; adjusted p_xsload.diff for this (Bug #24382)
* Thu Feb 27 2003 - sndirsch@suse.de
- updated to final release XFree86 4.3.0
- removed p_freetype_faces.diff (already in 4.3.0)
- /etc/X11/xdm/Xsetup:
  * only use checkproc for existing gdm binary
- pacebook.tar.gz:
  * latest driver (release 1.1, 2003-02-27)
- p_xterm_utmp.diff:
  * fixes wrong UTMP entry, wich only occurs as root (Bug #24291)
- p_savage.diff:
  * some savage driver fixes
* Wed Feb 26 2003 - sndirsch@suse.de
- p_xterm_bold_noluit.diff (Michael Schroeder)
  * fixes bold sequences (emulation) in UTF-8 mode (Bug #24289)
  * disable use of luit if non-Unicode font is specified
* Tue Feb 25 2003 - sndirsch@suse.de
- p_freetype_faces.diff:
  * fixes bug, that only first face of ttc/otc fonts could be
  opened
- make 9x13 to xterm default font again (Bug #23983)
* Mon Feb 24 2003 - sndirsch@suse.de
- added luit wrapper 'luitx' for xterm to get back the old
  behaviour during exit of xterm when background processes are
  still running (Bug #24217)
* Sat Feb 22 2003 - sndirsch@suse.de
- updated to CVS sources 4.2.99.902-20030224
- p_fixes.diff:
  * adjusted to new CVS sources
- removed p_setjmp.diff (already included in new CVS sources)
- build shared freetype module (Bug #22715)
- p_fontconfig.diff:
  * use Vera fonts as default fonts
* Fri Feb 21 2003 - sndirsch@suse.de
- XFree86 obsoletes ttmkfdir now
- build vnc module also for ia64/x86_64 (using shared jpeg lib now)
* Thu Feb 20 2003 - sndirsch@suse.de
- p_fixes.diff:
  * no longer remove complete directory from fontpath if there are
  invalid fonts in it
  * patch for O_SYNC
- p_setjmp.diff:
  * hopefully fixes freetype module errors/crashes (Bug #22715)
- p_xsload.diff:
  * adjusted to changes in p_setjmp.diff
- cleanup in specfile
* Tue Feb 18 2003 - sndirsch@suse.de
- p_suse.diff:
  * removed workaround for czech keyboards (Bug #23289, Comment #26)
- don't use "?" any longer as cut & paste seperator in xterm;
  extremely useful for pasting URLs
* Mon Feb 17 2003 - sndirsch@suse.de
- added wheel mouse support for Acrobat Reader in Xresource files
  (Bug #22916)
* Sun Feb 16 2003 - sndirsch@suse.de
- updated to CVS sources 4.2.99.901-20030216
* Sat Feb 15 2003 - sndirsch@suse.de
- updated to CVS sources 4.2.99.901-20030215
- package XFree86-GLX replaces packages NVIDIA_GLX + NVIDIA_kernel
  during an update now
* Fri Feb 14 2003 - sndirsch@suse.de
- new xsload sources (now supports "-vendor" option)
- moved xsload to package XFree86-server
- removed packages NVIDIA_GLX/NVIDIA_kernel
- moved nvidia_drv to package XFree86-server
* Thu Feb 13 2003 - sndirsch@suse.de
- updated to CVS sources 4.2.99.901-20030213
- adjusted p_fixes.diff
* Wed Feb 12 2003 - sndirsch@suse.de
- fixed keybindings for uxterm (Bug #23207)
- p_fixes.diff:
  * fixed RANDR Multihead support (Bug #22844)
* Wed Feb 12 2003 - sndirsch@suse.de
- sync .xsession with sys.xsession
* Tue Feb 11 2003 - sndirsch@suse.de
- updated to CVS sources 4.2.99.901-20030211
- added Synaptics Touchpad driver
  (synaptics-0.11.3.tar.gz/p_synaptics.diff)
- p_suse.diff:
  * compress all font encoding files
* Tue Feb 11 2003 - werner@suse.de
- Fix Backspace-Tasten bug of XTerm noticed at SuSE-Beta
- Fix ssh-agent start if no ~/.xinitrc is found
* Mon Feb 10 2003 - sndirsch@suse.de
- disabled build of VNC module for IA64
* Mon Feb 10 2003 - kukuk@suse.de
- xdm.pamd: Use pam_unix2.so instead of pam_unix.so
* Mon Feb 10 2003 - sndirsch@suse.de
- build VNC module as dynamic module again (see also Bug #22937)
* Mon Feb 10 2003 - sndirsch@suse.de
- updated to CVS sources 4.2.99.901-20030210
- adjusted p_fixes.diff
- p_suse.diff:
  * fixed keyboard group switching for czech keyboards (Bug #23289)
* Fri Feb 07 2003 - sndirsch@suse.de
- updated to CVS sources 4.2.99.901-20030207
- p_fixes.diff:
  * another fix for Xrandr library
* Fri Feb 07 2003 - werner@suse.de
- Fix Xsetup script to fit kdm/gdm needs
* Wed Feb 05 2003 - sndirsch@suse.de
- updated to CVS sources 4.2.99.901-20030205 (fixes also double
  free in libXRandr)
- removed explicit setting of Default Cursor theme; 'core' is now
  used upstream anyway
* Tue Feb 04 2003 - sndirsch@suse.de
- updated to CVS sources 4.2.99.901-20030204
- adjusted p_x86-64_ioctl32.diff
- fixed wrong docu directory names for some packages (Bug #23311)
- p_fixes.diff:
  * mkfontscale: replace "-" char with <space> in font foundry/family
  to create valid XLFD strings (Mike Fabian)
- p_vnc.diff:
  * build VNC module as static module (libvnc.a instead of vnc.so)
* Mon Feb 03 2003 - sndirsch@suse.de
- changed BuilderEMailAddr to http://www.suse.de/feedback (Bug #23276)
* Sat Feb 01 2003 - sndirsch@suse.de
- updated to current CVS sources 4.2.99.4-20030201
* Fri Jan 31 2003 - sndirsch@suse.de
- added vncfb driver for x86_64 arch
* Fri Jan 31 2003 - sndirsch@suse.de
- fixed <Ctrl><Alt><BS> (Terminate_Server) in Xmodmap
* Wed Jan 29 2003 - sndirsch@suse.de
- updated to current CVS sources 4.2.99.4-20030130
- adjusted p_fixes.diff
- adjusted p_x86-64_ioctl32.diff
* Wed Jan 29 2003 - sndirsch@suse.de
- p_fpic.diff:
  * compile also static libxkbfile with "-fPIC"
* Tue Jan 28 2003 - sndirsch@suse.de
- updated to current CVS sources 4.2.99.4-20030128
* Tue Jan 28 2003 - sndirsch@suse.de
- fixed Sig11 in vbe module if "NoDDC" is specified for second
  monitor in a Matrox Multihead configuration (Michael Matz);
  fixes also Bug #23061
- enabled resmgr for xdm PAM configuration (Bug #23156)
- /etc/skel/.xinitrc
  * commented out XCURSOR_CORE stuff (not required any longer)
  * disable AccessX for Toshiba Notebooks
* Mon Jan 27 2003 - sndirsch@suse.de
- added missing options of ati, r128 and radeon driver to
  CardModules.addon; these can't be autogenerated by xsload :-(
* Sun Jan 26 2003 - sndirsch@suse.de
- updated to current CVS sources 4.2.99.4-20030126
- adjusted p_fixes.diff
- renamed previous 'core' cursor theme to 'pseudocore' cursor theme
- Keith's new 'core' cursor theme is now used by default
* Sat Jan 25 2003 - sndirsch@suse.de
- updated to current CVS sources 4.2.99.4-20030125
- added core cursor theme (making it default)
* Fri Jan 24 2003 - sndirsch@suse.de
- /etc/skel/.xinitrc (skel.tar.gz):
  * unset XCURSOR_CORE if XCURSOR_THEME is set or $HOME/.icons
  directory exists
* Fri Jan 24 2003 - sndirsch@suse.de
- added directory timestamp to fonts.dir, fonts.dir and
  .fonts-config-timestamp
* Thu Jan 23 2003 - sndirsch@suse.de
- p_fixes.diff:
  * better fix for mkfontscale Segfault (Bitmap fonts) by
  Juliusz Chroboczek
* Wed Jan 22 2003 - froh@suse.de
- remove files that are not built on s390/s390x from filelist
* Tue Jan 21 2003 - sndirsch@suse.de
- p_fixes.diff:
  * fixed Sig11 in mkfontscale; mkfontscale now ignores
  pcf/pcf.gz/bdf files completely (Mike Fabian)
* Tue Jan 21 2003 - sndirsch@suse.de
- disabled build and installation of gamma DRM kernel module
- /etc/X11/xdm/Xsession: do not any longer reset background and
  cursor for KDE if WINDOWMANAGER="kde"
* Mon Jan 20 2003 - sndirsch@suse.de
- fixed broken *charClass (doubleclick separators) for all archs
* Sun Jan 19 2003 - sndirsch@suse.de
- added vnc module and vncfb driver (Bug #22937)
* Sun Jan 19 2003 - sndirsch@suse.de
- p_fpic.diff:
  * compile also static libXss with "-fPIC"
* Sat Jan 18 2003 - sndirsch@suse.de
- updated to current CVS sources 4.2.99.3-20030118
- adjusted p_fixes.diff to current CVS sources
* Fri Jan 17 2003 - sndirsch@suse.de
- fixed build of DRM kernel modules for x86_64
* Fri Jan 17 2003 - sndirsch@suse.de
- p_fixes.diff:
  * fixes nv driver crash on HP zx6000 (Bug #21988)
- p_x86-64_ioctl32.diff:
  * support for 3D accelerated 32bit OpenGL applications in a 64
  bit environment
- /etc/skel/.xinitrc (skel.tar.gz):
  * disabled new Xcursor themes if none is specified or located in
  $HOME
* Thu Jan 16 2003 - sndirsch@suse.de
- include fonts.cache-1 files to save time during running
  SuSEconfig.fonts
* Thu Jan 16 2003 - sndirsch@suse.de
- p_fixes.diff:
  * fixed th_TH.UTF-8 XLC_LOCALE file
* Wed Jan 15 2003 - sndirsch@suse.de
- updated to current CVS sources 20030115
- p_suse.diff:
  * fixed ru_RU locale; now defaults to ISO-8859-5 instead of KOI8-R
  (Bug #22875)
- added logrotate file for xdm
- patching XF86Config during update so that pc105 is used for
  german keyboard layouts (Bug #22851)
* Tue Jan 14 2003 - sndirsch@suse.de
- /etc/X11/xdm/Xsession: do not reset any longer background and
  cursor for KDE (Bug #19089)
* Mon Jan 13 2003 - sndirsch@suse.de
- p_fpic.diff:
  * build libxf86config.a with "-fPIC" (again)
- added Pacebook Touchscreen driver (pacebook.tar.gz/p_pacebook.diff)
* Mon Jan 13 2003 - sndirsch@suse.de
- added missing entries for dead_acute, dead_grave, dead_circumflex
  and dead_abovering to UTF-8 compose table (Bug #22852)
* Sat Jan 11 2003 - sndirsch@suse.de
- updated to current CVS sources 20030111
* Fri Jan 10 2003 - sndirsch@suse.de
- updated to current CVS sources 20030110
- p_fixes.diff:
  * small fix in savage patch
* Fri Jan 10 2003 - werner@suse.de
- New sux script which is able to handle X11 authentification over
  ssh forwarded X11 connections.
* Thu Jan 09 2003 - sndirsch@suse.de
- moved all .pc files to /usr/%%_lib/pkgconfig (Bug #22828)
* Thu Jan 09 2003 - sndirsch@suse.de
- xterm now uses iso10646-1 fonts and luit for non-UTF-8 locales
  (xterm-fontsettings.dif in xterm-patches.tar.gz, Mike Fabian)
- p_fixes.diff:
  * possible fix for savage driver bug (Bug #19124)
- use XLC_LOCALE file of en_US.UTF-8 for all UTF-8 locales
* Wed Jan 08 2003 - sndirsch@suse.de
- new subpackage XFree86-fonts-syriac for Meltho fonts (Bug #22588)
* Sun Jan 05 2003 - sndirsch@suse.de
- new p_fixes.dif::
  * disabled non-working MIT-SHM extension of Xnest (Bug #22577)
* Sun Jan 05 2003 - sndirsch@suse.de
- cleanup in p_fpic.diff
* Sat Jan 04 2003 - sndirsch@suse.de
- updated to current CVS sources 20030104
* Sat Dec 28 2002 - sndirsch@suse.de
- updated to current CVS sources 20021228
* Thu Dec 19 2002 - sndirsch@suse.de
- updated to current CVS sources 20021219
- cleanup in specfile
* Wed Dec 18 2002 - jplack@suse.de
- adapted all ppc and ppc64 related patches for XFree86-4.3
  resulting in only two remaining patches:
  * p_XFree86-4.3-kbdmapping.diff
  * p_XFree86-4.3-ppc64.dif
* Wed Dec 18 2002 - sndirsch@suse.de
- p_fixes.diff:
  * fixed build on sparc
  * fixed deadkey tilde for en_US.UTF-8 locale
- added missing Compose and XI18N_OBJS files for some UTF-8 locales
* Tue Dec 17 2002 - sndirsch@suse.de
- removed obsolete p_suse_trash.diff
- remove obsolete symbols.tar.gz
- removed obsolete Motif config files in suse-addons.tar.bz2
- compile also xsload against static misc/Xv libs
- updated gb18030 patch (disabled for now)
* Mon Dec 16 2002 - sndirsch@suse.de
- updated to current CVS sources 20021216
- removed obsolete XFIXES defines in host.def
- p_fixes.diff:
  * removed obsolete XFIXES patch
  * geode driver is now called nsc
- removed p_xlib-i18n.diff (changes already in current sources)
- removed Xcms.txt from filelist
* Sat Dec 14 2002 - sndirsch@suse.de
- updated xterm patches (Werner Fink)
- p_fixes.diff:
  * Fix 64bit bug in VESA driver (Bug #22416)
- removed p_sparc_pci.dif (PCI domain patch now obsolete)
* Sun Dec 08 2002 - sndirsch@suse.de
- updated to current CVS sources 20021208
* Thu Dec 05 2002 - sndirsch@suse.de
- removed driver_options.sh (not required any more)
- xsload.tar.gz/p_xsload.diff/CardModules.addon:
  * module loader to extract available options of all installed
  drivers
  * options for additional driver
- p_fpic.diff:
  * also compile libXinerama.a with PIC
* Wed Dec 04 2002 - sndirsch@suse.de
- updated to current CVS sources 20021204
* Mon Dec 02 2002 - sndirsch@suse.de
- updated to current CVS sources 20021202
- disabled XFIXES extension/lib (not ready yet for 4.3)
- default cursor now has old look&feel again
* Mon Dec 02 2002 - sndirsch@suse.de
- run ldconfig in %%post section of XFree86-libs
- p_fixes.diff:
  * fixed Render problem in mga driver for multihead configurations
* Fri Nov 29 2002 - sndirsch@suse.de
- updated to current CVS sources 20021129
- removed patch in p_fixes.diff (already applied in XFree86 CVS)
- added /usr/X11R6/lib/X11/Xcms.txt to filelist
* Wed Nov 27 2002 - sndirsch@suse.de
- Makefile.module/p_fixes.diff: fixed build for x86_64
- p_fixes.diff: added ATI FireGL 8x00 support
- cleanup in config-dist.sh
* Tue Nov 26 2002 - sndirsch@suse.de
- updated to current CVS sources 20021126
- removed p_suse_up.diff (already in current CVS sources)
* Mon Nov 25 2002 - sndirsch@suse.de
- updated to current CVS sources 20021125
- use expat lib of expat package
- disable build of geode driver on ia64
* Mon Nov 25 2002 - sndirsch@suse.de
- moved xauth patch from p_suse_up.diff --> p_suse_trash.diff
- removed patches which are not required any more
  * p_sbit.diff
  * p_drm_pte-highmem.diff
  * p_drm_page.diff
  * p_newport.diff
  * p_nv.diff
  * p_bison.diff
- completely new p_fixes.diff:
  * integrated p_missing_new_line.diff
  * integrated p_x86-64-drivers.diff
* Fri Nov 22 2002 - sndirsch@suse.de
- new p_fpic.diff:
  * use -fPIC for building libxf86config.a
* Fri Nov 22 2002 - sndirsch@suse.de
- updated to current CVS sources 20021122
- moved fontconfig-config, xcursor-config and xft-config to
  devel package
* Thu Nov 21 2002 - sndirsch@suse.de
- p_x86-64-drivers.diff:
  * build fbdev and vesa driver also for x86_64
* Tue Nov 19 2002 - sndirsch@suse.de
- p_missing_new_line.diff:
  * fixes build in BETA
* Tue Nov 19 2002 - sndirsch@suse.de
- updated to current CVS sources 20021119
* Mon Nov 18 2002 - sndirsch@suse.de
- moved some binaries (chooser, rstartd.real) from /etc/X11 to
  /usr/X11R6/bin for FHS compliance (Bug #21857)
* Sat Nov 16 2002 - sndirsch@suse.de
- splitted p_suse.diff
  * p_suse.diff: still applied
  * p_suse_up.diff: still applied; to remove when commited upstream
  * p_suse_trash.diff: no longer applied; hopefully to remove soon
- updated 'FILES'
* Thu Nov 14 2002 - sndirsch@suse.de
- updated to current CVS release 20021113
* Wed Nov 13 2002 - sndirsch@suse.de
- adjusted config-dist.sh to new specfile name
- new p_fixes.diff:
  * use StaticNeedsPicForShared also for hppa
* Tue Nov 12 2002 - sndirsch@suse.de
- adjusted 'FILES'
- new p_fixes.diff:
  * Mesa: turning on IEEE support for x86-64. This gives some
  performance boost in 3D apps
  * X11.tmpl: fixing further warning message of C-preprocessor during
  imake
  * radeon driver: fixing problem with division by 0 error in case
  dotclock is out of the possible clock ranges of the pll clocks.
* Mon Nov 11 2002 - sndirsch@suse.de
- reverted previous renaming km_drm --> XFree86-km_drm
* Sun Nov 10 2002 - sndirsch@suse.de
- renamed packages radically:
  * NVIDIA_GLX              (remains)
  * NVIDIA_kernel           (remains)
  * XFree86-compat-libs     (remains)
  * km_drm                  XFree86-km_drm
  * xdevel                  XFree86-devel
  * xextra                  XFree86-Xnest + XFree86-Xvfb (split)
  * xf86                    XFree86 + XFree86-fonts-75dpi + XFree86-doc (split)
  * xf86_glx                XFree86-GLX
  * xf86_glx-devel          XFree86-GLX-devel
  * xf86driver-options      XFree86-driver-options
  * xfnt100                 XFree86-fonts-100dpi
  * xfntcyr                 XFree86-fonts-cyrillic
  * xfntscl                 XFree86-fonts-scalable
  * xloader + xmodules      XFree86-server (merge)
  * xman                    XFree86-man
  * xshared                 XFree86-libs
  * xxprt                   XFree86-Xprt
- new p_fixes.diff:
  * config/cf/Imake.cf: removed wrong braces behind #undef, which are
  no longer accepted by new preprocessor
* Thu Nov 07 2002 - sndirsch@suse.de
- p_bison.diff by Tomas Crhak:
  * added missing semicolons at the end of the rules; new bison
  does not tolerate missing semicolons any more ...
- disabled p_xlib-i18n.diff for now (Bug #21640)
* Wed Nov 06 2002 - sndirsch@suse.de
- p_xf86-4.2-2-pci_domain.diff (jplack)
  * fixes pci scanning on p650, p640 and others.
- new p_fixes.diff:
  * integrated p_alpha_gprel.diff
  * another loader fix for x86_64 by Egbert
* Wed Oct 30 2002 - sndirsch@suse.de
- new p_fixes.diff:
  * XFree86 loader: merging section allocation for x86_64, using
  mmap() for allocation
* Mon Oct 28 2002 - sndirsch@suse.de
- new p_fixes.diff:
  * Move LpRing to beginning of fb memory for the i845G. This chip cannot
  handle GART remappings of the LpRing. This may occur if stolen memory
  is too small. Remove option FixMem. Making FixMem default when stolen
  memory too small.
  * Added/Fixed Internet keyboard support
  * Fixed RAC for devices that require VGA routing but don't share
  identical VGA resources.
  * fixed radeon BIOS posting by resetting values to their pre-POST
  defaults.
  * fixing resource registration for tdfx driver.
  * minor fix to generic ps2 mouse.
  * Silently ignore unsupported system BIOS calls when executing int10.
- X11 skel files now included (removed in package aaa_skel)
- removed aaa_skel from #neededforbuild
- adjusted one patch in ppc-patches.tar.bz2
* Thu Oct 24 2002 - sndirsch@suse.de
- fixed sourcing of wrong sysconfig file in Xstartup script
  (Philipp Thomas)
* Thu Oct 24 2002 - sndirsch@suse.de
- p_xlib-i18n.diff (adjusted patch from Egbert)
  * fixes Xlib memory leak
  * cleanup of om code
* Wed Oct 23 2002 - sndirsch@suse.de
- fixed SuSEconfig.xdm for new KDM (Bug #21188)
* Tue Oct 22 2002 - sndirsch@suse.de
- integrated the following patches in p_fixes.diff:
  * p_ps2-fix.diff
  * p_ps2-fix2.diff
  * p_xf86misc.diff
* Mon Oct 21 2002 - sndirsch@suse.de
- integrated the following patches in p_fixes.diff:
  * p_fixes_post-beta1.diff
  * p_fixes_post-beta2.diff
  * p_fixes_post-preview5.diff
  * p_ia64.diff
  * p_no_strict_aliasing.diff
  * p_xdm.diff
- other changes in p_fixes.diff:
  * disabled 3DNow for x86_64
  * omText.c: probably better code
  * mga driver: fixed granularity panning when HALlib is used
  * fbdev driver: ioctl for FBIOPAN_DISPLAY is now silent if it fails,
  unless you specify a verbose level >= 5
  * add support for IBM space saver keyboard
  * Help for mouse abusers: Don't freak if mouse is moved during init
  * fix sig11 problem in i830/i845 driver when PreInit() errors
  * xiiimp.so.2 fix (Masaru Yokoi <masaru@turbolinux.co.jp>)
- new p_suse.diff:
  * fixed twm for UTF-8 (Mike Fabian)
* Sat Oct 19 2002 - sndirsch@suse.de
- Update SPARC pci-domain patch (kukuk)
- p_xdm.diff:
  * fixes xdm, which crashed HP IA64 machines when reading /dev/mem
  (Bug #20252)
- p_xf86-4.2-pci_domain.diff (jplack)
  * fixed some problems related to problems with pci domains on some ppc machines
- p_xf86-4.2-pci_domain_drivers.diff (jplack)
  * same for some drivers, still incomplete due to missing hardware
- p_xf86-4.2-ignore_pciconflict.diff (jplack)
  * ignore wrongly reported pci resource conflicts
* Fri Oct 18 2002 - sndirsch@suse.de
- pid file of kdm has changed (Bug #20735)
* Fri Oct 11 2002 - stepan@suse.de
- add R_ALPHA_GPRELHIGH and R_ALPHA_GPRELLOW relocations to
  the elf loader.
* Fri Sep 13 2002 - werner@suse.de
- Change order of setting login `-' for SHELL in sux (bug #19599)
* Tue Sep 10 2002 - sndirsch@suse.de
- p_ps2-fix2.diff:
  * fixes another console switch PS/2 problem (Bug #19305)
* Fri Sep 06 2002 - sndirsch@suse.de
- removed p_mouse_preview3.diff; we now fixed the PS/2 mouse problem
  seriously in the current mouse driver
- p_ps2-fix.diff: PS/2 mouse driver fix (see above) (Bug #18719)
- p_xf86misc.diff: fixed misc extension bug (Bug #19006)
* Thu Sep 05 2002 - sndirsch@suse.de
- p_mouse_preview3.diff: switched back to mouse driver of preview3;
  PS/2 mouse driver was broken since preview4 (Bug #18719)
* Fri Aug 30 2002 - sndirsch@suse.de
- p_i18n-20020830.diff:
  * added and fixed support for gbk, gb18030 and big5hkscs locales
  (Bug #18470); patch by James Su <suzhe@turbolinux.com.cn>
- p_nv.diff:
  * added support for NV18, NV28 and nForce2 to nv driver
- adjusted nvidia driver options
* Fri Aug 30 2002 - sndirsch@suse.de
- new p_fixes_post-beta2.diff:
  * radeon driver: added ATI Radeon 9000 Pro support
* Wed Aug 28 2002 - sndirsch@suse.de
- p_ia64.diff: workaround for ATI probing on IA64
- new p_fixes_post-beta2.diff:
  * allowing EXPPS2 mouse to be set thru the xf86Misc extension
  * disable access of legacy register on ia64
* Tue Aug 27 2002 - sndirsch@suse.de
- p_fixes_post-beta2.diff:
  * Security Fix: setuid binaries no longer can load symbols
  controlled by the user via Xlib
  * Mouse was frozen after server reset on framebuffer server.
  InitOutput() called BlockSIGIO() however the unblock in
  PostScreenInit() never got called.
  * fixed Sig11 in libshadow (could be triggered by SaX2, which
  started on a fbdev XServer)
- xf86.spec: some cleanups to make it easier to generate ppc
  specific files; therefore adjusted also p_no_strict_aliasing.diff
  and p_ppc64.diff (Joachim Plack)
* Mon Aug 26 2002 - sndirsch@suse.de
- xdm configuration: don't start xconsole when kdm runs (Bug #18189)
* Sat Aug 24 2002 - schwab@suse.de
- Use -fno-strict-aliasing for every architecture since it's a generic
  XFree86 bug.
* Fri Aug 23 2002 - sndirsch@suse.de
- new p_fixes_post-beta1.diff:
  * i810 driver: fixed core dump due to uninitialized pointers
  * turning on -fno-strict-aliasing for gcc >= 3.1
- removed p_radeon_dri_x86-64.diff; not required any more with
-fno-strict-aliasing
* Fri Aug 23 2002 - sndirsch@suse.de
- removed Req: xdmbgrd
* Mon Aug 19 2002 - sndirsch@suse.de
- p_fixes_post-beta1.diff:
  * fixed X Server crash, which happended each time a proportional
  iso10646 font was loaded with xtt backend
  * integrated patch 'p_xwd.diff'
* Mon Aug 19 2002 - sndirsch@suse.de
- workaround for compiler bug, which fixes DRI support for radeon
  driver on x86_64 (p_radeon_dri_x86-64.diff)
* Sun Aug 18 2002 - schwab@suse.de
- Fix portability bug in xwd.
* Sun Aug 18 2002 - sndirsch@suse.de
- fixed build on ppc64
* Fri Aug 16 2002 - sndirsch@suse.de
- new p_fixes_post-preview5.diff:
  * fixed compiler warnings in radeon DRI driver
* Thu Aug 15 2002 - sndirsch@suse.de
- p_fixes_post-preview5.diff:
  * r128/radeon/glint/sis/mga/i810/i830 driver: reenable BM when
  coming back from a VT switch. Fixes some lockup problems.
  * fixing DRI lock problem when a ModeSwitch fails for i830.
  * adding RENDER support to i830/i845 driver
- p_bug17759.diff:
  * enhancement for deadkey mode (Bug #17759)
* Mon Aug 12 2002 - sndirsch@suse.de
- new p_fixes.diff:
  * mga driver: merging Matrox's extensions for merged screens
  * i810 driver: changed fixmem to restore register on VTSwitch/Exit
- new Matrox HAL library
- added dummy driver to filelist
* Fri Aug 09 2002 - sndirsch@suse.de
- new p_fixes.diff:
  * updated version of Thomas Winischhofer's SiS driver
  * fixed video support for 6326 (sort of: doesn't work on all
  chips. I suspect HW bugs.)
* Fri Aug 09 2002 - sndirsch@suse.de
- added newport driver patch (p_newport.diff)
- new p_fixes.diff:
  * security fixes for xf86misc extensions: allow only devices to
  be changed when they are specified as input devices in the
  config file.
* Thu Aug 08 2002 - sndirsch@suse.de
- new p_fixes.diff:
  * mga driver: fix for text mode color restauration problem when
  using HAL lib; fixed screen fuzziness due to unlocked PLL on
  G550
* Wed Aug 07 2002 - sndirsch@suse.de
- new p_fixes.diff:
  * new i810 driver with fixes for i810/i830/i845 from Egbert
  * fixed typo in PEX
  * cursor fix
  * fixed PS/2 mouse autodetection
  * siliconmotion driver changes
- removed 'i810.tar.bz2'
* Tue Aug 06 2002 - werner@suse.de
- Switch XTerm behaviour to its default (bug #15002)
* Sat Aug 03 2002 - sndirsch@suse.de
- integrated new savage driver in p_fixes.diff
--> new tarball for i810 driver (i810.tar.bz2)
--> removed p_savage.diff
* Fri Aug 02 2002 - sndirsch@suse.de
- integrated new sis driver in p_fixes.diff
- new savage driver (i810_savage.tar.bz2)
- fix for new savage driver (p_savage.diff)
* Fri Aug 02 2002 - sndirsch@suse.de
- switch2nvidia_glx: fixed for lib64
- switch2xf86_glx/switch2nvidia_glx: create also symbolic link
  'libGL.so.1' for 32bit
- added packages NVIDIA_GLX and NVIDIA_kernel for x86_64
* Thu Aug 01 2002 - sndirsch@suse.de
- new p_fixes.diff:
  * latest changes from Egbert
- drivers: dummy (new!), chips, mga, neomagic, siliconmotion,
  trident, vmware, sunffb, mouse, wacom, fb, kdrive
- int10, vbe, x86emu
- elf loader
- added 'PreReq:' for xf86, xf86_glx, NVIDIA_GLX and NVIDIA_kernel
* Mon Jul 29 2002 - sndirsch@suse.de
- new p_fixes.diff:
  * reverted latest savage driver changes; this means also removing
  support for ProSavage DDR/DDR-K chips again
  * fixed build for sparc (workaround by Thorsten Kukuk); build
  problem most likely introduced by the big patch on 2002-07-19
- new p_suse.diff:
  * fixed build on lib64 archictures (libusb)
* Mon Jul 29 2002 - sndirsch@suse.de
- new p_fixes.diff:
  * fixed loader Bug #17189 (".rodata.cst16" was not loaded)
  * some fixes for x86_64 in loader from Egbert
* Sat Jul 27 2002 - sndirsch@suse.de
- moved gccmakedep to xdevel subpackage
* Thu Jul 25 2002 - sndirsch@suse.de
- patching XF86Config for FireGL8x00 driver during update as driver
  was renamed (fglr200 --> fglrx)
* Thu Jul 25 2002 - sndirsch@suse.de
- moved imake/xmkmf to xdevel subpackage
* Wed Jul 24 2002 - sndirsch@suse.de
- new p_fixes.diff:
  * added support for Intuos2-Tablets to Wacom driver
  (Martin Pley <martin@alc.de>)
* Mon Jul 22 2002 - sndirsch@suse.de
- integrated nv and savage driver of i810_nv_savage_sis.tar.bz2
  and p_i810_nv_savage_sis.diff into p_fixes.diff
- new tarball i810_sis.tar.bz2 of i810/sis driver
- removed old tarball i810_nv_savage_sis.tar.bz2
* Sun Jul 21 2002 - sndirsch@suse.de
- new drivers (i810_nv_savage_sis.tar.bz2/p_i810_nv_savage_sis.diff):
  * i810
  * nv
  * savage
  * sis
* Fri Jul 19 2002 - sndirsch@suse.de
- new p_fixes.diff:
  * added fbdev + vesa driver build for x86_64
  * latest x86_64 changes of Egbert (int10 and others)
- commented out %%post of xmodules (not required any longer)
* Thu Jul 18 2002 - kukuk@suse.de
- Don't parse rc.config in xfs init script [Bug #17024]
* Wed Jul 17 2002 - werner@suse.de
- Clean Xsession script to fit /etc/profile expansion
* Thu Jul 11 2002 - sndirsch@suse.de
- made sure that /usr/X11R6/%%{_lib}/modules/linux/libint10.a does
  not exist on x86-64 machines
* Tue Jul 09 2002 - sndirsch@suse.de
- new 'ppc-patches' tarball: added some patches for ATI driver
* Mon Jul 08 2002 - sndirsch@suse.de
- switch2nvidia_glx/switch2xf86_glx: create libGL.so symbolic link,
  which is no longer in the file list of package mesa-devel; too
  many applications and libs use libGL.so instead of libGL.so.1.
  Therefore it is required also for a runtime environment. :-(
* Fri Jul 05 2002 - sndirsch@suse.de
- removed switch2xf86-3x resp. switch2xf86-4 scripts; these are
  no longer required since new xinit and xf86config scripts in
  xf86tools package
* Fri Jul 05 2002 - kukuk@suse.de
- Use %%ix86 macro
* Thu Jul 04 2002 - sndirsch@suse.de
- us_group2 xkb file: fixed <Shift><space> (Bug #16829)
* Wed Jul 03 2002 - sndirsch@suse.de
- fixed 'switch2xf86_glx' script; gave wrong result code for "-test"
  when also nvidia packages are installed
* Tue Jul 02 2002 - sndirsch@suse.de
- new p_fixes.diff:
  * Xvideo fix for radeon driver from Keith Packard: The fix is to
  adjust the position of the video on the screen -- all pre-8500
  radeons need the video shifted right by 8 pixels
* Fri Jun 28 2002 - sndirsch@suse.de
- removed p_radeon-xv.diff (integrated now in p_fixes.diff)
- removed p_x86_64.diff (not required any longer with new glibc)
- new p_fixes.diff:
  * fixes Xvideo support on R200 based boards (Radeon 8500, FireGL 8x00)
  * added support for FireGL 8x00 boards to radeon driver
* Tue Jun 25 2002 - sndirsch@suse.de
- p_radeon-xv.diff: fixes Xvideo support for R200 based boards
  (Radeon 8500, FireGL 8x00)
* Mon Jun 24 2002 - sndirsch@suse.de
- p_x86_64.diff: fixes build on x86_64
* Fri Jun 21 2002 - sndirsch@suse.de
- new p_fpic.diff:
  * added missing "-fPIC" for compiling scan.o of libxf86config.a
* Wed Jun 19 2002 - sndirsch@suse.de
- new p_fixes.diff:
  * added FireGL 7800 support
* Fri Jun 14 2002 - olh@suse.de
- add the built files on ppc64 to the filelist
  use target_cpu instead of arch to compare install file list
* Fri Jun 14 2002 - sndirsch@suse.de
- new p_fixes.diff:
  * loader patch for x86_64. Turn off mmap() for allocation to keep
  addresses in range.
  * patch to make DRI work on x86-64
* Thu Jun 13 2002 - olh@suse.de
- hack p_ppc64.diff, enable XF86Server
  it installs some needed headerfiles.
  hack LinuxPCIinit to allow compile, needs more tweaking for ppc64
* Tue Jun 11 2002 - sndirsch@suse.de
- new p_fixes.diff:
  * fixing screensaver extension for 64 bit
  * implementing pictrect function in vmware driver.
  * wrapped picture functions in RAC.
  * fixed xkb vs. DGA issue.
* Mon Jun 10 2002 - sndirsch@suse.de
- using defaults for BuildXF86MiscExt, JoystickSupport,
  BuildXF86BigfontExt, MesaUseMMX, MesaUse3DNow, BuildPexExt,
  BuildXIE and BuildXIElib in host.def instead of enabling/disabling
  them explicitely
- enabled MesaUseKatmai
* Thu Jun 06 2002 - sndirsch@suse.de
- p_fpic.diff:
  * finally compiles now also the static libs of Xv, Xxf86dga,
  Xxf86misc and Xxf86vm with -fPIC
* Tue Jun 04 2002 - schwab@suse.de
- xterm: fix missing casts.
* Mon Jun 03 2002 - sndirsch@suse.de
- removed glu.h from xf86_glx-devel package, so the package does
  not conflict any longer with mesaglu-devel package
- added driver for Gunze touch panels (gunzets-snapshot-020312.tar.gz)
* Mon Jun 03 2002 - olh@suse.de
- add p_ppc64.diff, build on ppc64 without xserver
* Fri May 31 2002 - sndirsch@suse.de
- new p_fixes.diff:
  * fixing resource and RAC registration in s3 driver for
  multihead
  * adding PIC to static libraries that need to be linked
  into shared objects (libXinerama, libXv, libXxf86dga,
  libXxf86misc, libXxf86vm, libxf86config)
  * added Xv support for NeoMagic 2097 (doesn't work yet)
- disabled hack in specfile for compiling static libraries
  with PIC
* Thu May 30 2002 - schwab@suse.de
- Build dummy NVIDIA_GLX/NVIDIA_kernel packages also on ia64.
* Sun May 26 2002 - sndirsch@suse.de
- renamed xf86glx-devel --> xf86_glx-devel
- removed requirement for ttmkfdir package; not required any longer
  (replaced by mkfontscale of package xf86tools)
* Sat May 25 2002 - sndirsch@suse.de
- new p_fixes.diff:
  * added Render support to vmware driver
* Fri May 24 2002 - sndirsch@suse.de
- new p_fixes.diff:
  * vmware driver fixed
- removed old vmware driver and patches for it (vmware-010220.tar.gz,
  p_vmware-fix.diff, p_vmware.diff); not required any longer
- compile libxf86config.a with "-fPIC" for lib64; required for SaX2
* Thu May 23 2002 - sndirsch@suse.de
- new p_fixes.diff:
  * fixed Xinerama.h: make it easier to use it in C++ code, so the
  user needs no longer t to write
  'extern "C" { #include <X11/extensiona/Xinerama.h> }'; instead
  he can just write '#include <X11/extensiona/Xinerama.h>' now;
  suggestion of Marcus Schaefer <ms@suse.de>
  * new ARM patches by Uli Hecht <uli@suse.de>
- removed p_arm.diff (integrated in p_fixes.diff)
* Sat May 18 2002 - sndirsch@suse.de
- moved shared libs in /usr/X11R6/lib/X11/locale/%%{_lib}/common to
  xshared package
* Fri May 17 2002 - sndirsch@suse.de
- lib64 adjustments in switch2xf86_glx
- lib64 adjustments in specfile
- added package xmodules for x86_64
- added packages xf86_glx/xf86glx-devel for s390/s390x
- some cleanups in specfile
- new p_fixes.diff:
  * fixed i18n X11 library location to work on platforms that allow
  32 and 64 bit libraries
  * added drivers for x86_64
  * modified PostKbdEvent() to discard any keyboard events while server
  is suspended.
  * Changed GetTimeInMillis() to only use time difference between
  gettimeofday() calls.
  * Fixes for gamma correction and 9397 video playback in trident driver.
* Thu May 16 2002 - sndirsch@suse.de
- integrated the following patches in p_fixes.diff:
  * p_cz-decimal.diff
  * p_gcc3.diff
  * p_ia64_drm.diff
  * p_lbxproxy.diff
  * p_mouse-misc.diff
  * p_sunffb_dri.diff
  * p_xf86Wacom-fix.diff
  * p_xset.diff
- other changes in p_fixes.diff:
  * handling time skew reduction more gracefully to give timers a chance
  * Support for Vaios with 1024x480 display in neomagic driver
* Tue May 14 2002 - sndirsch@suse.de
- p_cz-decimal.diff:
  * fixed decimal period in US group of Czech and Slovak keyboards (#15581)
- p_drm_page.diff:
  * fixed compilation of i810/i830 kernel module with kernel >= 2.4.19-pre7
- p_lbxproxy.diff:
  * Security fix for MIT-SHM extension
- integrated the following patches in p_fixes.diff:
  * p_420-fixes.diff
  * p_dlopen-refcount.diff
  * p_fix-xkb-sig11.diff
  * p_fixes_after_RC1.diff
  * p_hu-euro.diff
  * p_hwcursor.diff
  * p_i810-fix.diff
  * p_ia64.diff
  * p_late-fixes.diff
  * p_late-fixes2.diff
  * p_nv-gf2go-gf4.diff
  * p_pnp-neo.diff
  * p_vgahw.diff
  * p_xf86Wacom.diff
  * p_xft_leak.diff
- addititional changes in p_fixes.diff:
  * Security fix for lbxproxy client
* Fri May 10 2002 - sndirsch@suse.de
- p_vmware-fix.diff from Egbert:
  * fixes vt switching segfaults of vmware driver
* Wed May 08 2002 - meissner@suse.de
- Use the same -fPIC hack we use for ia64 and alpha for x86_64 too
  to build libXinerama.a with -fPIC.
* Wed Apr 24 2002 - olh@suse.de
- build nv driver on ppc
* Tue Apr 23 2002 - ms@suse.de
- fixing x86_64 built
* Tue Apr 16 2002 - schwab@suse.de
- Fix DRM locking on ia64.
* Mon Apr 15 2002 - schwab@suse.de
- xset: don't crash if server does not use xkb.
* Thu Apr 11 2002 - schwab@suse.de
- More gcc3 fixes for Alpha.
* Wed Apr 10 2002 - schwab@suse.de
- Fix for gcc3.
* Sun Mar 31 2002 - sndirsch@suse.de
- don't include libGL*.a any longer in xdevel package; these libs
  belong to xf86glx-devel package
* Fri Mar 29 2002 - sndirsch@suse.de
- build Xvideo, DGA, Misc and Vidmode Extension with -fPIC on Alpha
  (like ia64)
* Tue Mar 26 2002 - sndirsch@suse.de
- p_fixes_after_RC1.diff:
  * fixes restoring of color map for Riva 128 boards (Bug #15183)
  * fixes hardware cursor for Matrox G550 boards
  * disabling neomagic video support in nonlinear mode
  * disabling C&T video in nonlinear mode; removing leftover print command
  * fixing gamma support for trident 9397
  * fixing messages in chips driver
* Mon Mar 25 2002 - sndirsch@suse.de
- p_hu-euro.diff (Koblinger Egmont <egmont@suselinux.hu>):
  * added Euro symbol for hungarian kbd layout
- use $RPM_OPT_FLAGS for compiling instead of hardcoded options
  "-O2 -mcpu=i686 -march=i486"; useful for 'full-debug-i386' builds
* Fri Mar 22 2002 - sndirsch@suse.de
- fixed annoying msg when opening shells on some machines (Bug #15363)
* Thu Mar 21 2002 - sndirsch@suse.de
- p_xf86Wacom-fix.diff:
  * fix for wacom driver build
* Thu Mar 21 2002 - sndirsch@suse.de
- p_late-fixes2.diff (more late fixes from Egbert):
  * removed some HW cursor glitches in C&T driver
  * C&T driver: made video available even when accel is disabled
  * fixed a bug in PCI ROM read routine that caused system hangs
  * fixing some accel offscreen manager relations in neomagic driver
* Wed Mar 20 2002 - sndirsch@suse.de
- p_late-fixes.diff (late fixes from Egbert):
  * adding some new S3 Savage PCI chips to the database
  * fixing video support on neomagic: chip used to allocate too much
  memory for video, video didn't work when acc was disabled
  * disabling gamma correction for trident as it doesn't work like
  described in the data book.
  * adding tsi's ultimate silken mouse fix (tested).
* Tue Mar 19 2002 - sndirsch@suse.de
- p_xf86Wacom.diff:
  * improved new Wacom driver which works for serial and USB tablets
  (Frederic Lepied <lepied@XFree86.Org>)
- changes in switch2xf86_glx/switch2nvidia_glx:
  * only create symbolic link /usr/lib/libGL.so.1 if not already there;
  performance boost for ldconfig
* Sun Mar 17 2002 - sndirsch@suse.de
- p_vgahw.diff:
  * removes annoying log message from output, which produces hundreds
  or even thousands of useless lines in logfile for some drivers
* Sun Mar 10 2002 - sndirsch@suse.de
- p_nv-gf2go-gf4.diff:
  * support for GeForce2 Go + GeForce4
- added new option "Overlay" to nvidia options
- updated to bugfix release 4.2.0.1 (p_420-fixes.diff)
  Changelog entries:
  * XFree86 4.2.0.1 (xx February 2002)
  703. MIT-SHM updates (Roberto Zunino, Matthieu Herrb).
  702. Fix a problem related to reserving the overlay key in the default
  colormap in 24+8 mode.  This caused some clients using the 8-bit
  visuals to fail (David Dawes).
  701. Zlib error handling fix (Mark Adler).
  700. Put back XDarwin's byte-ordering fix for reading keymappings on
  Darwin x86 that was inadvertently dropped (Rob Braun).
  699. Fix for `hostname` issue on Linux (Marc La France).
  698. Fix startx script for ksh (Philip B. Bruce).
  697. Fix Emulate3Buttons for wsmouse protocol on NetBSD and OpenBSD
  (Matthieu Herrb).
  696. Temporary workaround for IA-64 (Marc La France).
  695. Fix SIGSEGV when printing modes that have no flags (Marc La France).
  694. Fix an unresolved symbol in libGLU.so that shows up when building it
  with gcc-3 (David Dawes).
  693. Fix incorrect symbol prefixing with Xlib's i18n modules on Solaris,
  and fix invalid code caused by a memcpy() macro being split by a
  directive (Keith Packard, David Dawes, #5150, Sami Farin).
  692. Don't try to print mode names when NULL (David Dawes).
  691. Revert the ATI driver's composite sync default to off (Marc La France).
- p_fix-xkb-sig11.diff (fixes Bug #14825)
- p_i810-fix.diff:
  * prevents I810Sync() from being called when switching to a VT
* Mon Mar 04 2002 - sndirsch@suse.de
- p_hwcursor.diff:
  * hardware cursor fix (Egbert Eich)
* Sun Mar 03 2002 - sndirsch@suse.de
- p_xft_leak.diff:
  * memory leak fix for libXft by Lars Knoll <lars@trolltech.com>;
  verified by Keith Packard
- p_dlopen-refcount.diff:
  use reference counts for dlopen of XI18N objects, based on
  patch by Owen Taylor <otaylor@redhat.com>, for details see also
  http://xfree86.org/pipermail/xpert/2002-January/015218.html.
  Without this patch XimRegisterIMInstantiateCallback() core dumps
  which results in core dumps in the initialization code of
  almost all applications supporting XIM when XMODIFIERS is set
  to a XIM server inappropriate for the locale. For example
  'XMODIFIERS=@im=kinput2 LANG=zh_TW gvim' core dumps without
  this patch.
* Thu Feb 28 2002 - sndirsch@suse.de
- added ia64 specific patch 'p_ia64.diff' for XFree86 loader
  (Andread Schwab)
* Wed Feb 27 2002 - sndirsch@suse.de
- p_pnp_neo.diff (Egbert Eich)
  * fixes in PNP mouse driver and neomagic video driver
- p_mouse-misc.diff (Egbert Eich, patch is disabled!)
  * big changes in mouse driver and misc extension
* Mon Feb 25 2002 - sndirsch@suse.de
- changes in p_fixes.diff (Mike Fabian)
  * treat 'urw-fontspecific' as identical to 'adobe-fontspecific';
  fixes displaying of URW Symbol and Dingbats fonts
- adjusted 'FILES'
* Sat Feb 23 2002 - sndirsch@suse.de
- changes in p_fixes.diff (Egbert Eich):
  * fixing a bug in the mouse driver that may cause Sig11 on console
  switches
  * modified and hopefully improved mtrr range splittings
* Wed Feb 20 2002 - sndirsch@suse.de
- DRI tdfx driver uses dlopen since 4.2.0 to load Glide3/DRI library
  instead of being linked against; adjusted switch2xf86_glx script
  and specfile to this change
- DRI tdfx driver needs to set FX_GLIDE_SWAPINTERVAL for Banshee
  boards; added profiles for this
* Wed Feb 20 2002 - sndirsch@suse.de
- changes in p_fixes.diff:
  * ATI Rage XL Lockup fix (Marc Aurele La France)
- fixed "SuSEconfig.xdm / 'etc/X11/xdm/Xservers'" bug (#13629)
* Mon Feb 18 2002 - sndirsch@suse.de
- changes in p_fixes.diff:
  * added missing commas to us_intl xkb layout
- changes in p_suse.diff
  * added Ungherese (qwerty) support
* Fri Feb 15 2002 - sndirsch@suse.de
- changes from Egbert Eich in p_fixes.diff:
  * Included new cross compile environment
  * Included x86_64 port
  * Removed several memory leaks
  * Added enhancements to memory debugger
  * Added automatic mouse recoginition
  * Fixed Rendition driver to work with VESA fbdev
  * Fixed Matrox driver to work with VESA fbdev and HALlib
  * Fixed video support in smi driver
  * Fixed smi driver to work with VESA fbdev
  * Added video support to neomagic driver
  * Made some enhancements to trident video support
  * Added automatic detection of legacy Tseng chipsets
  * Fixed vga driver HBlank problems with chips having a C&T core.
- previous patch for "config/imake/imake.c" now in p_fixes.diff
  instead of p_suse.diff to prevent conflicts between these two
  patches
- adjusted xterm patch due to changes in p_fixes.diff
- removed lib64 patch (already in in p_fixes.diff)
* Mon Feb 11 2002 - sndirsch@suse.de
- Revert the ATI driver's composite sync default to off
* Sat Feb 09 2002 - sndirsch@suse.de
- ppc: added building of imstt driver
* Mon Feb 04 2002 - sndirsch@suse.de
- changes in p_fixes.diff:
  * Fix sig11 problem when switching mouse protocols (Egbert Eich)
* Mon Feb 04 2002 - sndirsch@suse.de
- changes in p_fixes.diff:
  * make _XimCheckLocaleName() case insensitive; fixes problems when
  starting Xcin in zh_TW.Big5 locale (Mike Fabian <mfabian@suse.de>)
  * replace zh_CN.eucCN by the commonly used zh_CN.GB2312 in
  locale.alias/locale.dir (Mike Fabian <mfabian@suse.de>)
  * fixed typo in tdfx_driver.c (Mike Harris <mharris@redhat.com>);
  confirmed by Daryll Strauss <daryll@harlot.rb.ca.us>
- p_drm-pte-highmem.diff:
  adjusted DRM sources for pte/highmem changes in SuSE kernel
* Wed Jan 30 2002 - sndirsch@suse.de
- use utempter support of xterm instead of sgid bit (Olaf Kirch)
* Tue Jan 29 2002 - sndirsch@suse.de
- added kde3 lines to /etc/X11/xdm/Xsetup
* Mon Jan 28 2002 - sndirsch@suse.de
- changes in p_fixes.diff: fixed EURO support for xterm via App
  Defaults
* Sun Jan 27 2002 - sndirsch@suse.de
- changes in p_fixes.diff: added missing locale.alias/locale.dir
  entries for i18n spec
* Tue Jan 22 2002 - sndirsch@suse.de
- config-dist.sh: fixed build for 7.1-ppc, sles7-ppc and 7.3-ppc
- new ppc-patches.tar.bz2; patches are now applied again
* Mon Jan 21 2002 - sndirsch@suse.de
- changes in p_fixes.diff:
  * replaced G450SetPLLFreq(...) with MGAG450SetPLLFreq(...); fixes
  "G450SetPLLFreq in mga_drv.o is unresolved" and "Fatal error: SIGILL"
  problems during X Server start on mga boards when 'Option "NoHal"'
  is used
* Sun Jan 20 2002 - sndirsch@suse.de
- merged p_suse_fixes.diff, p_xpm.diff and p_driver_fixes.diff
  to new patch p_fixes.diff (generated by CVS diff)
- p_suse.diff now generated by CVS diff (no changes)
- added build flags "-mcpu=i686 -march=i486" for i386
* Sat Jan 19 2002 - sndirsch@suse.de
- updated to final release 4.2.0
- trident and mga fixes from Egbert (p_driver_fixes.diff)
- config-dist.sh: removed SuSEconfig.xdm for 7.0-i386,7.1-i386,
  7.2-i386, 7.3-i386
- build 'imstt' as devel driver
* Fri Jan 18 2002 - schwab@suse.de
- Fix libXpm for 64 bit architectures.
* Tue Jan 15 2002 - sndirsch@suse.de
- updated to CVS release (2002-01-18) of XFree86
- fixed build for 7.0-i386 in config-dist.sh
- p_lib64.diff: required for X11/lib64
- changes in p_suse_fixes.diff:
  * removed i830 patch (already included in CVS tarball)
  * use XI18N_OBJS of locale zh for locale zh_CN; fixes
  XSupportsLocale() for locale zh_CN
- fonts.dir files are included again (to much trouble without them)
- prepared specfile for lib64
- some cleanups in specfile
* Mon Jan 14 2002 - sndirsch@suse.de
- updated to CVS release (2002-01-14) of XFree86
- switch2nvidia_glx now executable (again)
* Sat Jan 12 2002 - sndirsch@suse.de
- updated to CVS release (2002-01-12) of XFree86
* Fri Jan 11 2002 - sndirsch@suse.de
- new p_suse_fixes.diff
  * fixed Render problem in mga driver for multihead configurations
  * integrated p_ia64.diff
- removed p_suse_fixes_post73.diff
- removed p_ia64.diff
- updated to the latest Matrox HALlib
- adjusted entries in 'FILES'
- added i830 DRM module to Makefile.module
- adjusted SuSEconfig.xdm to use /etc/sysconfig/displaymanager instead
  of /etc/rc.config.d/displaymanager.rc.config
- adjusted driver_options.sh to new options of ati and nvidia driver
- create the xkb symbols cs, cs_qwerty and gr as compatibility
  symbolic links (instead of real files)
* Thu Jan 10 2002 - sndirsch@suse.de
- renamed arm.dif --> p_arm.diff
- removed p_buildglxwithpic.diff (already integrated in CVS release)
- adjusted patches:
  * p_sbit.diff
  * p_suse.diff
  * xterm-privilege.patch (located in xterm-patches.tar.gz)
- use static usb lib (again) for builing XFree86 Loader
* Wed Jan 09 2002 - sndirsch@suse.de
- updated to CVS release (2002-01-09) of XFree86
- removed p_utf8.diff (already integrated in CVS release)
- defined UsbHidLib to "-lusb"
- removed workaround for compiling freetype2; not required any more
- adjusted revision number of Xrender lib in filelist
- added /usr/X11R6/lib/X11/fonts/truetype/ to package xfntscl
* Tue Jan 08 2002 - egmont@suselinux.hu
- changed /sbin/init.d to /etc/init.d in xfs init script comment,
  removed colons from startup and shutdown messages
* Fri Jan 04 2002 - sndirsch@suse.de
- made switch2xf86_glx executable
* Thu Jan 03 2002 - sndirsch@suse.de
- link all affected programs statically against libXv and libXxf86*
* Wed Jan 02 2002 - sndirsch@suse.de
- disabled patch p_sparc_pci.diff for now; must be adjusted when
  XFree86 4.2.0 is released
* Sat Dec 29 2001 - adrian@suse.de
- fix build for mips finaly (use MakeDllModules)
* Wed Dec 19 2001 - sndirsch@suse.de
- removed fonts.dir and encodings.dir and renamed fonts.scale, which
  are created dynamically by /sbin/conf.d/SuSEconfig.fonts anyway
* Tue Dec 18 2001 - sndirsch@suse.de
- some cleanups in host.def
- lib64
  * add %%_lib and %%_libdir where appropriate
  * move shared objects and only these to appropriate lib64 locations
  at the end of the install section
- adjusted config-dist.sh for 7.2-lib64-s390x
- added patch p_utf8.diff, which fixes the loading of the wrong
  input library
* Mon Dec 17 2001 - sndirsch@suse.de
- updated to CVS release (2001-12-17) of XFree86
- disabled some patches, which must be adjusted when XFree86 4.2.0
  is available (about 2002-01-02):
  * p_suse.diff
  * p_suse_fixes.diff
  * p_buildglxwithpic.diff
  * p_sbit.diff
  * p_suse_fixes_post73.diff
  * ppc specific patches
  * xterm-privilege.patch
  Most of them should be included in XFree86 4.2.0 anyway.
- added missing link to freetype/ftsizes.h
- added patch p_ia64.diff to fix DRI compile problems on ia64
- adjusted minor numbers of libXft and libXfont
- added some new files introcuded with coming 4.2.0 release to filelist
  * luit, uxterm, xrandr, xtrapchar, xtrapin, xtrapinfo, xtrapout,
  xtrapproto, xtrapreset, xtrapstats
  * xedit lisp files
  * libXTrap, libXrandr
  * new drivers: imstt, s3
  * new extension: libxtrap
  * Luxi truetype fonts
- use separate freetype2 package for building
* Fri Dec 14 2001 - ro@suse.de
- removed START_XFS, use macros for insserv
* Wed Dec 12 2001 - uli@suse.de
- use MakeDllModules on ARM
* Mon Dec 10 2001 - sndirsch@suse.de
- removed xf86driver-options from package list for s390/s390x
- replaced "Requires: pam_devperm" with "Requires: pam_devperm.so"
- removed p_mga_g550.diff and p_mga_g550_id.diff (G550 support now
  in p_suse_fixes_post73.diff)
- removed p_revert_mouse_changes.diff (Keith's changes were not
  responsible for loosing mouse events)
- adjusted p_sbit.diff to new p_suse_fixes_post73.diff
- disabled p_pcidomain_mga_ppc_antonb.diff (ppc only) for now
- new p_suse_fixes_post73.diff with the following additions:
  * Fix Timers to survive CARD32 wrap (keithp)
  * Patches from Egbert Eich:
- Updated fontlib to a later version
- fixed xkb to avoid setting of AccessXTimeout to 0
- reversed bogus patch for Xinerama XV
- Added option to sync the logfile after every line written
- improved APM handling:
  Added disable of Input Handlers,
  Added support for undo on failed APM requests,
  Set vtSema to false
- hopefully improved detection of primary device
- added fix for lockup of Radeon chips
- updated mga driver
- Set flag ROP_NEEDS_SOURCE for CPUToScreenColorExpand for all
  S3 Savage chips
- Added GE reset when returning from VT switch to siliconmotion
  driver.
- fixed SiS driver to restore fbdev mode properly.
- fopefully improved LCD handling on SiS 630.
- fixed screen blanking in SiS driver to properly blank LCDs
- fixed Tdfx driver for Banshee
- fixes to tga driver by Jay Eastabrook.
- added ps2 mouse replug reset to mouse driver.
- Several video enhancements for Trident driver
* Tue Dec 04 2001 - uli@suse.de
- added ARM support
* Tue Nov 20 2001 - sndirsch@suse.de
- compile static XVideo, Misc, DGA and Vidmode libraries with
  "-fPIC" for IA64
* Thu Nov 15 2001 - sndirsch@suse.de
- adjusted specfile for mips architecture
- moved shared libraries libXxf86vm, libXxf86dga, libXxf86misc and
  libXv from xshared to XFree86-compat-libs (new package)
--> https://bugzilla.redhat.com/bugzilla/show_bug.cgi?id=28196
- removed XftConfig; now in package xf86tools to be able to update
  it easier
* Fri Nov 09 2001 - sndirsch@suse.de
- removed subpackages xf86glu + xf86glu-devel (replaced by sub-
  packages mesaglu + mesaglu-devel of mesa)
- removed libOSMesa from filelist (now in package mesa)
* Tue Nov 06 2001 - sndirsch@suse.de
- added SuSEconfig.xdm for xdm configuration
* Tue Oct 09 2001 - bjacke@suse.de
- make xauth part of xshared (needed for ssh X11forwarding)
* Fri Oct 05 2001 - sndirsch@suse.de
- mga driver: Disable Render acceleration secondary CRTC (keithp)
  (Patch #9390)
- fix flickering LCD problem for notebooks with i815 chip like ASUS M1300
  in i810 driver (Harald Koenig <koenig@science-computing.de>,
  Poul-Henning Kamp <phk@freebsd.org>)
- fix for brazilian ABNT2 keyboard layout
  (Carlos Hix <carlos.hix@numericon.com.br>)
* Tue Sep 25 2001 - sndirsch@suse.de
- fixed important typo (Bug #11297)
* Fri Sep 21 2001 - sndirsch@suse.de
- reverted Keith's mouse changes again (to much trouble with lost
  mouse events) --> p_revert_mouse_changes.diff (Bug #11204)
- replaced p_mga_ppc_antonb.diff with the new patch
  p_pcidomain_mga_ppc_antonb.diff (only ppc is affected by this
  change of olh!)
- removed driver directory 'vmware.orig'
* Wed Sep 19 2001 - sndirsch@suse.de
- removed /etc/X11/XftConfig (Bug #10879)
* Tue Sep 18 2001 - sndirsch@suse.de
- fixed path for Type1 fonts in XftConfig (Bug #10801)
- removed wrong patches for documentation (mga.cpp,mga.man,README)
  in p_mga_g550.diff
* Sat Sep 15 2001 - sndirsch@suse.de
- mouse driver fix from Keith Packard (p_revert_mouse_changes.diff
  not required any longer): 'Mouse block/wakeup handlers werent
  re-registered after server reset'
- mga driver fix from Keith Packard: 'Initialize MGA storage used
  for accelerated alpha compositing'
- added Matrox MGA G550 support (p_mga_g550.diff) (Randall Watt)
- added Matrox MGA G550 device id (p_mga_g550_id.diff)
- MGA G550 patch was tested successfully with the affected
  boards G200/G400/G450
* Fri Sep 14 2001 - sndirsch@suse.de
- patches from Gerd Knorr <kraxel@suse.de>
  * parameters in NVPutOverlayImage call in nv video driver were
  mixed up
  * fixes a few drivers to set memPhysBase correctly (the v4l module
  depends on that). It also makes the v4l module print memPhysBase
  once to the log
- integrated glide driver fixes from XFree86 CVS branch (rel. 1.27)
  * fix broken glide driver that caused -configure to fail for all
  drivers in 4.1.0
  * first part of driver Loader symbol req/ref registration cleanup
  * Must call fbPictureInit after visual RGB orders have been fixed
* Wed Sep 12 2001 - sndirsch@suse.de
- reverted last mouse changes of Keith Packard (lost mouse events)
--> p_revert_mouse_changes.diff
* Tue Sep 11 2001 - kukuk@suse.de
- sunffb should not load dri and drm module
* Mon Sep 10 2001 - sndirsch@suse.de
- added new options for firegl23 and nvidia driver
- bugfixes from Egbert Eich integrated in p_suse_fixes.diff:
  * latest savage driver fixes by Tim Roberts: The 1.1.19 drop
  should fix the hangs in "xlock -mode xcl" and in the Opera
  browser.
- bugfixes from Keith Packard integrated in p_suse_fixes.diff:
  * lib/Xft: handle truetype fontfiles with more than one font --
  .xftcache was getting busted
  * Eliminate malloc/free calls from 3 button emulation code
  * Restructure fbDoCopy to ensure out of range width/height are
  always caught
  * Change unsigned int to XftChar32 everywhere else, fix
  RenderExtents{16,32,Utf8} to match RenderExtents8
  * Add Xinerama kludge for root window tiles
  * Incorrect protocol size for xPictFormInfo structure. Would you
  believe it mostly works anyhow?
- adjusted 000_stolen_from_HEAD.diff in ppc-patches.tar.bz2 (removed
  patch already included in p_suse_fixes.diff)
- exit code in switch2xf86_glx is now always defined
* Thu Sep 06 2001 - kukuk@suse.de
- Use $named and $network in rcxfs script [Bug #9908]
* Wed Sep 05 2001 - werner@suse.de
- Change color and location of XConsole for new KDM theme
* Mon Sep 03 2001 - sndirsch@suse.de
- removed 'x_server' and package ttmkfdir of 'Requires' of package
  xf86
- added package ttmkdir to 'Requires' of package xloader
- new p_suse_fixes.diff (patches from Egbert Eich):
  * disabling int10 support for Sparc
  * adding "ALDI"-tablet driver (again)
  * minor fixes to C&T overlay support
  * added automatic detection of 24/32 bpp for fbdev driver
  * removed a bogus fix from apm code that prevented apm
  to return to select. (Keith and I fixed this in March 2000
  somebody broke it again)
  * fix for video on Trident. Now videos wider than 384 pixels should
  play OK on more chipsets.
  * attempt to fix SiS driver
  this seems to work for me
* Fri Aug 31 2001 - sndirsch@suse.de
- new p_suse_fixes.diff:
  * some patches from Egbert Eich:
- removed debugging code from apm driver
- update  savage driver to version 1.1.1.18
- fixed ATi Mach64 driver for Sharp notebook
- fixed C&T driver for CT69030, improved video support etc.
- fixed lockup problem in neomagic driver
- added Libretto support to neomagic driver
- improved Trident video support
- added log message to vbe
- fixed typo in neomagic driver
- fixed color problem of DGA mode in neomagic driver
  * integrated cz_and_sk_kb.diff (patch from Kendy)
- added programs/xkb/symbols/us_group2
- fixes the cz* and sk* keyboards to use it to be switchable
  (with US keyboard) again
* Wed Aug 29 2001 - kendy@suse.cz
- added cz_and_sk_kb.diff, which creates xkb/symbols/us_group2
  and fixes the cz* and sk* keyboards to use it to be switchable
  (with US keyboard) again.
* Mon Aug 27 2001 - sndirsch@suse.de
- integrated hyperpen.tar.gz/p_hyperpen.diff (Hyperpen driver) into
  p_suse_fixes.diff
- build some libraries with -fPIC for ppc
* Fri Aug 24 2001 - sndirsch@suse.de
- added driver for AHP5000/Hyper Pen 5000/Digital Edge Natural Pen
  (hyperpen.tar.gz p_hyperpen.diff)
  ftp://ftp.sourceforge.net/pub/sourceforge/xf86DigitalEdge/xf86HyperPen-0.1.3.1.tar.gz
* Sat Aug 18 2001 - mfabian@suse.de
- add sbit patch to make the freetype module use embedded bitmaps
  present in some unicode/cjk TrueType fonts for small point sizes
  instead of rendering the outlines.
  (original patch xfree-ttf-patch.tar.gz is from
  <timecop@japan.co.jp> http://www.ne.jp/asahi/linux/timecop/,
  I only adapted it to work with  XFree86-4.1.0)
* Sat Aug 18 2001 - kukuk@suse.de
- Fix p_sparc-pci patch to apply again
* Fri Aug 17 2001 - sndirsch@suse.de
- link /usr/lib/libsupc++ inside of GLU, if it exists (required
  since gcc >= 3.0)
* Thu Aug 16 2001 - sndirsch@suse.de
- removed p_s390x.diff/p_suns32bpp.diff (integrated it into
  p_suse_fixes.diff)
- more p_suse_fixes.diff changes:
  r128/radeon driver: calculate the correct DRM_PAGE_SIZE for ia64; patch
  came from the linux-ia64 mailing list (Andreas Schwab sent it to me),
  have a look at
  https://external-lists.valinux.com/archives/linux-ia64/2001-March/001326.html
  for details
* Mon Aug 13 2001 - sndirsch@suse.de
- removed p_drm-ppc-diff (not required any longer)
- removed p_drm.diff (not required any longer)
- removed p_nvidia.diff (is now done with sed in specfile)
- removed p_x-axp.diff (integrated into specfile/host.def)
- removed most keyboard layouts of symbols.tar.gz (now handled with symlinks
  in specfile)
- added 'FILES' for details of sources/patches
- added wdm patch Xsession.diff of Vladimir N. <nadvornik@suse.cz>
- new p_suse_fixes.diff:
  * removed patch for xclock/Clock.c: not required any longer
  * new patches from Egbert Eich:
- xvdisp.c: changed XineramifyXV so that it is no longer required
  that the pimary card supports xv in order for xv to work; bugfix:
  changed & to &&
- lnx_kmod.c: fixing so that user can also load module (stts
  ticket: 20010729000000308); set PATH to /sbin so that modprobe
  finds insmod
- trident driver fixes:
  * Fixed support for the CYBERBLADEXP(m) Chipsets.
  We won't be able to do accel for those chips as Trident
  doesn't allow us to release source code.
  * Some modifications to video support of Blade chipsets
- common/xf86Events.c: Added comment
- common/xf86PM.c: initialized static variable
- cirrus driver fixes:
  * fixed acceleration for 5446 Chipset
  * fixed multihead for Alpine chipsets
- neomagic driver fixes:
  * fixed Screen2ScreenBlit for 2200 again: copy direction was not
  taken into account correctly before
- vbeFree() fixes for the drivers apm, r128, i740, i810, chips,
  mga, nv, rendition, savage, tseng, siliconmotion, vesa
- os-support/bus: fixed readPciBIOS() to handle non-x86 BIOS formats
- os-support/linux/lnx_video.c: Jay Estabrooks AXP Patches
- int10: fixed to work with new readPciBIOS()
- xf86cfg: fixed typo
- wacom driver: removed 3.3 stuff
- x86emu:
  * Jay Estabrooks AXP patches: reversed some stuff mo longer
  needed in mga driver due to the new sparse handling
  * alignment fixes for registers
- mga driver fixes:
  * Jay Estabrooks AXP patches: reversed some stuff mo longer
  needed in mga driver due to the new sparse handling
  * alignment fixes for registers
- xaa: fix for N-N CopyPlane to prevent Sig11 under certain
  circumstances (feedback ticket: 20010803990000091)
  * new patch from Gerd Knorr:
- v4l module: Handling of multiple TV cards didn't work correctly
  * new patch from Stefan Dirsch:
- is kbd layout: fixed typo (asciircum should be asciicircum)
* Thu Aug 09 2001 - bk@suse.de
- make it build and work on s390(fixes bug 9435)
  add s390x to all ifarch s390 in specfile(and disable usb, fix awk)
* Mon Jul 23 2001 - bk@suse.de
- add support for s390x
* Mon Jul 23 2001 - kukuk@suse.de
- Fix initialization of suncg4 and sunleo driver
* Sun Jul 22 2001 - kukuk@suse.de
- Fix pci domain patch (NULL pointer dereferencing)
* Fri Jul 20 2001 - sndirsch@suse.de
- added tarball for additional ppc patches (ppc-patches.tar.bz2)
* Thu Jul 19 2001 - sndirsch@suse.de
- changes in p_suse_fixes.diff:
  * actually 1002:5446 is a Rage 128 Ultra TF instead of the
  assumed Rage 128 Pro
  * added support for ATI Rage 128 GL SM chips (1002:534D)
* Tue Jul 17 2001 - kukuk@suse.de
- Add pci domain patch from DaveM for SPARC
* Wed Jul 11 2001 - sndirsch@suse.de
- replaced broken vmware driver with vmware driver (2/20/01) of
  vmware website
- added small vmware patch (p_vmware.diff) required for YaST2
  installation to detect the current color depth of the host
  X Server
- added Provides/Obsoletes of vmware-driver for package xmodules
- moved patch to link libusb statically from patch p_suse_fixes.diff
  to patch p_suse.diff
- changes in p_suse_fixes.diff:
  * fixed typo in X.man
* Mon Jul 09 2001 - sndirsch@suse.de
- splitted p_suse.diff in suse-addons.tar.bz2 and p_suse.diff
- integrated all non-arch specific patches in SuSE CVS;
  p_suse-fixes.diff now contains all non-arch specific patches;
- removed patches (now in SuSE/CVS respective p_suse_fixes.diff):
  * p_euro_acute2apostrophe.diff
  * p_euro_locale.diff
  * p_euro_localefont.diff
  * p_euro_xtermAppD.diff
  * p_euro_xtermAppD2.diff
  * p_ia64.diff
  * p_imake.diff
  * p_include_time.diff
  * p_lnx_kmod.c.diff
  * p_osmesa.diff
  * p_r128pro.diff
  * p_radeon_ve.diff
  * p_sparc.diff
  * p_suse-cvs.diff
  * p_symbols.diff
  * p_usb.diff
  * p_xdm_pam.diff
  * p_xvfb_s390.diff
- adjust Makefiles of glxinfo/twm during build for alpha architecure
  (workarounds for gcc 3.0 problems)
* Thu Jul 05 2001 - sndirsch@suse.de
- #neededforbuild+=freetype2 (freetype2 sources of XFree86 no longer
  used, libXft is now linked dynamically against freetype2)
- added changes of SuSE internal XFree86 CVS (p_suse-cvs.diff):
- fix core dump in ct driver
- enable dga accel only when acceleration is enabled: ct, neomagic
- fix core dump in i740 driver
- fix 24 + 8 overlay for mga when using hallib
- fix for mga G100 HW cursor color setting
- added softbooting to generic driver
- fixed problem with trident driver which caused "melting" effect on
  display again
- fixed pixmap window background and frame in sw xf8_24bpp overlay code
- fixed bug in readPciBios that caused wrong base register to be restored
- fixed servermd.h for S390
- fixed memory size limit routine in tseng driver
- fixed twm to not core dump when no locale information is present
- adding more messages of fbdev if anything goes wrong
* Tue Jun 26 2001 - sndirsch@suse.de
- renamed CardModules in /etc/X11 to CardModules.new to prevent
  conflicts with xf86 when SaX2 is built for SuSE <= 7.2
- corrected p_r128pro.diff
* Mon Jun 25 2001 - sndirsch@suse.de
- moved /etc/X11/CardModules to new package xf86driver-options
- Imake.rules: fix symlinking of files in sub-directories
  (p_imake.diff)
* Fri Jun 22 2001 - sndirsch@suse.de
- adjusted driver_options.sh to new options of ati + nvidia driver
- disabled moving of unicode fonts to ucs/{misc,75dpi,100dpi}
  directories
- patch /etc/X11/XF86Config in %%post of xf86 to remove additional
  to misc also the lines
  FontPath      "/usr/X11R6/lib/X11/fonts/75dpi"
  FontPath      "/usr/X11R6/lib/X11/fonts/100dpi"
  because scaled misc fonts look very ugly in general. This is only
  done, if the lines
  FontPath      "/usr/X11R6/lib/X11/fonts/75dpi:unscaled"
  FontPath      "/usr/X11R6/lib/X11/fonts/100dpi:unscaled"
  are available.
- changed config.xfs according to this
* Wed Jun 20 2001 - sndirsch@suse.de
- disabled use of pam_devperm.so for SuSE 7.0 (package not available
  for this version)
- moved X Printer config files located in /etc/X11/xserver/C/print
  from package xf86 to package xxprt
- added build of Xvfb/Xnest/Xprt on s390 (p_xvfb_s390.diff)
- added Device Id of Rage 128 Pro chip on ATI XPERT 2000 to
  xf86PciInfo.h (p_r128pro.diff)
- removed Requires: x_server in xf86 package for s390
* Mon Jun 18 2001 - sndirsch@suse.de
- added $(DESTDIR) to some rules in config/cf/Imakefile
- added Radeon VE patch (p_radeon_ve.diff)
* Mon Jun 18 2001 - sndirsch@suse.de
- added options "-nf" to all "ln -s" commands
- $RPM_BUILD_ROOT is now correctly removed in beginning of
  %%install section
- removed Requires: windowmanager in package xf86 (twm is included
  in xf86)
* Mon Jun 18 2001 - sndirsch@suse.de
- added DRM patch for ppc (p_drm-ppc.diff)
- added $(DESTDIR) to Makefile.module
* Tue Jun 12 2001 - sndirsch@suse.de
- do not try to copy 'xserverrc' sourcefile for s390
- added Requires:3ddiag for packages xf86_glx + NVIDIA_GLX
- enabled build of XIE/XIElib again (Mozilla 0.9.1 needs it!)
- added keyboard symbols (again): cs, cs_qwerty, czsk, gr
- renumbered patchfiles/sourcefiles in specfile
* Mon Jun 11 2001 - sndirsch@suse.de
- use 'xserverrc' sourcefile for every SuSE distribution
* Sat Jun 09 2001 - sndirsch@suse.de
- added libxrx and km_drm package for Sparc
* Thu Jun 07 2001 - sndirsch@suse.de
- disabled build of XIElib
- removed xieperf in filelist
- removed XIE extension header files
- enabled -fPIC for building GLX on all platforms other than i386
- changes to Makefile.module (DRM Build)
  * added radeon module
  * patch temporarily <linux/module.h>
  * install modules not only for Kernel 2.2
- adjustments for s390 (no xinit, no driver options file; showrgb,
  libxrx, /usr/X11R6/lib/X11/etc/* added)
- added libOSMesa for IA64
- added /usr/X11R6/lib/modules/*.uc for IA64
- added subpackage km_drm for IA64
* Thu Jun 07 2001 - sndirsch@suse.de
- updated XFree86 to release 4.1.0 (big step!)
- added HALlib (again) for mga driver
- added Glide3/DRI headers and libs for i386/axp (glidedri/gldri_v5
  packages not required any longer; will be deleted (also in x11DB);
  dependencies are set)
- added patch for OSMesa (p_osmesa.diff)
- removed matrox 1.2.0Beta driver sources (maybe we get new
  ones based on 4.1.0 later)
- removed siliconmotion/sis/savage driver sources (already in 4.1.0)
- removed unicode 75/100 dpi font sources (already in 4.1.0)
- removed g3ext.h (included now in glide3headers.tar.gz)
- removed many patches already included in 4.1.0
  * p_ati_render.diff
  * p_egbert.diff
  * p_egbert_smi.diff
  * p_egbert_trident.diff
  * p_i740_render.diff
  * p_r128_ddc.diff
  * p_sis_neomagic_ati.diff
  * p_smi.diff
  * p_smi_render.diff
  * p_tdfx_dri.diff
  * p_vga16.diff
  * p_xf86_402-402ppc.diff
  * p_xft.diff
  * p_xterm-u8.diff
  * p_xterm_trailing_blanks.diff
- removed some patches, which are not required any more
  * p_ucs-fonts-75dpi100dpi.diff
  * p_mga_nohal.diff
- removed some never used patches (not required at all)
  * p_mga_g450.diff
  * p_mga_ddc.diff
  * p_fbdev_render.diff
  * p_i810_render.diff
  * p_nopthreads4libGL.diff
  * p_euro.diff
- adjusted some patches for 4.1.0
  * p_drm.diff
  * p_euro_acute2apostrophe.diff
  * p_euro_locale.diff
  * p_lnx_kmod.c.diff
  * p_suse.diff
- adjusted switch2xf86_glx (renamed Glide3/DRI libs)
- c++ compiler (packages gpp/libgpp) now required for building
  GLU libs
- added packages xf86glu/xf86glu-devel for GLU libs (no xf86glu
  source package any more, will be deleted!)
- enabled DRI and Glide3 for Alpha (it looks like DRI with 3Dfx boards
  now works on Alpha)
- libOSMesa is now build also for alpha/ppc
- moved unicode fonts to ucs directories (Bug #8411)
  /usr/X11R6/lib/X11/fonts/ucs/misc
  /usr/X11R6/lib/X11/fonts/ucs/75dpi
  /usr/X11R6/lib/X11/fonts/ucs/100dpi
- no latin2 font directories any more
- SuperProbe now in package xf86_3x
- added some new binaries/libs/files
  * ccmakedep
  * cleanlinks
  * dpsexec
  * dpsinfo
  * glxgears
  * texteroids
  * xfsinfo
  * xftcache
  * xmh
  * libXmuu
  * /usr/X11R6/lib/X11/Options
- lbxproxy now included for all archs
- libxrx now also included for ppc/alpha
- DRI drivers now also for ppc/alpha (should be included now in the k_*
  packages for ppc/alpha)
- *** new *** : vmware driver
- km_drm package no longer empty for alpha/ppc
- some cleanups
* Mon Jun 04 2001 - sndirsch@suse.de
- disabled build of PEX/XIE (obsolete stuff)
- changed version of dummy packages NVIDIA_GLX/NVIDIA_kernel to 0.8
- added %%clean section, to be able to see if there are new files
  with a new build
* Thu May 31 2001 - sndirsch@suse.de
- removed 'insserv' call in %%post of xf86 for SuSE 7.0
- added sourcefile 'xserverrc' of SuSE 7.1 for SuSE 7.0
- added DDC patch for r128 driver (p_r128_ddc.diff)
* Fri May 25 2001 - sndirsch@suse.de
- adjusted xf86.spec/config-dist.sh to use libusb instead of
  usbutils (package was renamed)
* Wed May 23 2001 - sndirsch@suse.de
- Include dri modules on ia64
* Wed May 23 2001 - sndirsch@suse.de
- build now also works with SuSE 7.0/SuSE 7.1
  * added g3ext.h (again)
  * some changes in config-dist.sh
* Tue May 15 2001 - sndirsch@suse.de
- fixes for AA Font problems in konsole (p_xft.diff, Bug #8326)
* Fri May 11 2001 - sndirsch@suse.de
- added X Print Server config files (Bug #8111)
* Thu May 10 2001 - sndirsch@suse.de
- fixed Sig11 of "xterm -u8" if no unicode font can be found (Bug #7843)
* Thu May 10 2001 - sndirsch@suse.de
- p_euro_xtermAppD2.diff: now also for default font the correct font
  is loaded (important for EuroSign!)
* Thu May 10 2001 - sndirsch@suse.de
- added Requires: xf86_glx to xf86glx-devel
* Thu May 10 2001 - sndirsch@suse.de
- some small bugfixes in sis/neomagic driver (p_sis_neomagic.diff)
- replaced  p_euro_deadacutegrave.diff with p_euro_acute2apostrophe.diff
  acute is mapped to apostrophe for iso8859-15; two new variants
  "deadacute" and "deadgraveacute" for symbols/de
- corrected error message in startx, if the X link does not exist (Bug #7848)
- added RENDER support for ati driver (p_ati_render.diff)
- added RENDER support for smi driver (p_smi_render.diff)
- added RENDER support for i740 driver (p_i740_render.diff)
- /usr/lib/libGL.so is now a symbolic link to the correct libGL.so.1
  instead of a binary; resolves ldconfig confusion (Bug #7901)
- added libGL.so.1 to "Provides:" of xf86_glx
- all driver updates (sis/neomagic/ati/smi/i740) tested and verified
  (including RENDER support) by eich/sndirsch
* Sun May 06 2001 - sndirsch@suse.de
- replaced sis driver of XFree86 4.0.3 with sis driver of devel
  branch (some changes from Egbert)
- changed Makefile.module for km_drm package, so that only for
  kernel 2.2 DRM modules are installed; for kernel 2.4 the DRM
  modules which come with the kernel sources must be used
- removed wrong patch p_euro_acute2apostrophe.diff
- new patch p_euro_deadacutegrave.diff: acute/grave are now also
  dead keys for de(nodeadkeys), acute is mapped on apostrophe as
  there is no acute symbol in ISO8859-15
- removed %%define for RPM postinstall
* Fri May 04 2001 - mfabian@suse.de
- make xfs init script comply with latest LSB spec
* Fri May 04 2001 - sndirsch@suse.de
- smi patch (p_smi.diff):
  * enabled ZoomOnLCD option (stretching feature)
  * output of "Panel Size" enabled; required for SaX2
* Fri May 04 2001 - sndirsch@suse.de
- patch /etc/X11/XF86Config in %%post of xf86 to remove the line
  FontPath      "/usr/X11R6/lib/X11/fonts/misc"
  because scaled misc fonts look very ugly (Bug #7565)
* Thu May 03 2001 - sndirsch@suse.de
- replaced 4.0.3 smi driver with much better CVS smi driver
  (silicon_motion.tar.gz)
* Wed May 02 2001 - sndirsch@suse.de
- replaced savage driver with latest driver of Tim Roberts and
  some patches of Egbert Eich (suse.savage.tar.gz)
- removed unused sav40.tar.gz source
* Mon Apr 30 2001 - werner@suse.de
- Change for the common european languages due to the move from
  ISO-8859-1 to ISO-8859-15 the symbol `acute' to `apostrophe'.
* Thu Apr 26 2001 - werner@suse.de
- Fix calculation of the trailing blanks in xterm
  to fix drawing of YaST and others.
* Tue Apr 24 2001 - sndirsch@suse.de
- changes in driver_options.sh
  * options for r128, radeon added
  * correct options for ati, nvidia, firegl1, firegl23
- added p_euro_xtermAppD.diff by Michael Schroeder <mls@suse.de>
* Fri Apr 20 2001 - schwab@suse.de
- Fix portability bugs in Wraphelp.c.
* Wed Apr 18 2001 - sndirsch@suse.de
- replaced p_euro.diff (suggestions by Markus Kuhn); disabled for now
- added p_euro_locale.diff (patch for locale.alias/locale.dir)
- added p_euro_localefont.diff by Michael Schroeder <mls@suse.de>
- new locale.awk
- added ISO8859-15 fonts for 75dpi/100dpi
* Tue Apr 17 2001 - sndirsch@suse.de
- added trident/smi patches of Egbert (p_egbert_trident.diff/
  p_egbert_smi.diff)
* Fri Apr 13 2001 - sndirsch@suse.de
- added mga patch, so that HALlib is no longer used by default,
  specify 'Option "NoHal" "no"' to use HALlib; MGA G450 does not
  require HALlib any more, only G200/G400 for Multihead/TV out
  support
* Wed Apr 11 2001 - sndirsch@suse.de
- replaced mga driver with Matrox driver Beta 1.2.0 (April 3, 2001)
- removed HALlib.tar.gz (already included in mga-1_2_0beta.tgz)
- disabled p_mga_g450.diff (not required any more)
- replaced Savage driver 1.1.15 with official XFree86 4.0.3 driver
  again
* Tue Apr 10 2001 - sndirsch@suse.de
- added subpackages NVIDIA_GLX/NVIDIA_kernel for Dummy nvidia
  2D/3D driver; these packages can be easily updated with YOU or
  the download of these packages from the nVidia webserver to use
  the real 3D hardware accelerated nVidia driver
* Thu Apr 05 2001 - sndirsch@suse.de
- disabled DRI support for axp
- added Savage 1.1.15 driver (sav40src.tgz)
- new p_egbert.diff
  * bugfixes for drivers: r128, radeon, chips, cirrus, glint, mga, tga, neomagic
  * other bugfixes: compiler.h, xf86cmap.c, int10, os-support, xf4bpp, LBX, xdm
- removed p_lbx.diff (patch already included in new p_egbert.diff)
- removed some hunks in p_vga16.diff (already included in new p_egbert.dif)
* Sun Apr 01 2001 - sndirsch@suse.de
- g3ext.h only exists on i386, so it is only copied on this
  architecture
* Mon Mar 26 2001 - sndirsch@suse.de
- mapped AltGr+e to currcency symbol (was EuroSign before), so Euro
  symbol can be displayed when an ISO8859-15 font is used (Euro
  symbol is mapped on currency slot in ISO8859-15 fonts) -> euro.dif
- DRM kernel modules are now installed to kernel/drivers/char/drm
  instead of video (Makefile.module)
- renamed patches to p_<previous_patchname>.diff
- moved g3ext.h to package glidesdk
- moved fetchmsttfonts, xf86debug and xf86version to package xf86tools
- removed sourcefile glxext.h, use now the one which comes with XFree86
* Fri Mar 23 2001 - sndirsch@suse.de
- dependancy changes acccording to http://w3.suse.de/~kkaempf/dep/dep.html
- removed package cardmods (/etc/X11/CardModules included in package xf86)
* Thu Mar 22 2001 - sndirsch@suse.de
- added '/lib/cpp' to Requires: of xf86 (needed by xrdb)
* Tue Mar 20 2001 - sndirsch@suse.de
- updated to release 4.0.3
- adjusted patches
  * suse.dif
  * egbert.dif
- added usb.dif to be able to link with static libusb, without
  having to remove libusb.so manually
- removed freetype sources (now included in xf86 sources)
- g3ext.h now in ./include instead of /usr/include/glide3
- mesadev stuff no longer removed (mesadev was already not longer
  included in #neededforbuild)
- /usr/X11R6/lib/X11/XftConfig is now removed before the SuSE
  specific one is copied to this location
* Thu Mar 15 2001 - sndirsch@suse.de
- startx is now installed with the correct permission (755)
* Thu Mar 15 2001 - stepan@suse.de
- enabled drivers for alpha axp.
* Tue Mar 13 2001 - sndirsch@suse.de
- fixed startx problem by Werner Fink (Sourcefile: startx, Bug #6619)
- fixed PAM problem in xdm by Werner Fink (xdm_pam.dif, Bug #6637)
* Fri Mar 09 2001 - schwab@suse.de
- Fix vga16 server for ia64.
* Fri Mar 09 2001 - sndirsch@suse.de
- added lbx.dif: fixes server crash when lbxproxy client runs on
  a big endian machine
* Wed Mar 07 2001 - sndirsch@suse.de
- renamed package xf86glxd --> xf86glx-devel
* Wed Mar 07 2001 - sndirsch@suse.de
- removed mesadev from neededforbuild
- commented out temparily GLU/glut files
* Sun Mar 04 2001 - sndirsch@suse.de
- switch2xf86_glx: first probe if Voodoo4/5 is available in testmode
- fetchmsttfonts: new URLs for TT fonts (one was obsolete)
- added /usr/share/doc/packages/xf86 (symlink to /usr/X11R6/lib/X11/doc)
- updated to latest 4.0.2 CVS release
* Wed Feb 28 2001 - sndirsch@suse.de
- adjusted switch2xf86_glx script for creating/testing/removing
  /usr/lib/libglide3.so.3 symbolic link (Glide3/DRI libraries
  are now located without conflicts in /usr/lib/glide)
* Tue Feb 27 2001 - schwab@suse.de
- Don't try to disable interrutps on ia64.
* Mon Feb 26 2001 - sndirsch@suse.de
- includes now HALlib of Matrox 1.01.05 driver
- increased MaxClock for Multihead
  * G400: 135 Mhz (before: 112 MHz)
  * G450: 234 MHz
- corrected error message for disabling DRI in 32bp for
  3Dfx boards <= Voodoo3
- removed wmlist from suse.dif (now in package susewm)
* Sat Feb 10 2001 - sndirsch@suse.de
- some changes to make it buildable on 7.0-s390
  * adjustments in config-dist.sh similar to 7.0-i386
  * moved /usr/X11R6/lib/X11/xkb to /etc/X11/xkb
  * no Wacom USB support for s390
- removed lbxproxy from filelist for s390, ppc, sparc and sparc64
  (lbxproxy on big endian machines crashes X Server, at least on i386)
* Thu Feb 08 2001 - mfabian@suse.de
- add start script, rc.config entry for xfs and new
  config file for xfs.
* Wed Feb 07 2001 - sndirsch@suse.de
- does not remove links in %%postun of xf86_glx during an update any more
* Tue Feb 06 2001 - ro@suse.de
- xclock: Clock.c include time.h before ClockP.h
* Sun Feb 04 2001 - sndirsch@suse.de
- Update problems of xf86 package now hopefully fixed
  * pre/post/postun scripts for creating/removing symbolic links rewritten
  * triggerun/triggerpostun scripts deleted
  * ghost entries for symbolic links added (again) (/usr/X11R6/lib/X11/$i/*)
  * symbolic links are now relative --> no problems with autobuild
  (/usr/X11R6/lib/X11/$i --> ../../../../etc/X11/$i )
- disabled MMX, 3DNow and Katmai support for Mesa
* Sat Jan 27 2001 - sndirsch@suse.de
- changed second entry of "key <KPDL>" from KP_Seperator to
  KP_Decimal for de_CH keymap
* Wed Jan 24 2001 - kukuk@suse.de
- Fix xkb file for US-Sun-Keyboard
* Wed Jan 24 2001 - sndirsch@suse.de
- removed xf86_glx conflicts with
  * mlx
  * glxriva
  * glxrage
  * glxg200
  * NVIDIA_GLX
* Thu Jan 18 2001 - sndirsch@suse.de
- changed doubleclick separators of xterm for PPC
- some changes in config-dist.sh for compilation/use on SuSE 7.0-i386
  systems
- updated to latest Matrox HALlib (G450 support now better?)
* Thu Jan 18 2001 - sndirsch@suse.de
- libGL.so.1.2.xf86_glx is now located in /usr/lib/GL (problems
  with "ldconfig")
* Sat Jan 13 2001 - sndirsch@suse.de
- fixed showstopper in switch2xf86_glx script (Bug #5316)
* Fri Jan 12 2001 - sndirsch@suse.de
- small patch for trident driver from Egbert (font fix for 9540)
* Thu Jan 11 2001 - sndirsch@suse.de
- small patch for chips driver from Egbert
- set xterm to root.tty 2755
* Thu Jan 11 2001 - sndirsch@suse.de
- some more patches from Egbert for trident driver
* Wed Jan 10 2001 - sndirsch@suse.de
- changed real/effective user ID to 0/0 before exec of modprobe to
  load DRM kernel modules, as for some DRM modules agpgart must be
  preinstalled; this is done in a child process before the exec call,
  so it should be secure
* Mon Jan 08 2001 - sndirsch@suse.de
- libXv is now build as shared library instead of static as some DVD
  players require the shared library
* Mon Jan 08 2001 - sndirsch@suse.de
- some more bugfixes for Neomagic, Trident and Chips driver of Egbert
- all patches of Egbert are now in one patch (egbert.dif)
- you don't have to execute switch2xf86_glx any more with complete path
* Sat Jan 06 2001 - kukuk@suse.de
- On SPARC, rename fbdev_drv.o to fbdev_drv.o.problematic to
  avoid all the problems with not working framebuffer driver
* Fri Jan 05 2001 - sndirsch@suse.de
- added Egbert's patches 2 and 3 with many bugfixes for the
  following drivers
  * Chips & Technologies
  * Matrox
  * Neomagic
  * 3Dfx
  * Tseng
  * Vga(16)
  * Trident
- enabled build of tdfx driver for PPC
* Fri Jan 05 2001 - sndirsch@suse.de
- added xf86_402-402ppc.dif (only used for PPC!)
* Tue Jan 02 2001 - sndirsch@suse.de
- removed empty xfntbig package (obsolete in xf86 package is set!)
* Sat Dec 30 2000 - kukuk@suse.de
- Remove sparc patch
* Fri Dec 29 2000 - sndirsch@suse.de
- added Option "SwappedHead" for G450 boards (mga_g450.dif)
- adjusted DRM sources to Kernel 2.4-test12
* Wed Dec 27 2000 - sndirsch@suse.de
- added Egbert's patch with many bugfixes for the following drivers
  * Cirrus Logic (especially GD 5480)
  * Matrox
  * Neomagic
  * Trident
  * Tseng
* Thu Dec 21 2000 - sndirsch@suse.de
- corrected locale.awk script (Egbert Eich)
* Wed Dec 20 2000 - sndirsch@suse.de
- create package km_drm only for i386
* Mon Dec 18 2000 - sndirsch@suse.de
- updated to final release 4.0.2
- disabled building of mga driver with HALlib for all platforms
  other than i386
- enabled building of ati driver for ppc
* Sun Dec 17 2000 - sndirsch@suse.de
- updated to release 4.0.1Zc (4.0.2RC4)
- removed patches, which are already in 4.0.1Zc
  * ia64.dif
  * mga_hal.dif
  * remove_traditional.dif
  * turkish.dif
  * xf86Config.dif
* Fri Dec 15 2000 - sndirsch@suse.de
- updated to Freetype 2.0.1
* Fri Dec 15 2000 - sndirsch@suse.de
- removed XftConfig.dif (not required any longer)
- replaced XftConfig file (new format)
- removed package xtermttf
* Thu Dec 14 2000 - sndirsch@suse.de
- defined "feedback@suse.de" for XFree86 bug reports instead of
  "xfree86@xfree86.org"
- added HALlib support for mga driver (can be turned off with
  'Option "NoHal"' in XF86Config)
- enabled Freetype2 and DRI support for PPC again
* Wed Dec 13 2000 - werner@suse.de
- Distinguish between kdm of KDE and KDE2
* Wed Dec 13 2000 - werner@suse.de
- Use sessreg of xf86
  * set :<display>/<host> as line over tcpip for utmp/wtmp
- Allow horizontal scroll of XConsole
* Tue Dec 12 2000 - werner@suse.de
- New xterm-patches.tar.gz
  * xterm configuration
  + our app-defaults XTerm -> xterm-keybind.dif
  + keyboards, ansi color  -> xterm-simple.patch
  * suid/sgid switch patch   -> xterm-privilege.patch
  * Unicode patch seems to be obsolate
- Change spec because xterm.tar.gz is removed
- Add a secure sux script which avoid magic cookies on cmdline
* Tue Dec 12 2000 - sndirsch@suse.de
- replaced 'id -u' with 'echo $UID' in switch2xf86_glx
- corrected options for Fire GL1 board
* Mon Dec 11 2000 - werner@suse.de
- Fix sys.xsession (bug#4182)
- Sync sys.xsession with /etc/skel/.xsession
* Sat Dec 09 2000 - sndirsch@suse.de
- added root verification in switch2xf86_glx
* Thu Dec 07 2000 - ro@suse.de
- removed latin2.dif (broke all gtk applications)
* Tue Dec 05 2000 - sndirsch@suse.de
- adjusted spec file for 7.0-i386 via config-dist.sh
* Tue Dec 05 2000 - sndirsch@suse.de
- updated to release 4.0.1h (feature freeze!)
- adjusted sparc.dif + suse.dif + turkish.dif
- adjusted file list (libX11/libXmu are now version 6.2)
* Mon Dec 04 2000 - sndirsch@suse.de
- added latin2.dif of Jiri Smid <smid@suse.cz> (Bug #3831)
- removed Source glext.h (not required any more)
- disabled usb.dif except for PPC
- disabled DRI Support for PPC
- many changes for subpackage xf86glxd as package mesadev has changed
  a lot
* Sat Dec 02 2000 - sndirsch@suse.de
- added Euro entries for locale.alias (Werner's locale.awk does this)
* Thu Nov 30 2000 - sndirsch@suse.de
- reversed patch from Egbert of xf86Config.c (3.230 --> 3.231) as
  it ignores now completely the Modes section (xf86Config.dif)
- replaced obsolete usb with usbutils in #neeededforbuild line
- updated to release 4.0.1g
- removed xvfb.dif (already in 4.0.1g)
- minor changes in suse.dif (required for 4.0.1g)
- disabled Xftconfig.dif (libXft now uses Type1 instead of Truetype)
- added kde1 to wmlist
* Wed Nov 29 2000 - sndirsch@suse.de
- added /etc/X11/xkb/xkbcomp again to filelist (required to use
  XKB keymap)
* Mon Nov 27 2000 - sndirsch@suse.de
- added traditional Chinese Font Aliases for Netscape
- removed /etc/X11/xkb/xkbcomp executable from xf86 filelist
  (already in /usr/X11R6/bin)
- fixed update bug (empty /usr/X11R6/lib/xkb directory, should be a
  link to /etc/X11/xkb directory)
- added turkish keyboard support (turkish.dif)
* Mon Nov 27 2000 - schwab@suse.de
- Don't include <asm/io.h> on ia64.
* Fri Nov 24 2000 - sndirsch@suse.de
- added "-test" option for "switch2xf86_glx" skript
* Fri Nov 24 2000 - sndirsch@suse.de
- some corrections in fetchmsttfonts skript
* Thu Nov 23 2000 - sndirsch@suse.de
- moved GLw* manpages from xman --> xf86_glxd to remove conflicts
  between xman <--> mesadev
- added new files to filelist
* Thu Nov 23 2000 - sndirsch@suse.de
- added /usr/X11R6/bin/xf86debug to xf86 filelist
* Wed Nov 22 2000 - kukuk@suse.de
- Add pam_devperm to pam.d/xdm
- Add requires to pam_devperm
* Wed Nov 22 2000 - sndirsch@suse.de
- updated freetype2 library to final release 2.0
- fixed Wacom USB driver
* Tue Nov 21 2000 - sndirsch@suse.de
- updated to release 4.0.1f
- added wacomUSB driver
* Tue Nov 14 2000 - ro@suse.de
- don't remove "-traditional" but build makedepend without "-traditional"
* Tue Nov 14 2000 - ro@suse.de
- bump version to 4.0.1e
* Tue Nov 14 2000 - sndirsch@suse.de
- removed fonts.scale/fonts.dir in /usr/X11R6/lib/X11/fonts/CID
- added xf86debug skript to get easily gdb backtraces, if the
  X Server segfaults
* Tue Nov 14 2000 - ro@suse.de
- added patch to remove the "-traditional"
* Mon Nov 13 2000 - sndirsch@suse.de
- some changes to fetchmsttfonts skript, demanded by our legal
  department (Ole Weigel in this case)
* Wed Nov 08 2000 - sndirsch@suse.de
- added readlink function to switch2xf86_glx
- updated to release 4.0.1e
* Mon Nov 06 2000 - sndirsch@suse.de
- fixed switch2xf86-3x skript for PPC
- added Render fix for Xvfb (xvfb.dif)
* Sat Nov 04 2000 - kukuk@suse.de
- Remove wrong Requires.
- Remove duplicated SPARC patches
* Fri Nov 03 2000 - sndirsch@suse.de
- packages now provide also Redhat package names
- removed encodings.dir files from filelist
* Thu Nov 02 2000 - sndirsch@suse.de
- added usb.dif (removing of libusb.so* no longer necessary)
- defattr(-, root, root) added to all %%files sections,
  "-o root -g root" now not longer necessary for 'install'
* Mon Oct 30 2000 - sndirsch@suse.de
- updated to release 4.0.1d
- removed patches which are no longer required (glide.dif,
  geometry.dif, parts of sparc.dif)
- adjusted to S/390 architecture
- added %%triggerun/%%triggerpostun, adjusted %%post section of xf86
  package (the idea comes from nadvornik@suse.cz), so all %%ghost
  entries could be removed which caused trouble on our build machines
  as always /etc/X11/* was removed when the xf86 package was removed,
  although this was done for a chroot environment
* Fri Oct 27 2000 - ro@suse.de
- fixed freetype for alpha
* Sat Oct 14 2000 - sndirsch@suse.de
- updated to CVS release 20001014
- removed fixes.dif (already in CVS)
- added Freetype2 support
- xterm of official XFree86 tree is now used again (Freetype2 support)
- added glide.dif (small fix)
- adjusted file list for new binaries and libraries
- added xtermttf package
- added geometry.dif; Workaround for error message: "XtMakeGeometryRequest -
  parent not composite", which occurs e.g. when any buttons are pressed
  in gv or xfontsel
- added XftConfig file (required to use TT Fonts)
- added fetchmsttfonts (skript for fetching and installing MS Truetype Fonts)
- replaced readlink command in xf86version skript with a awk construct, as
  readlink is only available if tetex is installed
* Fri Oct 13 2000 - sndirsch@suse.de
- xf86version script replaced
- secure xserverrc file is now used for xinit/startx (aaa_skel package
  added to #neededforbuild for this); other users now won't be able
  to read from or write to DISPLAY any more
* Thu Oct 12 2000 - sndirsch@suse.de
- removed ppc.dif (not required any longer)
- added fixes.dif (small fixes required for PPC/AXP/Sparc)
* Fri Oct 06 2000 - sndirsch@suse.de
- updated to CVS release 20001003
- removed ia64.dif (already in CVS)
- some changes in drm.dif to enable i810 support for i386 machines
- xf86_glx package now no longer conflicts with other libGL
  packages, added switch2xf86_glx script for this
* Fri Sep 29 2000 - kukuk@suse.de
- Enable sparc patch
* Fri Sep 29 2000 - kukuk@suse.de
- Set version number to 4.0_20000924CVS (so we can update later)
- Add sparc.dif
- Fix filelist for SPARC
* Thu Sep 28 2000 - sndirsch@suse.de
- libOSMesa not available for Alpha + PPC
- libxrx not available for PPC
* Thu Sep 28 2000 - sndirsch@suse.de
- moved pixmaps from subpackage xdevel to subpackage xf86
- disabled DRM support for SiS chips
- added glext.h/glxext.h include files for OpenGL Development
  to subpackage xf86glxd
- added ppc.dif
* Mon Sep 25 2000 - sndirsch@suse.de
- added "#define BuildHtmlManPages NO" to host.def after
  installation (workaround)
* Wed Sep 20 2000 - sndirsch@suse.de
- updated to recent CVS sources 00-09-20 (Egbert has committed all
  patches in this version now)
- added ia64.dif and minor changes in Specfile for build on ia64
  of Andreas Schwab <schwab@suse.de>
* Tue Sep 19 2000 - sndirsch@suse.de
- added missing GLU/glut header files of mesadev
* Sun Sep 17 2000 - sndirsch@suse.de
- updated to recent CVS sources 00-09-14
- removed all patches, that are/will be included in the official
  xf86 CVS tree (Egbert is still working on this issue)
- TODO: PPC keyboard mapping
* Mon Sep 04 2000 - sndirsch@suse.de
- moved .so files to glxdev (no longer symbolic links)
* Tue Aug 29 2000 - ro@suse.de
- added arch-config for s390
* Thu Aug 03 2000 - sndirsch@suse.de
- marked some config files as %%config in filelist
- added security fixes and a bugfix for Vidmode Extension,
  from Egbert and Keith (auread_vmode.dif)
* Wed Aug 02 2000 - sndirsch@suse.de
- fixed authentication security hole introduced with 3.9Np (auth.dif)
* Wed Aug 02 2000 - werner@suse.de
- Fix bug within Xresources (bug# 3655)
* Fri Jul 21 2000 - kukuk@suse.de
- Add sun config files for xkbrules
* Fri Jul 21 2000 - sndirsch@suse.de
- added r128 patch from Egbert (fixes initialization of Rage 128
  chip; useful if a second server is started in another color depth,
  e.g. SaX2 and YaST2 do that!)
- minor change in Macintosh keyboard layout
- xdm bugfix: now xdm can also work with LANG variables which are
  unknown for X11 (e.g. german)
* Tue Jul 18 2000 - sndirsch@suse.de
- fixed reading of compressed xpm files (xpm.dif)
* Mon Jul 17 2000 - sndirsch@suse.de
- added macintosh_xkb_update.dif from Olaf
- added security fix (security.dif)
* Mon Jul 17 2000 - kendy@suse.cz
- added corr_noniso1_inp.diff (correctes broken input of non iso1 characters)
- added xkb-cs-40.dif (fixes xkb/symbols/cs and creates xkb/symbols/cs_qwerty)
* Tue Jul 11 2000 - sndirsch@suse.de
- removed dri.dif (replaced by eich.dif)
- added some bugfixes from Egbert Eich (eich.dif)
- added tdfx.dif (fixes the requirement for loading the dri module)
- disabled bigfonts
- replaced r128 driver of 4.0 with r128 driver of 4.0.1 (4.0 driver
  was totally broken!)
- added misc extension patch from Egbert Eich (miscext.dif) to enable
  the possibility to switch between serial mouse protocols (mouse
  initialization was missing)
- added format line for /etc/X11/CardModules
* Fri Jul 07 2000 - werner@suse.de
- Make xdm configuration better working together with gdm
  (we need to read our Xresources!)
* Mon Jul 03 2000 - sndirsch@suse.de
- added DGA mouse patch from Keith Packard (required for Q3 Arena!)
* Tue Jun 27 2000 - kukuk@suse.de
- Don't include framebuffer driver for SPARC
* Sun Jun 25 2000 - sndirsch@suse.de
- addded some more patches from Egbert Eich / Keith Packard
- addded OverridePolarity Option for "nvidia" driver
- added Compose Key Fix (missing Compose files)
- removed fbdev patches of eich_keitp.dif, which broke fbdev
  support completely
* Sat Jun 24 2000 - sndirsch@suse.de
- corrected dri.dif (required for empty DRI sections in XF86Config)
- changed SuSE entry in wmlist to DyDe
* Fri Jun 23 2000 - sndirsch@suse.de
- bugfix for xdm key bindings (Werner Fink)
- added xkill patch
- removed "Requires: sax2" from xloader package
* Tue Jun 20 2000 - sndirsch@suse.de
- removed DRI sources
- added eich_keithp patch
- removed patches already included in eich_keithp patches
  * dga_apm_rac.dif
  * videologic_xf86_40.dif
  * xdm.dif
- removed kernel-config (not required any more)
- adjusted mesa.dif
- added /usr/X11R6/bin/X symbolic link to /var/X11R6/bin/X
- moved /usr/X11R6/lib/lib*.so from xshared to xdevel, lib*.so.*
  still remains in xshared
* Sat Jun 17 2000 - sndirsch@suse.de
- removed '%%patch18'
* Fri Jun 16 2000 - sndirsch@suse.de
- added entry for Fire GL1 boards in /etc/X11/CardModules
- added Manual Pages for DGA, Misc and VidMode Extension
- added /var/X11R6/bin directory to xf86 package
* Mon Jun 12 2000 - ro@suse.de
- next try to fix greeter/Login.c :(
* Sun Jun 11 2000 - ro@suse.de
- really fixed xdm.dif to apply ...
* Sat Jun 10 2000 - ro@suse.de
- fixed xdm.dif
* Fri Jun 09 2000 - werner@suse.de
- Add missed "'s within defaultLoginTranslations of xdm
- New xterm version 136 (security fix included)
- Reenable GiveConsole and TakeConsole as
  GiveDevices and TakeDevices in SuSE's xdm configuration
* Wed Jun 07 2000 - sndirsch@suse.de
- added xkb-buffer_overflow.dif
- disabled Autoreqprov for xmodules, Provides/Requires are now
  manually set
- added /var/X11R6/xkb/compiled for 3.3.6 X Servers
* Tue Jun 06 2000 - kukuk@suse.de
- Add dummy Xmodmap for SPARC
* Sun Jun 04 2000 - sndirsch@suse.de
- added truetype font directory
- disabled creating of debug information for the static X11
  libraries (saves much space)
- outsourced DRM kernel modules stuff to package km_drm
- moved Xmodmap/Xmodmap.remote to /etc/X11 for FHS 2.1 compliance
* Fri Jun 02 2000 - sndirsch@suse.de
- added xf86version skript
- replaced "Alias:" lines in PAC files with "Obsoletes:" lines
  in Spec file
* Wed May 31 2000 - kukuk@suse.de
- sparc.dif update
* Tue May 30 2000 - sndirsch@suse.de
- added switch2xf86-3x/switch2xf86-4 skripts for switching between
  XFre86 3.3.6 and 4.0 (also used by YaST2)
- added option entry for "nvidia" driver
- added package 'xfiregl1' as Conflict with package 'xf86_glx'
* Sun May 28 2000 - sndirsch@suse.de
- DRI which comes with XFree86 4.0 is now used again
- added xfontsel to filelist (was missing in CVS DRI)
- moved xinit --> xinit4 and xf86config --> xf86config4, so that
  also xinit/xf86config of XFree86 3.3.X can be installed (package
  xf86_3x); xinit/xf86config (symbolic link) is created in %%post
  of xloader
- added Xsun* to possible X Servers for startx
* Thu May 25 2000 - werner@suse.de
- Fix xdm key binding, insert-char() only works for <Key> not
  <KeyPress> anymore.
- Install xdm.pamd as /etc/pam.d/xdm
- Define LIBDIR for making scripts xinitrc and startx
- Use default size for Xconsole (xdm configuration)
- Remove doubles in system Xresources
- don't apply basename to -- or `' in startx
- New driver_options.sh (minor changes:)
* Tue May 23 2000 - sndirsch@suse.de
- added skript for generating driver option list required for sax2,
  list (/etc/X11/CardModules) is included in package cardmods
- added some missing files to filelist
- Vidmode + DGA are now compiled also as shared libraries
* Mon May 22 2000 - sndirsch@suse.de
- added /usr/X11R6/bin/XFree86 as possible X Server for startx
* Fri May 19 2000 - werner@suse.de
- Make shared greeter lib compatible with PAM usage
- Make shared greeter lib work even on SystemV4
- Disable shared greeter lib by default for Linux
* Fri May 19 2000 - sndirsch@suse.de
- fixed secauth.dif
- some changes in config-dist.sh for other SuSE versions than
  libc5 and i386
- "#neededforbuild+=-lx_suse + lx_hack" required for DRI
- added package xf86glxd (include files and static lib for
  Mesa 3.3)
* Thu May 18 2000 - werner@suse.de
- Fix loaderProc.h header location
- Add secauth.dif
* Thu May 18 2000 - werner@suse.de
- Add more missed changes
- Extent mesa.dif
* Wed May 17 2000 - werner@suse.de
- `Backport' of most patches done for 3.3.X (suse.dif and xdm.dif)
  * security
  * bugs
  * changes and addons
- FHS-2.1 requires /var/lib/ and NOT /var/state/ (stupid, I know)
- Move wmlist and sux into suse.dif
- Add xditview into programs/Imakefile (suse.dif)
* Wed May 17 2000 - sndirsch@suse.de
- pre/post/postun for package xf86 rewritten
- added %%ghost for symbolic link files in /usr/X11R6/lib/X11
* Tue May 16 2000 - werner@suse.de
- Update XDM configuration tar file
- Use the Xresource file from above
* Fri May 12 2000 - schwab@suse.de
- Fix for ia64.
* Tue May 09 2000 - bs@suse.de
- fixed config.dist (BUILD_DIST is not set in autobuild mode)
* Mon May 08 2000 - sndirsch@suse.de
- removed Requires:glide from xmodules
- added Requires:ttmkfdir to xf86 (mkfontdir for Truetype Fonts)
- removed xf86_40 subpackage
* Sun May 07 2000 - sndirsch@suse.de
- removed /usr/X11R6/lib/libGL.a from xdevel (caused build of many
  OpenGL apps to fail)
- moved xf86config from xf86 -> xloader
- InternalMalloc is no longer used (this change is required for
  Loki's Erics Ultimate Solitaire)
- removed xf86misc and joystick patch
- added requires+=agpgart for xmodules (needed for i810)
* Sat May 06 2000 - kasal@suse.de
- removed /usr/X11R6/libz.a from xdevel (it caused xmame build to fail)
* Thu May 04 2000 - sndirsch@suse.de
- force building of static libraries in addition to shared
  libraries
- minor changes in filelists (xdevel/xf86_glx)
* Thu May 04 2000 - kukuk@suse.de
- prevent moving of app-defaults on "make install" by Makefiles
  generated by imake (imake_install.dif)
* Wed May 03 2000 - kukuk@suse.de
- Enable libxrx plugin on SPARC and PPC
* Tue May 02 2000 - sndirsch@suse.de
- changes in filelist of xmodules
- added config-dist.sh
* Tue May 02 2000 - sndirsch@suse.de
- app-defaults now in /usr/X11R6/lib/X11/app-defaults instead of
  /etc/X11/app-defaults
- corrected pos_stc_env.dif
* Fri Apr 28 2000 - sndirsch@suse.de
- added posix_stdc_env.dif patch (fixes problems with redefinition
  of wchar_t) of kasal@suse.de
- added xdm.dif patch of Egbert Eich
- added patch for Videologic Grafixstar 550 (CL-GD5464) of
  Egbert Eich
- added xf86_glx package (XFree86 4.X GLX driver)
* Thu Apr 27 2000 - sndirsch@suse.de
- added kde2 to wmlist
* Thu Apr 27 2000 - kukuk@suse.de
- fix to build on SPARC
* Wed Apr 26 2000 - sndirsch@suse.de
- corrected "%%ifarch axp" --> "%%ifarch alpha"
- some file list changes for PPC and Sparc
* Wed Apr 26 2000 - sndirsch@suse.de
- removed PEX fonts for AXP
- libglide2x.so module symbolic link only for i386
* Tue Apr 25 2000 - ro@suse.de
- restart on xf86-4.0 from BETA tree
* Fri Apr 14 2000 - sndirsch@suse.de
- workaround for possible compiler bug triggered in I128 X Server
* Wed Apr 12 2000 - werner@suse.de
- Integrate patch from Stefan Dirsch
* Wed Apr 12 2000 - werner@suse.de
- Fix BUG in input method handling to avoid SIGSEGV (aka Netscape
  Bus error) due call of local filter on destroyed window.
* Mon Apr 10 2000 - werner@suse.de
- Even more: reduce optimization for Callback.o and Destroy.o in
  libXt to help Netscape.
* Mon Apr 10 2000 - schwab@suse.de
- Fix 64 bit problems.
* Mon Apr 03 2000 - bk@suse.de
- filelist fix on s390(no x server or linkkit documentation on s390)
* Sun Apr 02 2000 - bk@suse.de
- add support for s390 and archs without Xservers or 3D support
* Tue Mar 28 2000 - sndirsch@suse.de
- X Server now uses vt07 also on PPC and Sparc (xdm config)
- added sawmill to wmlist
* Tue Mar 28 2000 - sndirsch@suse.de
- corrected install error for 'sux' script
* Mon Mar 27 2000 - sndirsch@suse.de
- changed the 'keycode 22' entry of Xmodmap
- added 'sux' script from Werner
* Mon Mar 27 2000 - ro@suse.de
- removed -mev6 for alpha
* Thu Mar 23 2000 - olh@suse.de
- add powerpc keycodes, should work now with ps/2 keyboards
  use "powerpcps2" instead of "pc104" on CHRP and PReP
* Tue Mar 21 2000 - sndirsch@suse.de
- integrated Harald Koenig's S3_TRIO_3D_2X patch
- added 'SuSE' to wmlist
* Thu Mar 16 2000 - olh@suse.de
- update pmac keycodes, should work now on usb and adb
* Wed Mar 08 2000 - werner@suse.de
- Remove O_EXCL open of Xauth files due ssh hold those files open
  (should be investigated more carefully!!)
- Add old patch for a backup
* Wed Mar 08 2000 - werner@suse.de
- Make `stop local display if the Xserver fails' working
* Tue Mar 07 2000 - werner@suse.de
- Remove keycode mapping for german users to global Xmodmap
- Add keycode mapping to de and de_CH xkb symbol table
* Tue Mar 07 2000 - sndirsch@suse.de
- fixed compile errors in xdmcp.c/wrapper.c
- added keycode mapping for german users to global Xmodmap
* Mon Mar 06 2000 - werner@suse.de
- Add Oclock patch from Keith Packard
- Avoid race on open ~/.Xauthority
- Add patch to stop local display if the Xserver fails to often.
- include sys/select.h in Xpoll.h if FD_SETSIZE is not defined
- grabWaiters in Xserver/dix/dispatch.c are 32 bit fields
- czech is cs_CZ.ISO8859-2 not cs_CS.ISO8859-2
- Avoid a few compiler warnings
- Reduce optimization for Callback.o and Destroy.o in libXt
  (may help for Motif applications like Netscape)
* Mon Mar 06 2000 - werner@suse.de
- Add some comments and README.security how to change Xaccess and
  how to enable XDMCP port for remote Xterminals.
* Sat Mar 04 2000 - werner@suse.de
- added some Fontpath entries to xf86config program and sample XF86Config
- minor changes in config-dist.sh/xf86.spec to build on SuSE 6.1/6.2
* Sat Mar 04 2000 - bk@suse.de
- fixed missing dependancy for an xterm:
  xf86:  Added Requires: xterm_program
  xterm: Added Provides: xterm_program
* Fri Mar 03 2000 - werner@suse.de
- Coloring xconsole for xdm
* Fri Mar 03 2000 - schwab@suse.de
- Add support for ia64
* Wed Mar 01 2000 - sndirsch@suse.de
- added Harald Koenig's S3 patch for IBM machines
* Tue Feb 29 2000 - kasal@suse.de
- xf86 should not require "fvwm" but "windowmanager" which is already
  provided by all(?) windowmanagers
* Tue Feb 22 2000 - sndirsch@suse.de
- enabled i810 support (was missing!)
- changed minor device number of agpgarti810 to 240
* Mon Feb 21 2000 - sndirsch@suse.de
- disabled 'Scanline Screen-To-Screen Color Expand' acceleration for
  now to fix font problem in Rage 128 driver
- added xfce windowmanager to 'wmlist'
* Tue Feb 15 2000 - sndirsch@suse.de
- minor bug fix in spec file required for archs other than i386
* Fri Feb 11 2000 - sndirsch@suse.de
- marked app-defaults for xterm as config files
- changed group tag to 'X11/XFree86'
- special 'old' agp module for i810 included again (changed module
  name and device name/numbers), i.e agpgarti810.o, /dev/agpgarti810 174 0
* Thu Feb 03 2000 - olh@suse.de
- add missing targets to xkbcomp symbols Imakefile
* Thu Feb 03 2000 - werner@suse.de
- XDM: Avoid graphical login if normal login is disabled
- XTerm: merge xterm.patch with main patch
* Wed Feb 02 2000 - sndirsch@suse.de
- new subpackage 'xterm', which will conflict with additional
  'xtermutf' package
* Mon Jan 24 2000 - ro@suse.de
- removed agpgart (module and node) from filelist
* Mon Jan 24 2000 - sndirsch@suse.de
- added more greek fonts (package xfntgr)
* Wed Jan 19 2000 - olh@suse.de
- first try of localized mac keyboards :)
* Wed Jan 19 2000 - uli@suse.de
- added plain vanilla Xpmac since Xpmac for Rage 128 won't run
  on old PowerMacs
* Wed Jan 19 2000 - uli@suse.de
- added accelerated servers Xpmac (w/Rage 128 support), Xbh for PPC
* Wed Jan 19 2000 - ro@suse.de
- commented out mknod in %%post section
* Tue Jan 18 2000 - kasal@suse.de
- fixed config-dist.sh to use XFree-3.3.6.dif
- repairing xf86MouseCflags -- affected both XFree-3.3.6{.dif,-sparc.diff}
- use %%{P:3} in specfile -- expands to pathname of Patch3
* Tue Jan 18 2000 - ro@suse.de
- fixed filelist for ppc
- added sparc-patch
* Tue Jan 18 2000 - ro@suse.de
- fixed to build on axp
* Mon Jan 17 2000 - ro@suse.de
- fixed to build on ppc
- fixed to build with DESTDIR
* Mon Jan 17 2000 - ro@suse.de
- specfile fix (agpgart need not be built for 2.3, it's in kernel)
* Sat Jan 15 2000 - ro@suse.de
- specfile changed to work around rpm-bug
* Sat Jan 15 2000 - ro@suse.de
- accept kernel-2.3
* Thu Jan 13 2000 - sndirsch@suse.de
- updated to XFree86 3.3.6 (Big Step!)
* Mon Dec 20 1999 - olh@suse.de
- remove Rage128 from ppc file list
  fix Xmodmap.ppc
* Thu Dec 16 1999 - ro@suse.de
- specfile fix
* Mon Dec 13 1999 - sndirsch@suse.de
- fixed Rage 128 support in SVGA server
- added missing README files for Mach32/Mach64/Riva128 chipsets
* Thu Dec 09 1999 - schwab@suse.de
- Fix xterm crash (missing bounds checking in Terminfo "ich")
* Thu Dec 09 1999 - ro@suse.de
- added link /usr/include/X11 to xdevel package
* Tue Dec 07 1999 - werner@suse.de
- XDM Xsession: Do NOT let overwrite HOME, DISPLAY, and XAUTHORITY
  even if set by /etc/profile and /etc/profile.d/*
- The same for sys.xsession
- Temporary remove Control_R from control modifier during the
  extension with Multi_key
* Wed Dec 01 1999 - uli@suse.de
- added PEX fonts for PPC
* Thu Nov 25 1999 - ms@suse.de
- fixed config-dist.sh
* Fri Nov 19 1999 - kukuk@suse.de
- Add patches for SPARC support
* Tue Nov 09 1999 - werner@suse.de
- Make xconsole smaller if root window is smaller
- undef macro linux for xdm Xresources
* Wed Nov 03 1999 - ro@suse.de
- don't try to build gart-module on non-x86
* Wed Nov 03 1999 - ro@suse.de
- install docs manually; needs to be fixed
* Wed Nov 03 1999 - ms@suse.de
- add xterm patch ( screen.c ) fixed tty get dimensions <werner@suse.de>
- fixed version number from xfcom patch
* Wed Nov 03 1999 - ms@suse.de
- added rage128 support to the SVGA server (XF86_SVGA)
- added i810 support as XFCom server ( package xi810 )
* Sun Oct 31 1999 - ro@suse.de
- added missing pci-ids
* Fri Oct 29 1999 - sndirsch@suse.de
  1509. Trio3D/2X fix and cleanup (#3344, Harald Koenig).
  1508. Fix ViRGE/MX and APM (#3345, Harald Koenig).
  1496. Fix ViRGE driver when starting the server with Linux fbdev enabled
  (#3304, Harald Koenig).
  1493. ATI driver: Rage XC & Rage XL fixes. Rage Mobility support.
  Disable TVOUT feature of 3D Rage (#3263,3312, Marc LaFrance,
  Christian Lupien).
  1491. Fix some problems that prevented use of acceleration on some
  chipsets
  with Trident driver (#3261, Harald Koenig)
  1488. Rage LCD: Fix determination of panel dimensions with older BIOS's.
  Fix panel display problems by ensuring 8-dot character clocks are
  always
  used (#3218, Marc LaFrance).
  1486. Better default memory size for MGA G400 cards (#3201, Matthias
  Scheler).
  1485. Update S3_Savage driver to fall back to traditional register
  setting
  when it encounters a mode not supported by the BIOS (#3198, Tim
  Roberts).
  1482. Extend XF86Setup/xf86config to handle multiple Cards files
  (Dirk Hohndel)
  1481. More SiS fixes (provided by SiS).
* Thu Oct 28 1999 - bs@suse.de
- cleaned neededforbuild.
* Sat Oct 16 1999 - bs@suse.de
- fixed neededforbuild
* Tue Oct 12 1999 - ro@suse.de
- completed tcl/tk switch: tcl/tk are now 8.0 versions
* Sat Oct 09 1999 - ro@suse.de
- specfile fix
* Sat Oct 09 1999 - ro@suse.de
- fixed typo in xconsole.c
* Fri Oct 08 1999 - werner@suse.de
- system Xmodmap's for  serveral architectures
* Thu Oct 07 1999 - werner@suse.de
- Fix the diff patch: No ../file.orig !
- Use -Tlaint1 for geqn and groff
- Use pic for a preprocessor for groff
- Enabel devpts for xconsole
- If available use /dev/xconsole for xconsole
* Wed Sep 29 1999 - sndirsch@suse.de
- fixed problems with localbuffer when using zbuffer/stencil/textures
  on some GLINT 500TX/MX boards
* Tue Sep 28 1999 - sndirsch@suse.de
- disabled PAM Code for Xwrapper to prevent the user being asked for
  his password when he starts the X Server. This must be fixed later
  in a better way ...
- groff is now executed with "-mandoc" and not any longer with "-man"
* Mon Sep 27 1999 - bs@suse.de
- fixed requirements for sub packages
* Mon Sep 20 1999 - ro@suse.de
- added Provides x_server for all servers
- added Requires x_server for x86
- added Requires c_preprocessor for xfsetup
* Thu Sep 16 1999 - sndirsch@suse.de
- bugfix for 3DLabs server (required for Permedia/GLINT boards)
* Mon Sep 13 1999 - bs@suse.de
- ran old prepare_spec on spec file to switch to new prepare_spec.
* Thu Sep 02 1999 - uli@suse.de
- preliminary PPC package
* Thu Sep 02 1999 - hohndel@suse.de
- xkbcomp security fix
* Fri Aug 27 1999 - hohndel@suse.de
- update to 3.3.5
- disable remote access to xdm
- add config-dist.sh for building without PAM
* Thu Jul 22 1999 - bs@suse.de
- added XFCom* and XBF* to list of X server for startx
* Tue Jul 20 1999 - hohndel@suse.de
- include a post-3.3.4 Rage LT fix
* Fri Jul 16 1999 - uli@suse.de
- wmlist: changed wmaker to windowmaker as requested by choeger
* Thu Jul 15 1999 - bs@suse.de
- used final version of 3.3.4 sources
- call Check after installation of fonts
* Tue Jul 13 1999 - kukuk@suse.de
- Add nullok to xdm.pamd
* Tue Jul 06 1999 - hohndel@suse.de
- update to XFree86-3.3.4
* Wed Jun 09 1999 - ro@suse.de
- turned off XdmAuth for Alpha: now xdm works
* Wed Jun 09 1999 - ro@suse.de
- xdm: no shared GreeterLib for Linux-Alpha
* Mon Jun 07 1999 - kukuk@suse.de
- Add PAM for Xwrapper and xdm
- xterm: Use /dev/pts
* Thu May 27 1999 - ro@suse.de
- programs/xterm/screen.c add trailing space for egcs on alpha
- programs/xdm/config/Imakefile use DEFAULTVT on alpha as well
* Tue May 25 1999 - werner@suse.de
- Set xdm's Xsetup*, *Console and Log* to %%config
* Tue May 18 1999 - ro@suse.de
- added subpackage: xtga: DEC TGA Xserver
* Tue Apr 27 1999 - werner@suse.de
- Small fix in Backarrow2Delete and Backarrow2BackSpace script
* Thu Apr 15 1999 - werner@suse.de
- Add font aliases for international fonts (aka MULE fonts)
* Wed Apr 14 1999 - hohndel@suse.de
- add Greek fonts package
* Mon Apr 12 1999 - ro@suse.de
- added line for indonesian to locale.alias
* Sun Mar 28 1999 - hohndel@suse.de
- fix security problems with /tmp/.X11-unix
- don't use lx_hack for build.
* Fri Mar 26 1999 - ro@suse.de
- removed link XFCom_SIS
* Wed Mar 24 1999 - ro@suse.de
- p9x00: disabled DPMS extension which broke several cards
  (hohndel@XFree86.org 990324)
* Wed Mar 17 1999 - werner@suse.de
- Integrate extra.patch in our dif file
- Fix a change in verify.c of xdm
- Sort patches
* Wed Mar 17 1999 - ro@suse.de
- added post-3.3.3.1 diff (removed rcs-hunks before)
* Tue Mar 09 1999 - werner@suse.de
- Make xf86config and XF86Setup using URW font link of the
  Type1 fonts of ghostscript
- Make comments in GiveConsole/TakeConsole/LogOn/LogOff clear for
  everyone.
- Avoid double Translations settings in globale Xresources
- Enabel account locking of the shadow package
* Fri Mar 05 1999 - ro@suse.de
- linux.cf: use -Wa,-mev6 on alpha to be able to compile jays patch
* Thu Mar 04 1999 - ro@suse.de
- finally added jay's patch for alpha's
* Fri Jan 29 1999 - ro@suse.de
- added neccessary alpha modifications (in ifarch)
- dont define XXXArchitecture in host.def (done elsewhere)
- use tcl/tk 8.0
* Mon Jan 18 1999 - bs@suse.de
- set version to 3.3.3.1
* Tue Jan 12 1999 - werner@suse.de
- Within GiveConsole and LogOn use RUID=`id -ur $USER` instead of
  UID because $USER is set by xdm/xlogin.
- Add patch 3.3.3.1 to Makefile.Linux
* Mon Jan 11 1999 - hohndel@suse.de
- add i740 cards to Cards file again
* Fri Jan 08 1999 - bs@suse.de
- now ROOT_LOGIN_REMOTE works in all cases :)
* Fri Jan 08 1999 - bs@suse.de
- another try to fix ROOT_LOGIN_REMOTE
* Thu Jan 07 1999 - hohndel@suse.de
- fix missing files for LinkKit
- fixed problem in xdm if ROOT_LOGIN_REMOTE is not set
* Tue Jan 05 1999 - hohndel@suse.de
- merge XFree86-3.3.3.1
* Tue Dec 22 1998 - werner@suse.de
- one liner fix in programs/xdm/config/Xsetup_default
* Mon Dec 14 1998 - bs@suse.de
- sys.xsession: check for PROFILEAD before parsing /etc/profile.
* Mon Dec 14 1998 - bs@suse.de
- added Haralds patch for s3v (StarOffice 5.0 lockup)
* Sat Dec 12 1998 - bs@suse.de
- minor fix in startx
* Fri Dec 11 1998 - bs@suse.de
- removed "-quiet" for starting the X server with xdm
* Wed Dec 09 1998 - bs@suse.de
- added some cards from CDB to Cards for XF86Setup
- added symlinks for xglint and svga server
- added patches to startx and wmlist (from maddin)
* Wed Dec 02 1998 - hohndel@suse.de
- re-add XF86_FBDev server to build process
* Wed Dec 02 1998 - hohndel@suse.de
- once again, merge things
* Tue Dec 01 1998 - werner@suse.de
- Simple security patch for LogOn for foreign roots
  (using /etc/rc.config)
- Remove -fno-force-mem
* Tue Dec 01 1998 - hohndel@suse.de
- add handling of /usr/X11R6/lib/X11/fonts/local
- add xfbdev package
* Mon Nov 30 1998 - hohndel@suse.de
- add XF86_FBDev server
- fix sad bug in XF86_3DLabs
* Sat Nov 28 1998 - hohndel@suse.de
- merge the omitted changes back in
* Fri Nov 27 1998 - bs@suse.de
- fixed file list.
* Fri Nov 27 1998 - hohndel@suse.de
- import XFree86-3.3.3
* Tue Nov 03 1998 - werner@suse.de
- Don't pack /var/run/xdm.pid into the rpm
- Touch /var/log/xdm.error
* Fri Oct 30 1998 - werner@suse.de
- Fix a bug in Xsession
- Add local display handling in LogOn, LogOff, ans Xsetup_default
- Move /var/lib/xdm/xdm-pid to /var/run/xdm.pid
  and set a link from /var/run/xdm.pid to /var/lib/xdm/xdm-pid
- Move /var/lib/xdm/xdm-errors to /var/log/xdm.errors
  and set a link from /var/log/xdm.errors to /var/lib/xdm/xdm-errors
- Add some *Text*Translations for Delete in
  /usr/X11R6/lib/X11/xinit/Xresources
  to get delete-next-character() working on the (most) X programs
* Fri Aug 28 1998 - werner@suse.de
- Add Dirks patch for vgaPCI.c which removes `-quiet' kludge
* Wed Jul 29 1998 - werner@suse.de
- Link X11 libs explicit with libc
- Close sockets of a running chooser in xdm
* Fri Jul 24 1998 - bs@suse.de
- added /usr/X11R6/bin/wmlist to file list.
* Wed Jul 22 1998 - werner@suse.de
- typo fix
* Mon Jul 20 1998 - werner@suse.de
- remove unnecessary undef of TIOCSLTC ... handelt now by HAS_LTCHARS
- use mktemp in gccmakedep if avaliable
- set XFree86Version to 3323
* Mon Jul 20 1998 - hohndel@suse.de
- fixed patch section.
* Sun Jul 19 1998 - hohndel@suse.de
- add preliminary patch 3 (XFree86-3.3.2.3)
- update dif file accordingly
* Wed Jul 15 1998 - hohndel@suse.de
- Fix one small rej case
- Make internal some variables of Xsession readonly
- Use wmlist in startx
* Wed Jul 15 1998 - hohndel@suse.de
- add fix for Riva128 IRQ problem
- add support for XFCom servers to xf86config
- add support for /etc/X11/X in xf86config
* Fri Jul 10 1998 - werner@suse.de
- Make Xsession `user save' ... protect, restore, and (re)set
  system variables to make Xsession mostly work.
* Thu Jul 09 1998 - werner@suse.de
- Add wmlist
* Fri Jul 03 1998 - werner@suse.de
- Small fix in xdm scripts
* Wed Jul 01 1998 - werner@suse.de
- Change to official 3.3.2-patch2 and remove an oneliner out of
  our dif (this on is included in the official 3.3.2-patch2).
- Change Backarrow key handling of xterm to an Xresource and add two
  scripts Backarrow2Delete and Backarrow2BackSpace for switching
  between the two possibilities. Note: Default is Backarrow2Delete!
- Security fix against existing temporary files of gccmdep.cpp and
  mergelib.cpp.  Add a check against tmp1//tmp2 for mkdirhier.sh
- Set sticky bit for /tmp/.X11-unix/ in lib/xtrans/Xtranssock.c
- Security fix against existing temporary files of x11pcomp.cpp.
- Fix segfault of xauth
- Add load message for chooser instead of "Willing to manage"
- Update xdm scripts
- Add new xdm scripts
- Add patch for xf86config.c (handle more than 10 modes)
- Add a minimal host.def.inst for installation
- Fix common in programs/xkbevd/cfgscan.c
- Set XFree86Version to 3322
- Refresh file lists in spec file
- ToDo: FHS for S.u.S.E. 6.0
* Mon Jun 29 1998 - ro@suse.de
- added patch from Dirk for mga hw-cursor
- added patch from Harald for S3/S3V fixes
* Sat Jun 27 1998 - bs@suse.de
- added creation of /var/lib/xdm in install section.
* Mon Jun 15 1998 - ro@suse.de
- switched back to use /lib/cpp
* Fri Jun 12 1998 - ro@suse.de
- changed xfree86/os_support/linux/lnx_jstk.c to be able to
  compile with 2.1.105:
  used v 3.12 from recent src-tree
  disabled timeout set and get if these controls are undefined
- removed Cards.orig from diff (no need to double the length on every
  diff-generation)
* Thu Jun 04 1998 - werner@suse.de
- Few changes for egcs and glibc
- Tidey ip some settings in host.cf
- ToDo: FHS
* Mon May 25 1998 - werner@suse.de
- Incooperate security patch 3.3.2-patch2
- Remove some patches of S.u.S.E. for Xdmcp
  (now included in 3.3.2-patch2)
* Fri May 15 1998 - werner@suse.de
- don't install xload with suid bit
* Tue May 05 1998 - werner@suse.de
- Incooperate security patch 3.3.2-patch1 as *extern* patch
  *Note*: the take&drop patch for xterm is also included
  because with Linux the IDs will be saved (SysV/POSIX)
* Thu Apr 30 1998 - werner@suse.de
- Fix for Xaw security leak in xterm (take and drop root privilege)
- Fix for libXdmcp
- Fix for choose.c of xdm
* Mon Mar 23 1998 - sndirsch@suse.de
  Patch from Harald Koenig:
- The XFree86 3.3.2 s3_svga driver has a small bug which doesn't allow
  `newmmio' access for S3 Trio64V2 chips.
- This causes the same lockups for LX based main baords with S3 Trio64V2
  cards as the S3 server shows too.  The following patch should fix the
  problem (plus a small cosmetic patch for S3 server allowing newmmio
  for S3 Aurora64V+ to o by default).
* Fri Mar 06 1998 - sndirsch@suse.de
- adjusted Cards file in xf86 and TCL scripts in xfsetup for
  GLINT/PERMEDIA/PERMEDIA-2 cards
* Tue Mar 03 1998 - hohndel@suse.de
- update to final XFree86-3.3.2 sources
* Tue Mar 03 1998 - ro@suse.de
- pack everything below lib/XF86Setup into xfsetup package
* Mon Mar 02 1998 - ro@suse.de
- include xload in xf86 / include xload.1 in xman
* Sat Feb 28 1998 - hohndel@suse.de
- re-enabled showfont
- added Xwrapper
- added README.mouse and README.apm
- updated to XFree86-3.3.1z
* Sat Feb 14 1998 - bs@suse.de
- disabled include of /usr/bin/showfont (will be fixed next week).
- skipped some files in xlkit package (will be fixed next week).
* Mon Feb 09 1998 - hohndel@suse.de
- update to XFree86-3.3.1c
* Thu Jan 08 1998 - hohndel@suse.de
- Add support for XSuSE_Matrox
* Sat Dec 06 1997 - hohndel@suse.de
- both XF86Setup and xf86config can now handle the XSuSE servers
- added support for XSuSE_Trident to both programs
- added selection of modes and default color depth to XF86Setup
* Tue Nov 18 1997 - ro@suse.de
- xf86config uses the new cards-file "CardsXSuSE"
  and xf86Setup uses cards-file "Cards"
* Sat Nov 15 1997 - hohndel@suse.de
- added Support for XSuSE_Matrox to XFree86 Setup.
* Wed Nov 12 1997 - ro@suse.de
- fixed link /usr/X11R6/bin/X to /var/X11R6/bin/X in specfile
* Mon Nov 10 1997 - bs@suse.de
- added patches for kdm (Xsession & Xsetup_0)
* Mon Nov 10 1997 - ro@suse.de
- fix two uninitialized variables
* Sun Nov 02 1997 - hohndel@suse.de
- fix error in Cards file
- fix bug in xf86config that was triggered by the bug above
* Sun Oct 26 1997 - hohndel@suse.de
- fixed startx to accept our XSuSE servers as well
- updated xf86config
- fixed install problem with cf and rules files
* Sun Oct 19 1997 - bs@suse.de
- added Dirks patch for xf86config (new SuSE server included)
* Fri Oct 10 1997 - ro@suse.de
- specfile generated -- almost ready for autobuild
* Fri Aug 22 1997 - hohndel@suse.de
- recompile all the binaries without -fexpensive-optimizations
* Thu Aug 07 1997 - hohndel@suse.de
- fix problem with creating xkb temp file in /var/X11R6/xkb/compiled
- fix douplicate docs and as a consequence remove xdoc from the
  dependencies of xf86setup
* Tue Aug 05 1997 - hohndel@suse.de
- XFree86-3.3.1 Binaries
- Experimental Matrox Millennium II support
- Fixed locale problem
- added latin2 fonts
- most known bugs fixed in the servers
- fixed wrong path in proxy manager config
- fixed problem with mounting /usr readonly
- changed linux.cf to set BinUtilsMajorVersion to 27 by default
* Mon Jun 23 1997 - hohndel@suse.de
- fix some minor bugs in some of the servers
* Fri Jun 13 1997 - hohndel@suse.de
  minor fixes
- some fixes for cirrus clock limits
- fixes for S3V hangs
- more servers support DacSpeed for higher bpp
- fix for I128 server
- some build fixes in preparation for -D_REENTRANT
* Tue Jun 03 1997 - hohndel@suse.de
  new version 3.3
* Sat Apr 26 1997 - bs@suse.de
  xlkit.tgz
  xdevel.tgz    - fixed target step in Imake.rules
